searchNodes=[{"type":"task","title":"Mix.Tasks.Scenic.Run","doc":"Starts the application The --no-halt flag is automatically added.","ref":"Mix.Tasks.Scenic.Run.html"},{"type":"module","title":"Scenic","doc":"The Scenic module itself is a supervisor that manages all the machinery that makes the Scenes , ViewPorts , and Drivers run. In order to run any Scenic application, you will need to start the Scenic supervisor in your supervision tree. Load a configuration for one or more ViewPorts, then add Scenic to your root supervisor. defmodule MyApp do def start ( _type , _args ) do import Supervisor.Spec , warn : false # load the viewport configuration from config main_viewport_config = Application . get_env ( :my_app :viewport ) # start the application with the viewport children = [ supervisor ( Scenic , [ viewports : [ main_viewport_config ] ] ) , ] Supervisor . start_link ( children , strategy : :one_for_one ) end end Note that you can start the Scenic supervisor without any ViewPort Configurations. In that case, you are responsible for supervising the ViewPorts yourself. This is not recommended for devices as Scenic should know how to restart the main ViewPort in the event of an error.","ref":"Scenic.html"},{"type":"function","title":"Scenic.version/0","doc":"Return the current version of scenic","ref":"Scenic.html#version/0"},{"type":"module","title":"Scenic.Color","doc":"APIs to create and work with colors. Colors are used in multiple places in Scenic. Fills and Strokes of a single color are quite common. Data Format There are multiple ways to define colors. The native format of color on modern computers is RGBA. This is four channels including Red, Green, Blue, and Alpha. Alpha indicates transparency, and is used to blend the color being applied at any given location with the color that is already there. Most of the time, you will use one of the pre-defined named colors from the Named Colors table. However, there are times when you want to work with other color formats ranging from simple grayscale to rgb to hsl. The following formats are all supported by the Scenic.Color module. The values of r, g, b, and a are integers between 0 and 255. For HSL and HSV, h is a float between 0 and 360, while the s, v and l values are floats between 0 and 100. Format Implicit Explicit Named Color na See the Named Color Table Grayscale g {:color_g, g} Gray, Alpha {g, a} {:color_ga, {g, a}} Red, Green, Blue {r, g, b} {:color_rgb, {r, g, b}} Red, Green, Blue, Alpha {r, g, b, a} {:color_rgba, {r, g, b, a}} Hue, Saturation, Value na {:color_hsv, {h, s, v}} Hue, Saturation, Lightness na {:color_hsl, {h, s, l}} Named Colors The simplest is to used a named color (see the table below). Named colors are simply referred to by an atom, which is their name. Named colors are opaque by default. I failed to figure out how to show a table with colored cells in exdoc. So this is a list of all the color names. I'll eventually add a link to a page that shows them visually. [:alice_blue, :antique_white, :aqua, :aquamarine, :azure, :beige, :bisque, :black, :blanched_almond, :blue, :blue_violet, :brown, :burly_wood, :cadet_blue, :chartreuse, :chocolate, :coral, :cornflower_blue, :cornsilk, :crimson, :cyan, :dark_blue, :dark_cyan, :dark_golden_rod, :dark_gray, :dark_green, :dark_grey, :dark_khaki, :dark_magenta, :dark_olive_green, :dark_orange, :dark_orchid, :dark_red, :dark_salmon, :dark_sea_green, :dark_slate_blue, :dark_slate_gray, :dark_slate_grey, :dark_turquoise, :dark_violet, :deep_pink, :deep_sky_blue, :dim_gray, :dim_grey, :dodger_blue, :fire_brick, :floral_white, :forest_green, :fuchsia, :gainsboro, :ghost_white, :gold, :golden_rod, :gray, :green, :green_yellow, :grey, :honey_dew, :hot_pink, :indian_red, :indigo, :ivory, :khaki, :lavender, :lavender_blush, :lawn_green, :lemon_chiffon, :light_blue, :light_coral, :light_cyan, :light_golden_rod, :light_golden_rod_yellow, :light_gray, :light_green, :light_grey, :light_pink, :light_salmon, :light_sea_green, :light_sky_blue, :light_slate_gray, :light_slate_grey, :light_steel_blue, :light_yellow, :lime, :lime_green, :linen, :magenta, :maroon, :medium_aqua_marine, :medium_blue, :medium_orchid, :medium_purple, :medium_sea_green, :medium_slate_blue, :medium_spring_green, :medium_turquoise, :medium_violet_red, :midnight_blue, :mint_cream, :misty_rose, :moccasin, :navajo_white, :navy, :old_lace, :olive, :olive_drab, :orange, :orange_red, :orchid, :pale_golden_rod, :pale_green, :pale_turquoise, :pale_violet_red, :papaya_whip, :peach_puff, :peru, :pink, :plum, :powder_blue, :purple, :rebecca_purple, :red, :rosy_brown, :royal_blue, :saddle_brown, :salmon, :sandy_brown, :sea_green, :sea_shell, :sienna, :silver, :sky_blue, :slate_blue, :slate_gray, :slate_grey, :snow, :spring_green, :steel_blue, :tan, :teal, :thistle, :tomato, :turquoise, :violet, :wheat, :white, :white_smoke, :yellow, :yellow_green] Additional Named Colors Name Value :clear {0x80, 0x80, 0x80, 0x00} :transparent {0x80, 0x80, 0x80, 0x00} Converting Between Color Formats By using the functions to_g/1 , to_ga/1 , to_rgb/1 , to_rgb/1 , to_hsl/1 , and to_hsv/1 you can convert between any implicit or explicit color type to any explicit color type.","ref":"Scenic.Color.html"},{"type":"function","title":"Scenic.Color.named/0","doc":"Return map of all named colors and their values","ref":"Scenic.Color.html#named/0"},{"type":"function","title":"Scenic.Color.to_g/1","doc":"Convert a specified color to G format (just grayscale) This is a lossy conversion and will lose any color information other than the gray level.","ref":"Scenic.Color.html#to_g/1"},{"type":"function","title":"Scenic.Color.to_ga/1","doc":"Convert a specified color to GA format","ref":"Scenic.Color.html#to_ga/1"},{"type":"function","title":"Scenic.Color.to_hsl/1","doc":"Convert a color to the HSL color space","ref":"Scenic.Color.html#to_hsl/1"},{"type":"function","title":"Scenic.Color.to_hsv/1","doc":"Convert a color to the HSV color space","ref":"Scenic.Color.html#to_hsv/1"},{"type":"function","title":"Scenic.Color.to_rgb/1","doc":"Convert a specified color to RGB format","ref":"Scenic.Color.html#to_rgb/1"},{"type":"function","title":"Scenic.Color.to_rgba/1","doc":"Convert a specified color to RGBA format","ref":"Scenic.Color.html#to_rgba/1"},{"type":"type","title":"Scenic.Color.explicit/0","doc":"","ref":"Scenic.Color.html#t:explicit/0"},{"type":"type","title":"Scenic.Color.g/0","doc":"","ref":"Scenic.Color.html#t:g/0"},{"type":"type","title":"Scenic.Color.ga/0","doc":"","ref":"Scenic.Color.html#t:ga/0"},{"type":"type","title":"Scenic.Color.hsl/0","doc":"","ref":"Scenic.Color.html#t:hsl/0"},{"type":"type","title":"Scenic.Color.hsv/0","doc":"","ref":"Scenic.Color.html#t:hsv/0"},{"type":"type","title":"Scenic.Color.implicit/0","doc":"","ref":"Scenic.Color.html#t:implicit/0"},{"type":"type","title":"Scenic.Color.rgb/0","doc":"","ref":"Scenic.Color.html#t:rgb/0"},{"type":"type","title":"Scenic.Color.rgba/0","doc":"","ref":"Scenic.Color.html#t:rgba/0"},{"type":"type","title":"Scenic.Color.t/0","doc":"","ref":"Scenic.Color.html#t:t/0"},{"type":"module","title":"Scenic.Components","doc":"About Components Components are small scenes that are managed, by another scene. They are useful for reusing bits of UI and containing the logic that runs them. Helper Functions This module contains a set of helper functions to make it easy to add, or modify, the standard components. In general, each helper function is of the form: def name_of_component ( graph , data , options \\\\ [ ] ) Unlike primitives, components are scenes in themselves. Each component is run by a GenServer and adding a basic component does two things. A new component GenServer is started and supervised by the owning scene's dynamic scene supervisor. A reference to the new scene is added to the graph. This doesn't happen all at once. These helper functions simply add a reference to a to-be-started component to your graph. When you push a graph, the ViewPort then manages the life cycle of the components. When adding components to a graph, each helper function accepts a graph as the first parameter and returns the transformed graph. This makes is very easy to build a complex graph by piping helper functions together. @graph Graph . build ( ) |&gt; button ( &quot;Press Me&quot; , id : :sample_button ) When modifying a graph, you can again use the helpers by passing in the component to be modified. The transformed component will be returned. Graph . modify ( graph , :sample_button , fn ( p ) -&gt; button ( p , &quot;Continue&quot; ) end ) # or, more compactly... Graph . modify ( graph , :sample_button , &amp; button ( &amp;1 , &quot;Continue&quot; ) ) In each case, the second parameter is a data term that is specific to the component being acted on. See the documentation below. If you pass in invalid data for the second parameter an error will be thrown along with some explanation of what it expected. The third parameter is a keyword list of options that are to be applied to the component. This includes setting the id, styles, transforms and such. @graph Graph . build ( ) |&gt; button ( &quot;Press Me&quot; , id : :sample_button , rotate : 0.4 )","ref":"Scenic.Components.html"},{"type":"function","title":"Scenic.Components.button/3","doc":"Add a Button to a graph A button is a small scene that is pretty much just some text drawn over a rounded rectangle. The button scene contains logic to detect when the button is pressed, tracks it as the pointer moves around, and when it is released. Data title title - a bitstring describing the text to show in the button Messages If a button press is successful, it sends an event message to the host scene in the form of: { :click , id } Styles Buttons honor the following standard styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :primary Additional Styles Buttons honor the following list of additional styles. :width - pass in a number to set the width of the button. :height - pass in a number to set the height of the button. :radius - pass in a number to set the radius of the button's rounded rectangle. :alignment - set the alignment of the text inside the button. Can be one of :left, :right, :center . The default is :center . :button_font_size - the size of the font in the button Buttons do not use the inherited :font_size style as they should look consistent regardless of what size the surrounding text is. Theme Buttons work well with the following predefined themes: :primary , :secondary , :success , :danger , :warning , :info , :text , :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text in the button :background - the normal background of the button :active - the background while the button is pressed Examples The following example creates a simple button and positions it on the screen. graph |&gt; button ( &quot;Example&quot; , id : :button_id , translate : { 20 , 20 } ) The next example makes the same button as before, but colors it as a warning button. See the options list above for more details. graph |&gt; button ( &quot;Example&quot; , id : :button_id , translate : { 20 , 20 } , theme : :warning )","ref":"Scenic.Components.html#button/3"},{"type":"function","title":"Scenic.Components.button_spec/2","doc":"Generate an uninstantiated button spec, parallel to the concept of primitive specs. This allows buttons to be treated as data.","ref":"Scenic.Components.html#button_spec/2"},{"type":"function","title":"Scenic.Components.checkbox/3","doc":"Add a Checkbox to a graph Data {text, checked?} text - must be a bitstring checked? - must be a boolean and indicates if the checkbox is set. Messages When the state of the checkbox changes, it sends an event message to the parent scene in the form of: {:value_changed, id, checked?} Styles Buttons honor the following standard styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Theme Checkboxes work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text in the button :background - the background of the box :border - the border of the box :active - the border of the box while the button is pressed :thumb - the color of the check mark itself Examples The following example creates a checkbox and positions it on the screen. graph |&gt; checkbox ( { &quot;Example&quot; , true } , id : :checkbox_id , translate : { 20 , 20 } )","ref":"Scenic.Components.html#checkbox/3"},{"type":"function","title":"Scenic.Components.checkbox_spec/2","doc":"Generate an uninstantiated checkbox spec, parallel to the concept of primitive specs. See Components.checkbox for data and options values.","ref":"Scenic.Components.html#checkbox_spec/2"},{"type":"function","title":"Scenic.Components.dropdown/3","doc":"Add a Dropdown to a graph Data {items, initial_id} items - must be a list of items, each of which is: {text, id} . See below... initial_item - the id of the initial selected item. It can be any term you want, however it must be an item_id in the items list. See below. Per item data: {text, item_id} text - a string that will be shown in the dropdown. item_id - any term you want. It will identify the item that is currently selected in the dropdown and will be passed back to you during event messages. Messages When the state of the Dropdown changes, it sends an event message to the host scene in the form of: {:value_changed, id, selected_item_id} Options Dropdown honors the following list of options. Styles Buttons honor the following styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Additional Styles Buttons honor the following list of additional styles. :width - pass in a number to set the width of the button. :height - pass in a number to set the height of the button. :direction - what direction should the menu drop. Can be either :down or :up . The default is :down . Theme Dropdowns work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text :background - the background of the component :border - the border of the component :active - the background of selected item in the dropdown list :thumb - the color of the item being hovered over Examples The following example creates a dropdown and positions it on the screen. graph |&gt; dropdown ( { [ { &quot;Dashboard&quot; , :dashboard } , { &quot;Controls&quot; , :controls } , { &quot;Primitives&quot; , :primitives } ] , :controls } , id : :dropdown_id , translate : { 20 , 20 } )","ref":"Scenic.Components.html#dropdown/3"},{"type":"function","title":"Scenic.Components.dropdown_spec/2","doc":"Generate an uninstantiated dropdown spec, parallel to the concept of primitive specs. See Components.dropdown for data and options values.","ref":"Scenic.Components.html#dropdown_spec/2"},{"type":"function","title":"Scenic.Components.radio_group/3","doc":"Add a RadioGroup to a graph Data {radio_buttons, selected_id} radio_buttons must be a list of radio button data. See below. Radio button data: {text, radio_id} text - must be a bitstring radio_id - can be any term you want. It will be passed back to you as the group's value. Messages When the state of the radio group changes, it sends an event message to the host scene in the form of: {:value_changed, id, radio_id} Options Radio Buttons honor the following list of options. :theme - This sets the color scheme of the button. This can be one of pre-defined button schemes :light , :dark , or it can be a completely custom scheme like this: {text_color, box_background, border_color, pressed_color, checkmark_color} . Styles Radio Buttons honor the following styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Theme Radio buttons work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text :background - the background of the component :border - the border of the component :active - the background of the circle while the button is pressed :thumb - the color of inner selected-mark Examples The following example creates a radio group and positions it on the screen. graph |&gt; radio_group ( [ { { &quot;Radio A&quot; , :radio_a } , { &quot;Radio B&quot; , :radio_b } , { &quot;Radio C&quot; , :radio_c } , ] , :radio_b } , id : :radio_group , translate : { 20 , 20 } )","ref":"Scenic.Components.html#radio_group/3"},{"type":"function","title":"Scenic.Components.radio_group_spec/2","doc":"Generate an uninstantiated radio_group spec, parallel to the concept of primitive specs. See Components.radio_group for data and options values.","ref":"Scenic.Components.html#radio_group_spec/2"},{"type":"function","title":"Scenic.Components.slider/3","doc":"Add a Slider to a graph Data { extents, initial_value} extents gives the range of values. It can take several forms... {min, max} If min and max are integers, then the slider value will be an integer. {min, max} If min and max are floats, then the slider value will be an float. [a, b, c] A list of terms. The value will be one of the terms initial_value Sets the initial value (and position) of the slider. It must make sense with the extents you passed in. Messages When the state of the slider changes, it sends an event message to the host scene in the form of: {:value_changed, id, value} Options Sliders honor the following list of options. Styles Sliders honor the following styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Theme Sliders work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :border - the color of the slider line :thumb - the color of slider thumb Examples The following example creates a numeric slider and positions it on the screen. graph |&gt; slider ( { { 0 , 100 } , 0 } , id : :num_slider , translate : { 20 , 20 } ) The following example creates a list slider and positions it on the screen. graph |&gt; slider ( { [ :white , :cornflower_blue , :green , :chartreuse ] , :cornflower_blue } , id : :slider_id , translate : { 20 , 20 } )","ref":"Scenic.Components.html#slider/3"},{"type":"function","title":"Scenic.Components.slider_spec/2","doc":"Generate an uninstantiated slider spec, parallel to the concept of primitive specs. See Components.slider for data and options values.","ref":"Scenic.Components.html#slider_spec/2"},{"type":"function","title":"Scenic.Components.text_field/3","doc":"Add a TextField input to a graph Data initial_value initial_value - is the string that will be the starting value Messages When the text in the field changes, it sends an event message to the host scene in the form of: {:value_changed, id, value} Styles Text fields honor the following styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Additional Styles Text fields honor the following list of additional styles. :filter - Adding a filter option restricts which characters can be entered into the text_field component. The value of filter can be one of: :all - Accept all characters. This is the default :number - Any characters from &quot;0123456789.,&quot; &quot;filter_string&quot; - Pass in a string containing all the characters you will accept function/1 - Pass in an anonymous function. The single parameter will be the character to be filtered. Return true or false to keep or reject it. :hint - A string that will be shown (greyed out) when the entered value of the component is empty. :type - Can be one of the following options: :all - Show all characters. This is the default. :password - Display a string of '*' characters instead of the value. :width - set the width of the control. Theme Text fields work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text :background - the background of the component :border - the border of the component :focus - the border while the component has focus Examples graph |&gt; text_field ( &quot;Sample Text&quot; , id : :text_id , translate : { 20 , 20 } ) graph |&gt; text_field ( &quot;&quot; , id : :pass_id , type : :password , hint : &quot;Enter password&quot; , translate : { 20 , 20 } )","ref":"Scenic.Components.html#text_field/3"},{"type":"function","title":"Scenic.Components.text_field_spec/2","doc":"Generate an uninstantiated text_field spec, parallel to the concept of primitive specs. See Components.text_field for data and options values.","ref":"Scenic.Components.html#text_field_spec/2"},{"type":"function","title":"Scenic.Components.toggle/3","doc":"Add Toggle to a Scenic graph. Data on? on? - true if the toggle is on, pass false if not. Styles Toggles honor the following styles. The :light and :dark styles look nice. The other bundled themes...not so much. You can also supply your own theme . :hidden - If false the toggle is rendered. If true, it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Additional Styles Toggles also honor the following additional styles. :border_width - the border width. Defaults to 2 . :padding - the space between the border and the thumb. Defaults to 2 :thumb_radius - the radius of the thumb. This determines the size of the entire toggle. Defaults to 10 . Theme To pass in a custom theme, supply a map with at least the following entries: :border - the color of the border around the toggle :background - the color of the track when the toggle is off . :text - the color of the thumb. :thumb - the color of the track when the toggle is on . Optionally, you can supply the following entries: :thumb_pressed - the color of the thumb when pressed. Defaults to :gainsboro . Examples The following example creates a toggle. graph |&gt; toggle ( true , translate : { 20 , 20 } ) The next example makes a larger toggle. graph |&gt; toggle ( true , translate : { 20 , 20 } , thumb_radius : 14 )","ref":"Scenic.Components.html#toggle/3"},{"type":"function","title":"Scenic.Components.toggle_spec/2","doc":"Generate an uninstantiated toggle spec, parallel to the concept of primitive specs. See Components.toggle for data and options values.","ref":"Scenic.Components.html#toggle_spec/2"},{"type":"behaviour","title":"Scenic.Driver","doc":"The main module for drawing and user input. Note: The driver model has completely changed in v0.11. Drivers make up the bottom layer of the Scenic architectural stack. They draw everything on the screen and originate the raw user input. In general, different drawing targets will need different drivers. The driver interface provides a great deal of flexibility, but is more advanced than writing scenes. You can write drivers that only provide user input, only draw scripts, or do both. There is no assumption at all as to what the output target or user source is. Starting Drivers Drivers are always managed by a ViewPort that hosts them. The most common way to instantiate a driver is set it up in the config of a ViewPort when it starts up. config :my_app , :viewport , size : { 800 , 600 } , name : :main_viewport , theme : :dark , default_scene : MyApp.Scene.MainScene , drivers : [ [ module : Scenic.Driver.Local , name : :local_driver , window : [ title : &quot;My Application&quot; , resizeable : false ] ] , [ module : MyApp.Driver.MyDriver , my_param : &quot;abc&quot; ] , ] In the example above, two drivers are configured to be started when the :main_viewport starts up. Both drivers drivers will be running at the same time and will receive the same messages from the ViewPort. Drivers can be dynamically started on a ViewPort using Scenic.ViewPort.start_driver/2 . They can be dynamically stopped on a ViewPort using Scenic.ViewPort.stop_driver/2 . Drivers can also define their own configuration options. See the documentation for the driver you are interested in starting to see the available options. Messages from the ViewPort The way a ViewPort communicates with it's drivers is by sending them a set of well-known messages. These are picked up by the Driver module and sent to your driver through callbacks. Callback Description reset_scene/1 The ViewPort context has been reset. The driver can clean up all scripts and cached media request_input/2 The ViewPort is requesting user inputs from the keys list update_scene/2 The scripts identified by ids have been update and should be processed del_scripts/2 The script identified by id has been deleted and can be cleaned up clear_color/2 The background clear color has been updated Handling Updates The main drawing related task of a Driver is to receive the update_scene/2 callback and then draw the updated scripts to the screen, or whatever output medium the driver supports. In a very simple example, it would look something like this. def update_scene ( ids , driver ) do Enum . each ( ids , fn ( id ) -&gt; with { :ok , script } &lt;- ViewPort . get_script_by_id ( vp , id ) do script |&gt; Scenic.Script . serialize ( ) |&gt; my_render_script ( driver ) end end ) { :ok , driver } end The above example is overly simple and just there to get you started. Note that only the ids of the scripts are sent. You still need to fish them out of the ViewPort User Input User input events are created whenever a driver has events to share. The request_input/2 callback indicates to you which input events are currently being listened to. This is a guide that you can use or not. You can send any valid input event at any time, the ViewPort will simply ignore those that aren't being listened to. In this example, there is some source of user input that casts messages to our driver. def handle_cast ( { :my_cursor_press , button , xy } , driver ) do send_input ( driver , { :cursor_button , { button , 1 , [ ] , xy } } ) { :noreply , driver } end No matter what type of input you are sending, it will be checked to make sure it conforms the known input types . Updated Input Formats There are several changes to the input formats in version v0.11. Button indicators are now atoms that conform to standard linux-like buttons. This allows for more buttons on a mouse like device. Do not assume these are the only buttons that can be sent in a :cursor_button message. New Button Old Button :btn_left :left :btn_right :right Press and Release messages were atoms and are now numbers. This is to support multi-state buttons and joysticks and the like. Turns out that some buttons are pressure sensitive and can have a range of values. New Action Old Action 0 :release 1 :press Modifier keys were previously a number and you would have had to dig into the GLFW documentation to see how to interpret it. That was both unintuitive and I wanted to make it more source independent. So now it is a list of atoms. If the atom you are interested is in the list, then it is pressed. [ :ctrl , :shift , :alt , :meta ] Test if a modifier key is pressed using the Enum.member?/2 function. mods = [ :ctrl , :shift ] Enum . member? ( mods , :shift )","ref":"Scenic.Driver.html"},{"type":"function","title":"Scenic.Driver.assign/2","doc":"Convenience function to assign a list of values into a driver struct.","ref":"Scenic.Driver.html#assign/2"},{"type":"function","title":"Scenic.Driver.assign/3","doc":"Convenience function to assign a value into a driver struct.","ref":"Scenic.Driver.html#assign/3"},{"type":"function","title":"Scenic.Driver.assign_new/2","doc":"Convenience function to assign a list or map of new values into a driver struct. Only values that do not already exist will be assigned","ref":"Scenic.Driver.html#assign_new/2"},{"type":"function","title":"Scenic.Driver.assign_new/3","doc":"Convenience function to assign a new values into a driver struct. The value will only be assigned if it does not already exist in the struct.","ref":"Scenic.Driver.html#assign_new/3"},{"type":"callback","title":"Scenic.Driver.clear_color/2","doc":"Called when the background color has changed. The color is provided. This callback is optional.","ref":"Scenic.Driver.html#c:clear_color/2"},{"type":"callback","title":"Scenic.Driver.del_scripts/2","doc":"Called when a script has been deleted and can be cleaned up. The deleted id is provided. This callback is optional.","ref":"Scenic.Driver.html#c:del_scripts/2"},{"type":"function","title":"Scenic.Driver.fetch/2","doc":"Convenience function to fetch an assigned value out of a driver struct.","ref":"Scenic.Driver.html#fetch/2"},{"type":"function","title":"Scenic.Driver.get/3","doc":"Convenience function to get an assigned value out of a driver struct.","ref":"Scenic.Driver.html#get/3"},{"type":"callback","title":"Scenic.Driver.init/2","doc":"Initialize a driver process. The ViewPort and an options list for the driver are passed in. Just like initializing any GenServer process, it should return {:ok, state}","ref":"Scenic.Driver.html#c:init/2"},{"type":"callback","title":"Scenic.Driver.request_input/2","doc":"Called when requested input types have changed. This informs your driver that the requested input types for the application have changed. This is useful if you want to reduce the amount of data being transferred between your input source (which might be expensive...) and the driver. This callback is optional. If you ignore it and send all input events, then only the ones being listened to will be processed.","ref":"Scenic.Driver.html#c:request_input/2"},{"type":"function","title":"Scenic.Driver.request_update/1","doc":"Request a scene_updated call. This is used when scripts are updated. Some drivers use it to batch updates into a single atomic operation. This call is rate limited by limit_ms.","ref":"Scenic.Driver.html#request_update/1"},{"type":"callback","title":"Scenic.Driver.reset_scene/1","doc":"Called when the scene has been reset. This is an opportunity for your driver to clear state that may no longer be relevant. This is typically scripts, inputs, media, etc.","ref":"Scenic.Driver.html#c:reset_scene/1"},{"type":"function","title":"Scenic.Driver.send_input/2","doc":"Send input from the driver. Send input from the driver to its ViewPort. :cursor_pos and :cursor_scroll input will be buffered/rate limited according the driver's :limit_ms setting.","ref":"Scenic.Driver.html#send_input/2"},{"type":"function","title":"Scenic.Driver.set_busy/2","doc":"Set or clear the busy flag. When the busy flag is set, put_script messages will be consolidated until cleared.","ref":"Scenic.Driver.html#set_busy/2"},{"type":"function","title":"Scenic.Driver.terminate/2","doc":"","ref":"Scenic.Driver.html#terminate/2"},{"type":"callback","title":"Scenic.Driver.update_scene/2","doc":"Called when the scene has been updated. The list of ids is the set of script ids that have changed and should be updated. Note that the list may be empty if you have requested an update via the request_update/1 function. This callback is optional.","ref":"Scenic.Driver.html#c:update_scene/2"},{"type":"function","title":"Scenic.Driver.validate/1","doc":"Validate driver configuration Used primarily for dynamic view port creation","ref":"Scenic.Driver.html#validate/1"},{"type":"callback","title":"Scenic.Driver.validate_opts/1","doc":"Validate the options passed to a Driver. The list of options for a driver are passed in as opts . If you decide then are good, return them, or a transformed set of them as {:ok, opts} If they are invalid, return either one of: {:error, String.t()} {:error, NimbleOptions.ValidationError.t()} Scenic uses NimbleOptions internally for options validation, so NimbleOptions errors are supported.","ref":"Scenic.Driver.html#c:validate_opts/1"},{"type":"type","title":"Scenic.Driver.response_opts/0","doc":"","ref":"Scenic.Driver.html#t:response_opts/0"},{"type":"type","title":"Scenic.Driver.t/0","doc":"","ref":"Scenic.Driver.html#t:t/0"},{"type":"behaviour","title":"Scenic.Driver.KeyMap","doc":"Behaviour and support functions for mapping physical keys to characters. This module is meant to be implemented elsewhere and provided to a driver in order to localize key presses into the correct characters. The :scenic_driver_local driver comes with a USEnglish key map, which it uses by default. Look at that one as an example on how to make a custom key mapping.","ref":"Scenic.Driver.KeyMap.html"},{"type":"function","title":"Scenic.Driver.KeyMap.alt?/1","doc":"Is any alt key pressed?","ref":"Scenic.Driver.KeyMap.html#alt?/1"},{"type":"function","title":"Scenic.Driver.KeyMap.caps_lock?/1","doc":"Is the caps lock enabled? Returns true if any shift key or the caps lock is pressed or active.","ref":"Scenic.Driver.KeyMap.html#caps_lock?/1"},{"type":"function","title":"Scenic.Driver.KeyMap.ctrl?/1","doc":"Is any ctrl key pressed?","ref":"Scenic.Driver.KeyMap.html#ctrl?/1"},{"type":"callback","title":"Scenic.Driver.KeyMap.map_key/4","doc":"Translate a key to a codepoint, which is really just a string. The first time this is called, state is nil. After that you can return any state that makes sense and it will be passed back on the next call. If the mapping is successful, i.e. the key press results in a valid character, Then this function should return { :ok, codepoint, state } . The returned codepoint will be sent on to the ViewPort as a codepoint input event. If the key press does not map to a string (this is common), then the function should return { :ok, nil, state } . This will not result in a codepoint input being sent to the ViewPort. If the data makes no sense at all, then you can return { :error, error_msg, state } . This will not send a codepoint input, but will log the error message, which should be a string.","ref":"Scenic.Driver.KeyMap.html#c:map_key/4"},{"type":"function","title":"Scenic.Driver.KeyMap.meta?/1","doc":"Is any meta key pressed? This is usually the command button.","ref":"Scenic.Driver.KeyMap.html#meta?/1"},{"type":"function","title":"Scenic.Driver.KeyMap.mods/1","doc":"Generate the list of pressed modifier keys","ref":"Scenic.Driver.KeyMap.html#mods/1"},{"type":"function","title":"Scenic.Driver.KeyMap.num_lock?/1","doc":"Is the num lock enabled? Returns true if num lock is pressed or active.","ref":"Scenic.Driver.KeyMap.html#num_lock?/1"},{"type":"function","title":"Scenic.Driver.KeyMap.scroll_lock?/1","doc":"Is the scroll lock enabled? Returns true if scroll lock is pressed or active.","ref":"Scenic.Driver.KeyMap.html#scroll_lock?/1"},{"type":"function","title":"Scenic.Driver.KeyMap.shift?/1","doc":"Is the current set of keys shifted? Returns true if any shift key or the caps lock is pressed or active.","ref":"Scenic.Driver.KeyMap.html#shift?/1"},{"type":"type","title":"Scenic.Driver.KeyMap.keys/0","doc":"","ref":"Scenic.Driver.KeyMap.html#t:keys/0"},{"type":"type","title":"Scenic.Driver.KeyMap.mod_keys/0","doc":"","ref":"Scenic.Driver.KeyMap.html#t:mod_keys/0"},{"type":"module","title":"Scenic.Graph","doc":"Please see Graph Overview for a high-level description. What is a Graph There are many types of graphs in the field of Computer Science. There are graphs that show data to a user. There are graphs that give access to databases. Graphs that link people to a social network. In Scenic, a Graph is a graph in same way that the DOM in HTML is a graph. It is a hierarchical tree of data that describes a set of things to draw on the screen. You build a graph by appending primitives (individual things to draw) to the current node in the tree. Nodes are represented by Scenic.Primitive.Group . The following example builds a simple graph that displays some text, creates a group, then adds more text and a rounded rectangle to it. @graph Scenic.Graph . build ( ) |&gt; text ( &quot;This is some text&quot; , translate : { 20 , 20 } ) |&gt; group ( fn ( graph ) -&gt; graph |&gt; text ( &quot;This text is in a group&quot; , translate : { 200 , 24 } ) |&gt; rounded_rectangle ( { 400 , 30 } , stroke : { 2 , :blue } ) end , translate : { 20 , 100 } , text_align : :center ) There is a fair amount going on in the example above. The first line builds an empty graph with only one group as the root node. @graph Scenic.Graph . build ( ) By assigning it to the compile directive @group , we know that this group will be built once at compile time and will be very fast to access later during runtime. You could also do this at runtime, in your init function for example. The empty graph that is returned from build() is then passed to |&gt; text ( &quot;This is some text&quot; , translate : { 20 , 20 } ) This adds a text primitive to the root group. The graph returned from that call is then passed again into |&gt; group ( fn ( graph ) -&gt; graph |&gt; text ( &quot;This text is in a group&quot; , translate : { 200 , 24 } ) |&gt; rounded_rectangle ( { 400 , 30 } , stroke : { 2 , :blue } ) end , translate : { 20 , 100 } , text_align : :center ) This creates a new group which is filled with several other primitives. Notice that the anonymous group &quot;builder&quot; function receives a graph as its only parameter. This is the same graph that we are building, except that it has a marker indicating that new primitives added to it are inserted into the new group instead of the root of the graph. Finally, when the group is finished, a translation matrix and a :text_align style (see Scenic.Primitive.Style.TextAlign ) are added to it. These properties are inherited by the primitives in the group. Inheritance An important concept to understand is that both styles and transforms are inherited down the graph. This means that if you apply a style or transform to any group (including the root), then all primitives contained by that group will have those properties applied to them too. This is true even if the primitive is nested in several groups at the same time. @graph Scenic.Graph . build ( font : :roboto_mono ) |&gt; text ( &quot;This text inherits the font&quot; , translate : { 20 , 20 } ) |&gt; group ( fn ( graph ) -&gt; graph |&gt; text ( &quot;This text also inherits the font&quot; , translate : { 200 , 24 } ) |&gt; text ( &quot;This text overrides the font&quot; , font : :roboto ) end , translate : { 20 , 100 } , text_align : :center ) Transforms, such as translate, rotate, scale, also inherit down the graph, but do so slightly differently than the styles. With a style, when you set a specific value on a primitive, that overrides the inherited value of the same type. With a transform, the values multiply together. This allows you to position items within a group relative to the origin {0,0}, then move the group as a whole, keeping the interior positions unchanged. Styles, however, are NOT inherited by components even though transforms are. Modifying a Graph Scenic was written specifically for Erlang/Elixir, which is a functional programming model with immutable data. As such, once you make a graph, it stays in memory unchanged - until you transform it via Graph.modify/3 . Technically you never change it (that's the immutable part), instead Graph.modify returns a new graph with different data in it. Graph.modify/3 is the single Graph function that you will use the most. For example, lets go back to our graph with the two text items in it. @graph Graph . build ( font : :roboto , font_size : 24 , rotate : 0.4 ) |&gt; text ( &quot;Hello World&quot; , translate : { 300 , 300 } , id : :small_text ) |&gt; text ( &quot;Bigger Hello&quot; , font_size : 40 , scale : 1.5 , id : :big_text ) This time, we've assigned ids to both of the text primitives. This makes it easy to find and modify that primitive in the graph. graph = @graph |&gt; Graph . modify ( :small_text , &amp; text ( &amp;1 , &quot;Smaller Hello&quot; , font_size : 16 ) ) |&gt; Graph . modify ( :big_text , &amp; text ( &amp;1 , &quot;Bigger Hello&quot; , font_size : 60 ) ) Notice that the graph is modified multiple times in the pipeline. The push_graph/1 function is relatively heavy when the graph references other scenes. The recommended pattern is to make multiple changes to the graph . Accessing Primitives When using a Graph, it is extremely common to access and modify primitives. The way you do this is by putting an id on the primitives you care about in a graph. @graph Graph . build ( ) |&gt; text ( &quot;small text&quot; , id : :small_text ) |&gt; text ( &quot;bit text&quot; , id : :big_text ) When you get primitives, or modify a graph, you specify them by id. This happens quickly, but at a cost of using a little memory. If you aren't going to access a primitive, then don't assign an id to them. One interesting note: There is nothing saying you have to use an atom as the id. In fact you can use any Erlang term you want. This can be very powerful, especially when used to identify components...","ref":"Scenic.Graph.html"},{"type":"function","title":"Scenic.Graph.add/2","doc":"Add a pre-built primitive to the current group in the graph. This is usually called during graph construction. When a new Group primitive is added to a Graph, it marks the new group as the current one before calling the group's builder function. This is what allows you to add primitives to the correct place in the new Group. Note: All primitives added to a group are appended to the draw order.","ref":"Scenic.Graph.html#add/2"},{"type":"function","title":"Scenic.Graph.add/4","doc":"Build and add a primitive to the current group in the graph. This is usually called during graph construction. When a new Group primitive is added to a Graph, it marks the new group as the current one before calling the group's builder function. This is what allows you to add primitives to the correct place in the new Group. Note: All primitives added to a group are appended to the draw order.","ref":"Scenic.Graph.html#add/4"},{"type":"function","title":"Scenic.Graph.add_to/3","doc":"Add to a specified group in a graph. Similar to adding a group during graph construction, the add_to function accepts a builder function that adds to a graph under the identified group. Primitives with the id that are not groups are ignored. If multiple groups have the given id , then the builder is run against each of them.","ref":"Scenic.Graph.html#add_to/3"},{"type":"function","title":"Scenic.Graph.bounds/1","doc":"Compute the bounding box that contains the graph. Returns {left, top, right, bottom} or nil if the graph is empty.","ref":"Scenic.Graph.html#bounds/1"},{"type":"function","title":"Scenic.Graph.build/1","doc":"Builds and returns an empty graph. Just like any primitive, you can pass in an option list of styles and transforms. These will be applied to the otherwise empty root group in the new graph.","ref":"Scenic.Graph.html#build/1"},{"type":"function","title":"Scenic.Graph.compile/1","doc":"Compile a graph into a script.","ref":"Scenic.Graph.html#compile/1"},{"type":"function","title":"Scenic.Graph.count/1","doc":"Returns a count of all the primitives in a graph. The root Group counts as a primitive, so an empty graph should have a count of 1.","ref":"Scenic.Graph.html#count/1"},{"type":"function","title":"Scenic.Graph.count/2","doc":"Returns a count of all the primitives in a graph with a specific id.","ref":"Scenic.Graph.html#count/2"},{"type":"function","title":"Scenic.Graph.delete/2","doc":"Permanently delete a primitive from a group by id. This will remove a primitive (or many if they have the same id) from a graph. It then returns the modified graph. If you delete a group from a graph, then all primitives contained by that group are deleted as well.","ref":"Scenic.Graph.html#delete/2"},{"type":"function","title":"Scenic.Graph.find/2","doc":"Find one or more primitives in a graph via a filter function. Pass in a function that accepts a primitive and returns a boolean. Returns a list of primitives. Warning: This function crawls the entire graph and is thus slower than accessing items via a fully-specified id.","ref":"Scenic.Graph.html#find/2"},{"type":"function","title":"Scenic.Graph.get/2","doc":"Returns a list of primitives from a graph with a specific id.","ref":"Scenic.Graph.html#get/2"},{"type":"function","title":"Scenic.Graph.get!/2","doc":"Returns a single primitive from a graph with a specific id. This will raise an error if either none or multiple primitives are found with the specified id.","ref":"Scenic.Graph.html#get!/2"},{"type":"function","title":"Scenic.Graph.map/2","doc":"Map all primitives in a graph into a new graph. Crawls through the entire graph, passing each primitive to the callback function. The result of the callback replaces that primitive in the graph. The updated graph is returned.","ref":"Scenic.Graph.html#map/2"},{"type":"function","title":"Scenic.Graph.map/3","doc":"Map all primitives in a graph that match a specified id into a new graph. Crawls through the entire graph, passing each primitive to the callback function. The result of the callback replaces that primitive in the graph. The updated graph is returned. This is so similar to the modify function that it may be deprecated in the future. For now I recommend you use Graph.modify/3 instead of this.","ref":"Scenic.Graph.html#map/3"},{"type":"function","title":"Scenic.Graph.modify/3","doc":"Modify one or more primitives in a graph. Retrieves the primitive (or primitives) specified by id and passes them to a callback function. The result of the callback function is stored as the new version of that primitive in the graph. If multiple primitives match the specified id, then each is passed, in turn, to the callback function. The id can be either a term to match against (fast) a filter function that returns a boolean (slower) Examples: graph |&gt; Graph . modify ( :explicit_id , &amp; text ( &quot;Updated Text 1&quot; ) ) |&gt; Graph . modify ( { :id , 123 } , &amp; text ( &quot;Updated Text 2&quot; ) ) |&gt; Graph . modify ( &amp; match? ( { :id , _ } , &amp;1 ) , &amp; text ( &quot;Updated Text 3&quot; ) )","ref":"Scenic.Graph.html#modify/3"},{"type":"function","title":"Scenic.Graph.reduce/3","doc":"Invokes action for each primitive in the graph with the accumulator. Iterates over all primitives in a graph, passing each into the callback function with an accumulator. The return value of the callback is the new accumulator. This is extremely similar in behaviour to Elixir's Enum.reduce function, except that it understands how to navigate the tree structure of a Graph.","ref":"Scenic.Graph.html#reduce/3"},{"type":"function","title":"Scenic.Graph.reduce/4","doc":"Invokes action for each primitive that matches an id in the graph with the accumulator. Iterates over all primitives that match a specified id, passing each into the callback function with an accumulator. This is extremely similar in behaviour to Elixir's Enum.reduce function, except that it understands how to navigate the tree structure of a Graph.","ref":"Scenic.Graph.html#reduce/4"},{"type":"type","title":"Scenic.Graph.bounds/0","doc":"","ref":"Scenic.Graph.html#t:bounds/0"},{"type":"type","title":"Scenic.Graph.deferred/0","doc":"","ref":"Scenic.Graph.html#t:deferred/0"},{"type":"type","title":"Scenic.Graph.t/0","doc":"","ref":"Scenic.Graph.html#t:t/0"},{"type":"module","title":"Scenic.Primitives","doc":"A set of helper functions to make it easy to add to, or modify, a graph. In general, each helper function is of the form def name_of_primitive ( graph , data , opts \\\\ [ ] ) or def name_of_primitive_spec ( data , opts \\\\ [ ] ) The first form builds the primitive immediately and adds it to the graph that is passed in. The second form creates a specification for the primitive (basically, a data structure describing how to draw it). You then add this to a graph at some later time. Let's start by looking at the immediate versions. Immediate Primitive Helpers When adding primitives to a graph, each helper function accepts a graph as the first parameter and returns the transformed graph. This makes it very easy to build a complex graph by piping helper functions together. @graph Graph . build ( ) |&gt; text ( &quot;Hello World&quot; ) |&gt; rectangle ( { 100 , 200 } ) |&gt; line ( { { 10 , 20 } , { 100 , 20 } } ) When modifying a graph, you can again use the helpers by passing in the primitive to be modified. The transformed primitive will be returned. Graph . modify ( graph , :rect , fn ( p ) -&gt; rectangle ( p , { 200 , 300 } ) end ) # or, more compactly... Graph . modify ( graph , :rect , &amp; rectangle ( &amp;1 , { 200 , 300 } ) ) In each case, the second parameter is a data term that is specific to the primitive being acted on. See the documentation below. If you pass in invalid data for the second parameter, an error will be thrown, along with some explanation of what it expected. The third parameter is a keyword list of options that are to be applied to the primitive. This includes setting the id, styles, transforms and such. @graph Graph . build ( ) |&gt; text ( &quot;Hello World&quot; , id : :hello , font_size : 24 , rotate : 0.4 ) |&gt; rectangle ( { 100 , 200 } , translate : { 10 , 30 } , fill : :yellow ) |&gt; line ( { { 10 , 20 } , { 100 , 20 } } , id : :a_line , stroke : { 4 , :green } ) Deferred Primitive Helpers Each immediate primitive helper has a corresponding deferred helper. The deferred variant does not add the primitive to a graph. Instead, the deferred helper returns a function. You can then call that function, passing it a graph, and the primitive will be added to that graph. text = text_spec ( &quot;Hello World&quot; ) rect = rectangle_spec ( { 100 , 200 } ) line = line_spec ( { { 10 , 20 } , { 100 , 20 } } ) g = Graph . build ( ) g = text . ( g ) g = rect . ( g ) g = line . ( g ) Written like this, the deferred helpers aren't compelling. But we could also write items = [ text_spec ( &quot;Hello World&quot; ) , rectangle_spec ( { 100 , 200 } ) , line_spec ( { { 10 , 20 } , { 100 , 20 } } ) , ] g = items |&gt; Enum . reduce ( Graph . build ( ) , fn item , g -&gt; item . ( g ) end ) Deferred helpers let us express primitives as data. This makes it easier to define display graphs at compile time, particularly when we use the group_spec/2 helper to express the grouping of components: @line { { 0 , 0 } , { 60 , 60 } } @lines [ line_spec ( @line , stroke : { 4 , :red } ) , line_spec ( @line , stroke : { 20 , :green } , cap : :butt , t : { 60 , 0 } ) , line_spec ( @line , stroke : { 20 , :yellow } , cap : :round , t : { 120 , 0 } ) , ] @text [ text_spec ( &quot;Hello&quot; , translate : { 0 , 40 } ) , text_spec ( &quot;World&quot; , translate : { 90 , 40 } , fill : :yellow ) , ] @drawing Graph . build ( ) |&gt; add_specs_to_graph ( [ @lines , @text ] ) If you wanted to put the lines into one group and the text into another, simply interpose the group_spec/2 helper: @drawing Graph . build ( ) |&gt; add_specs_to_graph ( [ group_spec ( @lines , t : [ 100 , 50 ] ) , group_spec ( @text , t : [ 150 , 50 ] ) ] ) If you have a smaller graph or just like to see everything in one place, you might prefer using group_spec_r/2 : @line { { 0 , 0 } , { 60 , 60 } } @drawing Graph . build ( ) |&gt; add_specs_to_graph ( [ group_spec_r ( [ t : { 100 , 50 } ] , [ line_spec ( @line , stroke : { 4 , :red } ) , line_spec ( @line , stroke : { 20 , :green } , cap : :butt , t : { 60 , 0 } ) , line_spec ( @line , stroke : { 20 , :yellow } , cap : :round , t : { 120 , 0 } ) ] ) , group_spec_r ( [ t : { 150 , 50 } ] , [ text_spec ( &quot;Hello&quot; , translate : { 0 , 40 } ) , text_spec ( &quot;World&quot; , translate : { 90 , 40 } , fill : :yellow ) , ] ) ] ) These examples use add_specs_to_graph/2 , a simple helper that converts specs into primitives and adds them to a graph. Style options Style options affect the way primitives are drawn. They include options such as :fill , :stroke , :font and many more. See the Scenic.Primitive.Style documentation for the full list. Style options are inherited down the graph. In other words, if you set a style on the root of the graph like this: Graph.build(font_size: 24) , then all text items in all groups will be rendered with a point size of 24 unless they set a different size. Not every primitive accepts every style. For example, it doesn't make much sense to apply a font to a rectangle. If you try, the rectangle will ignore that value. See the documentation for each primitive for a list of what styles they pay attention to. Transforms that are applied to a Group are inherited by all primitives in that group's branch of the tree. Note that style inheritance does not cross SceneRef boundaries. Transform options Transform options affect the size, position and rotation of elements in the graph. Any transform you can express as a 4x4 matrix of floats, you can apply to any primitive in the graph, including groups and SceneRefs. Transform options are applied on the element they are specified on. If you specify a transform on a group, then it is applied to everything rendered in that branch of the graph tree. This is done mathematically as a &quot;stack&quot; of transforms. As the renderer traverses up and down the graph, transforms are pushed and popped from the matrix stack as appropriate. Transform inheritance does cross SceneRef boundaries. Draw Order Primitives will be drawn in the order you add them to the graph. For example, the graph below draws text on top of a filled rectangle. If the order of the text and rectangle were reversed, they would both still be rendered, but the text would not be visible because the rectangle would cover it up. @graph Graph . build ( font : { :roboto , 20 } ) |&gt; rect ( { 100 , 200 } , color : :blue ) |&gt; text ( &quot;Hello World&quot; , id : :hello , translate : { 10 , 10 } )","ref":"Scenic.Primitives.html"},{"type":"function","title":"Scenic.Primitives.add_specs_to_graph/2","doc":"Given a graph and a list of deferred primitive specifications, run the specs in order, adding the primitives to the graph. Example: items = [ text_spec ( &quot;hello &quot; ) , text_spec ( &quot;world&quot; ) ] graph = graph |&gt; add_specs_to_graph ( items ) If given a third parameter, the specs are wrapped in a group, and that parameter is used as the group's options. graph = graph |&gt; add_specs_to_graph ( items , t : { 100 , 100 } )","ref":"Scenic.Primitives.html#add_specs_to_graph/2"},{"type":"function","title":"Scenic.Primitives.add_specs_to_graph/3","doc":"","ref":"Scenic.Primitives.html#add_specs_to_graph/3"},{"type":"function","title":"Scenic.Primitives.arc/3","doc":"Add an arc to a graph An arc is the outer edge of a part of a circle or ellipse. It is the sort of thing you would use a compass to draw on a piece of paper. It has a radius, and angle that defines how much of the arc to sweep through. The angle is specified in radians. Data: { radius , angle } If you want something that looks like a piece of pie (maybe for a pie chart??), then you want a Sector, not an Arc. To create an arc of an ellipse, create a normal arc, and apply a :scale transform with unequal x and y sizing. The following example will draw a simple arc with a radius of 100, starting straight out to the right, then going down 0.4 radians. graph |&gt; arc ( { 100 , 0.6 } ) Note The format for Arc has changed since v0.10. It used to be {radius, start_angle, end_angle}. You can achieve the same effect in the new, simpler format by using the same radius and the new angle is the difference between the old end_angle and start_angle. Then you can apply a rotation transform to get it in the right position. Styles Arcs honor the following styles :hidden - If true , the outline is rendered. If false , it is skipped. Default: false . :fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear , but optimized. :stroke - Draws the outline with the specified width and paint. The default if not set is {1, :white} . Example: graph |&gt; arc ( { 100 , 0.4 } , stroke : { 4 , :blue } )","ref":"Scenic.Primitives.html#arc/3"},{"type":"function","title":"Scenic.Primitives.arc_spec/2","doc":"Create the specification that adds an arc to a graph. See the documentation for arc/3 for details. Example: arc = arc_spec ( { 100 , 0 , 0.4 } , stroke : { 4 , :blue } ) graph = arc . ( graph ) Note The format for Arc has changed since v0.10. It used to be {radius, start_angle, end_angle}. You can achieve the same effect in the new, simpler format by using the same radius and the new angle is the difference between the old end_angle and start_angle. Then you can apply a rotation transform to get it in the right position.","ref":"Scenic.Primitives.html#arc_spec/2"},{"type":"function","title":"Scenic.Primitives.circle/3","doc":"Add a Circle to a graph. Circles are defined by a radius. The following example will draw circle with radius 100. graph |&gt; circle ( 100 ) Styles Circles honor the following styles :hidden - If true , the outline is rendered. If false , it is skipped. Default: false . :fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear , but more optimized. :stroke - The width and paint to draw the outline with. If the stroke is not specified, the default stroke is {1, :white} . Example: graph |&gt; circle ( 40 , fill : :red , stroke : { 3 , :blue } , translate : { 100 , 200 } ) While you could apply a :rotate transform to a circle, it wouldn't do anything visible unless you also add a uneven :scale transform to make it into an ellipse.","ref":"Scenic.Primitives.html#circle/3"},{"type":"function","title":"Scenic.Primitives.circle_spec/2","doc":"Create the specification that adds a circle to a graph. See the documentation for circle/3 for details. Example: circle = circle_spec ( 40 , stroke : { 4 , :blue } ) graph = circle . ( graph )","ref":"Scenic.Primitives.html#circle_spec/2"},{"type":"function","title":"Scenic.Primitives.ellipse/3","doc":"Add an Ellipse to a graph. Ellipses are defined by two radii. The following example will draw an ellipse. graph |&gt; ellipse ( { 100 , 140 } ) If you want the ellipse to be on an angle, apply a :rotate transform. Styles Ellipses honor the following styles :hidden - If true , the outline is rendered. If false , it is skipped. Default: false . :fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear , but optimized. :stroke - The width and paint to draw the outline with. If the stroke is not specified, the default stroke is {1, :white} Example: graph |&gt; ellipse ( { 40 , 60 } , fill : :red , stroke : { 3 , :blue } , rotate : 0.4 )","ref":"Scenic.Primitives.html#ellipse/3"},{"type":"function","title":"Scenic.Primitives.ellipse_spec/2","doc":"Create the specification that adds an ellipse to a graph. See the documentation for ellipse/3 for details. Example: ellipse = ellipse_spec ( { 40 , 60 } , stroke : { 4 , :blue } ) graph = ellipse . ( graph )","ref":"Scenic.Primitives.html#ellipse_spec/2"},{"type":"function","title":"Scenic.Primitives.group/3","doc":"Create a new branch in a Graph. The Group primitive creates a new branch in the Graph's tree. The data field you pass in is a function callback, which allows you to add more primitives inside the new group. The single parameter to your anonymous callback is a transformed graph that knows to add new primitives to the right branch in the tree. @graph Graph . build ( ) |&gt; text ( &quot;Hello World&quot; ) |&gt; group ( fn ( g ) -&gt; g |&gt; text ( &quot;I&#39;m in the Group&quot; ) end , translate : { 40 , 200 } ) NOTE: Unlike other primitives, group/3 currently only takes a graph and not an existing group primitive. Styles Groups will accept all styles. They don't use the styles directly, but any styles you set on a group become the new defaults for all primitives you add to that group's branch in the graph. The :hidden style is particularly effective when applied to a group as it causes that entire branch to be drawn, or not. Transforms Any transforms you apply to a group are added into the render matrix stack and are applied to all items in that branch, including crossing SceneRefs.","ref":"Scenic.Primitives.html#group/3"},{"type":"function","title":"Scenic.Primitives.group_spec/2","doc":"Bundle a list of specifications together, and return a function that, when called, will add those specs as a group to a graph. The options are the same as for group/3 Example: line = { { 0 , 0 } , { 60 , 60 } } lines = [ line_spec ( @line , stroke : { 4 , :red } ) , line_spec ( @line , stroke : { 20 , :green } , cap : :butt , t : { 60 , 0 } ) , line_spec ( @line , stroke : { 20 , :yellow } , cap : :round , t : { 120 , 0 } ) , ] line_group = group_spec ( lines , t : [ 100 , 100 ] ) graph = line_group . ( graph ) You can also pass in a single primitive spec: line = line_spec ( { { 0 , 0 } , { 60 , 60 } } , stroke : { 4 , :red } ) , line_group = group_spec ( line , t : [ 100 , 100 ] ) graph = line_group . ( graph )","ref":"Scenic.Primitives.html#group_spec/2"},{"type":"function","title":"Scenic.Primitives.group_spec_r/2","doc":"Bundle a list of specifications together, and return a function that, when called, will add those specs as a group to a graph. The options are the same as for group_spec/2 , but reversed, making it suitable to use when declaring graph specs as big literals due to the increased readability. Example: line = { { 0 , 0 } , { 60 , 60 } } line_group = group_spec_r ( [ t : { 100 , 100 } ] , [ line_spec ( @line , stroke : { 4 , :red } ) , line_spec ( @line , stroke : { 20 , :green } , cap : :butt , t : { 60 , 0 } ) , line_spec ( @line , stroke : { 20 , :yellow } , cap : :round , t : { 120 , 0 } ) , ] ) graph = line_group . ( graph ) You can also pass in a single primitive spec: line = line_spec ( { { 0 , 0 } , { 60 , 60 } } , stroke : { 4 , :red } ) , line_group = group_spec_r ( [ t : { 100 , 100 } ] , line ) graph = line_group . ( graph )","ref":"Scenic.Primitives.html#group_spec_r/2"},{"type":"function","title":"Scenic.Primitives.line/3","doc":"Add a line to a graph. Lines are pretty simple. They start at one point and go to another. Data: { { from_x , from_y } , { to_x , to_y } } The following example will draw a diagonal line from the upper left corner {0,0} to the point {100,200} , which is down and to the right. graph |&gt; line ( { { 0 , 0 } , { 100 , 200 } } ) Styles Lines honor the following styles :hidden - If true , the line is skipped. If false , the line is rendered. Default: false . :stroke - The width and paint to draw the line with. If the stroke is not specified, the default stroke is {1, :white} . :cap - Specifies the shape of the ends of the line. Can be one of :round , :butt , or :square . If cap is not specified, then the default is :butt . Example: graph |&gt; line ( { { 0 , 0 } , { 100 , 200 } } , stroke : { 4 , :blue } , cap : :round )","ref":"Scenic.Primitives.html#line/3"},{"type":"function","title":"Scenic.Primitives.line_spec/2","doc":"Create the specification that adds a line to a graph. See the documentation for line/3 for details. Example: line = line_spec ( { { 0 , 0 } , { 100 , 200 } , stroke : { 4 , :blue } ) graph = line . ( graph )","ref":"Scenic.Primitives.html#line_spec/2"},{"type":"function","title":"Scenic.Primitives.path/3","doc":"Add custom, complex shape to a graph. A custom path is defined by a list of actions that the renderer can follow. This is about as close as Scenic gets to immediate mode rendering. See Scenic.Primitive.Path for details. graph |&gt; path ( [ :begin , { :move_to , 10 , 20 } , { :line_to , 30 , 40 } , { :bezier_to , 10 , 11 , 20 , 21 , 30 , 40 } , { :quadratic_to , 10 , 11 , 50 , 60 } , { :arc_to , 70 , 80 , 90 , 100 , 20 } , :close_path , ] , stroke : { 4 , :blue } , cap : :round )","ref":"Scenic.Primitives.html#path/3"},{"type":"function","title":"Scenic.Primitives.path_spec/2","doc":"Create the specification that adds a path to a graph. See the documentation for path/3 for details. Example: path = path_spec ( [ :begin , { :move_to , 10 , 20 } , { :line_to , 30 , 40 } , { :bezier_to , 10 , 11 , 20 , 21 , 30 , 40 } , { :quadratic_to , 10 , 11 , 50 , 60 } , { :arc_to , 70 , 80 , 90 , 100 , 20 } , :close_path , ] , stroke : { 4 , :blue } , cap : :round ) graph = path . ( graph )","ref":"Scenic.Primitives.html#path_spec/2"},{"type":"function","title":"Scenic.Primitives.quad/3","doc":"Add a Quadrilateral (quad) to a graph. Quads are defined by four points on the screen. Data: { { x0 , y0 } , { x1 , y1 } , { x2 , y2 } , { x3 , y3 } } The following example will draw a quad. graph |&gt; quad ( { { 10 , 20 } , { 100 , 20 } , { 90 , 120 } , { 15 , 70 } } ) Styles Quads honor the following styles :hidden - If true , the outline is rendered. If false , it is skipped. Default: false . :fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, except optimized out to do nothing. :stroke - The width and paint to draw the outline with. If the stroke is not specified then the default stroke is {1, :white} :join - Specifies how the lines are joined together where they meet. Can be one of :miter , :round , or :bevel . If join is not specified, then the default is :miter :miter_limit - Apply an optional miter limit to the joints. If the angle is very shallow, the pointy bit might extend out far beyond the joint. Specifying :miter_limit puts a limit on the joint and bevels it if it goes out too far. Example: graph |&gt; quad ( { { 10 , 20 } , { 100 , 20 } , { 90 , 120 } , { 15 , 70 } } , fill : :red , stroke : { 3 , :blue } , join : :round )","ref":"Scenic.Primitives.html#quad/3"},{"type":"function","title":"Scenic.Primitives.quad_spec/2","doc":"Create the specification that adds a quad to a graph. See the documentation for quad/3 for details. Example: quad = quad_spec ( { { 10 , 20 } , { 100 , 20 } , { 90 , 120 } , { 15 , 70 } } , fill : :red , stroke : { 3 , :blue } , join : :round ) graph = quad . ( graph )","ref":"Scenic.Primitives.html#quad_spec/2"},{"type":"function","title":"Scenic.Primitives.rect/3","doc":"Shortcut to the rectangle/3 function. rect/3 is the same as calling rectangle/3","ref":"Scenic.Primitives.html#rect/3"},{"type":"function","title":"Scenic.Primitives.rect_spec/2","doc":"Create the specification that adds a rectangle to a graph. See the documentation for rectangle/3 for details. Example: rect = rect_spec ( { { 10 , 20 } , { 100 , 20 } } , fill : :red , stroke : { 3 , :blue } , join : :round ) graph = rect . ( graph )","ref":"Scenic.Primitives.html#rect_spec/2"},{"type":"function","title":"Scenic.Primitives.rectangle/3","doc":"Add a rectangle to a graph. Rectangles are defined by a width and height. Data: { width , height } The following example will draw a rectangle. graph |&gt; rectangle ( { 100 , 200 } ) Styles Rectangles honor the following styles :hidden - If true , the outline is rendered. If false , it is skipped. Default: false . :fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, except optimized out to do nothing. :stroke - The width and paint to draw the outline with. If the stroke is not specified then the default stroke is {1, :white} :join - Specifies how the lines are joined together where they meet. Can be one of :miter , :round , or :bevel . If join is not specified, then the default is :miter :miter_limit - Apply an optional miter limit to the joints. If the angle is very shallow, the pointy bit might extend out far beyond the joint. Specifying :miter_limit puts a limit on the joint and bevels it if it goes out too far. Example: graph |&gt; rectangle ( { 100 , 200 } , fill : :red , stroke : { 3 , :blue } , join : :round )","ref":"Scenic.Primitives.html#rectangle/3"},{"type":"function","title":"Scenic.Primitives.rectangle_spec/2","doc":"Create the specification that adds a rectangle to a graph. See the documentation for rectangle/3 for details. Example: rect = rectangle_spec ( { { 10 , 20 } , { 100 , 20 } } , fill : :red , stroke : { 3 , :blue } , join : :round ) graph = rect . ( graph )","ref":"Scenic.Primitives.html#rectangle_spec/2"},{"type":"function","title":"Scenic.Primitives.rounded_rectangle/3","doc":"Add a rounded rectangle to a graph. Rounded rectangles are defined by a width, height, and radius. Data: { width , height , radius } The following example will draw a rounded rectangle. graph |&gt; rounded_rectangle ( { 100 , 200 , 8 } ) Styles Rounded rectangles honor the following styles :hidden - If true , the outline is rendered. If false , it is skipped. Default: false . :fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, except optimized out to do nothing. :stroke - The width and paint to draw the outline with. If the stroke is not specified then the default stroke is {1, :white} Example: graph |&gt; rounded_rectangle ( { 100 , 200 , 8 } , fill : :red , stroke : { 3 , :blue } )","ref":"Scenic.Primitives.html#rounded_rectangle/3"},{"type":"function","title":"Scenic.Primitives.rounded_rectangle_spec/2","doc":"Create the specification that adds a rounded rectangle to a graph. See the documentation for rounded_rectangle/3 for details. Example: rect = rounded_rectangle_spec ( { { 10 , 20 } , { 100 , 20 } } , fill : :red , stroke : { 3 , :blue } , join : :round ) graph = rect . ( graph )","ref":"Scenic.Primitives.html#rounded_rectangle_spec/2"},{"type":"function","title":"Scenic.Primitives.rrect/3","doc":"Shortcut to the rounded_rectangle/3 function. rrect/3 is the same as calling rounded_rectangle/3","ref":"Scenic.Primitives.html#rrect/3"},{"type":"function","title":"Scenic.Primitives.rrect_spec/2","doc":"Create the specification that adds a rounded rectangle to a graph. See the documentation for rounded_rectangle/3 for details. Example: rect = rrect_spec ( { { 10 , 20 } , { 100 , 20 } } , fill : :red , stroke : { 3 , :blue } , join : :round ) graph = rect . ( graph )","ref":"Scenic.Primitives.html#rrect_spec/2"},{"type":"function","title":"Scenic.Primitives.script/3","doc":"Add a named script to a graph. Scripts are defined by a name, which can be an atom, string, pid or reference. NOTE: this doesn't add the script itself. Only places a reference to it in the graph. You still need to add the script to the ViewPort via Scenic.ViewPort.put_script/4 . Data: name Styles Setting styles on a script is similar to setting styles on a group Example: graph |&gt; script ( :my_script )","ref":"Scenic.Primitives.html#script/3"},{"type":"function","title":"Scenic.Primitives.script_spec/2","doc":"Create the specification that adds a script to a graph. See the documentation for script/3 for details. Example: script = script_spec ( &quot;script_name&quot; , translate : { 20 , 30 } )","ref":"Scenic.Primitives.html#script_spec/2"},{"type":"function","title":"Scenic.Primitives.sector/3","doc":"Add a sector to a graph A sector looks like a piece of pie. It is wedge shaped with a pointy bit on one side and a rounded bit on the other. It has a radius, and angle that defines how much of the arc to sweep through. The angle is specified in radians. Data: { radius , angle } To create a sector of an ellipse, create a normal sector, and apply a :scale transform with unequal x and y sizing. The following example will draw a sector with a radius of 100, starting straight out to the right, then going down 0.4 radians. |&gt; sector ( { 100 , 0.4 } ) Note The format for Sector has changed since v0.10. It used to be {radius, start_angle, end_angle}. You can achieve the same effect in the new, simpler format by using the same radius and the new angle is the difference between the old end_angle and start_angle. Then you can apply a rotation transform to get it in the right position. Styles Sectors honor the following styles :hidden - If true , the outline is rendered. If false , it is skipped. Default: false . :fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, except optimized out to do nothing. :stroke - Draws the outline with the specified width and paint. The default if not set is {1, :white} When you apply a stroke to a sector, it goes around the whole piece of pie. If you only want to stroke the curvy part, which is common in pie charts, overlay an Arc on top of the sector and stroke that. If you also put both the sector and the arc together in a Group, you can then apply transforms to the group to position both the primitives as a single unit. Example: graph |&gt; group ( fn ( g ) -&gt; g |&gt; sector ( { 100 , 0 , 0.4 } , fill : :red ) |&gt; arc ( { 100 , 0 , 0.4 } , stroke : { 4 , :blue } ) end , translate : { 30 , 40 } )","ref":"Scenic.Primitives.html#sector/3"},{"type":"function","title":"Scenic.Primitives.sector_spec/2","doc":"Create the specification that adds a sector ref to a graph. See the documentation for sector/3 for details. Example: sector = sector_spec ( { 100 , 0.4 } , fill : :red ) graph = sector . ( graph ) Note The format for Sector has changed since v0.10. It used to be {radius, start_angle, end_angle}. You can achieve the same effect in the new, simpler format by using the same radius and the new angle is the difference between the old end_angle and start_angle. Then you can apply a rotation transform to get it in the right position.","ref":"Scenic.Primitives.html#sector_spec/2"},{"type":"function","title":"Scenic.Primitives.sprites/3","doc":"Add a sprites list a graph.","ref":"Scenic.Primitives.html#sprites/3"},{"type":"function","title":"Scenic.Primitives.sprites_spec/2","doc":"Create the specification that adds a sprites list to a graph. See the documentation for sprites/3 for details. Example: sprites = sprites_spec ( { :static , &quot;source_texure&quot; } , translate : { 20 , 30 } )","ref":"Scenic.Primitives.html#sprites_spec/2"},{"type":"function","title":"Scenic.Primitives.text/3","doc":"Adds text to a graph. Text is pretty simple. Specify the string you would like drawn. The following example will draw some text on the screen. graph |&gt; text ( &quot;Hello World&quot; , translate : { 20 , 20 } ) Styles Text honors the following styles :hidden - If true , the outline is rendered. If false , it is skipped. Default: false . :fill - The paint to color the text with. If not specified, the default is :white. Note: Text can only be filled with solid colors at this time. :font - Specifies font family to draw the text with. The built-in system fonts are :roboto and :roboto_mono . If not specified, the default is :roboto . You can also load your own font into the Scenic.Cache , then specify its key for the font. :font_blur - Draw the text with a blur effect. If you draw text with blur, then draw it again without blur, slightly offset, you get a nice drop shadow effect. The default is to draw with no blur. :text_align - Specify the alignment of the text you are drawing. You will usually specify one of: :left , :center , or :right . See Scenic.Primitive.Style.TextAlign for details. :text_height - Specify the vertical spacing between rows of text. Example: graph |&gt; text ( &quot;Hello World&quot; , fill : :yellow , font : :roboto_mono font_blur : 2.0 , text_align : :center )","ref":"Scenic.Primitives.html#text/3"},{"type":"function","title":"Scenic.Primitives.text_spec/2","doc":"Create the specification that adds text to a graph. See the documentation for text/3 for details. Example: text = text_spec ( &quot;a wombat is a marsupial&quot; , fill : :red ) graph = text . ( graph )","ref":"Scenic.Primitives.html#text_spec/2"},{"type":"function","title":"Scenic.Primitives.triangle/3","doc":"Add a Triangle to a graph. Triangles are defined by three points on the screen. Data: { { x0 , y0 } , { x1 , y1 } , { x2 , y2 } } The following example will draw a triangle. graph |&gt; triangle ( { { 10 , 20 } , { 100 , 20 } , { 50 , 120 } } ) Styles Triangles honor the following styles :hidden - If true , the outline is rendered. If false , it is skipped. Default: false . :fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear , but optimized. :stroke - The width and paint to draw the outline with. If the stroke is not specified, the default stroke is {1, :white} . :join - Specifies how the lines are joined together where they meet. Can be one of :miter , :round , or :bevel . If join is not specified, then the default is :miter . :miter_limit - Apply an optional miter limit to the joints. If the angle is very shallow, the pointy bit might extend out far beyond the joint. Specifying :miter_limit puts a limit on the joint and bevels it if it goes out too far. Example: graph |&gt; triangle ( { { 10 , 20 } , { 100 , 20 } , { 50 , 120 } } , fill : :red , stroke : { 3 , :blue } , join : :round )","ref":"Scenic.Primitives.html#triangle/3"},{"type":"function","title":"Scenic.Primitives.triangle_spec/2","doc":"Create the specification that adds a triangle to a graph. See the documentation for triangle/3 for details. Example: triangle = triangle_spec ( { { 10 , 20 } , { 100 , 20 } , { 50 , 120 } } , fill : :red ) graph = triangle . ( graph )","ref":"Scenic.Primitives.html#triangle_spec/2"},{"type":"function","title":"Scenic.Primitives.update_opts/2","doc":"Update the options of a primitive without changing its data. This is not used during graph creation - only when modifying it later. All the primitive-specific helpers require you to specify the data for the primitive. If you only want to modify a transform or add a style, then use this function. Example: Graph . modify ( graph , :rect , fn ( p ) -&gt; update_opts ( p , rotate : 0.5 ) end ) # or, more compactly... Graph . modify ( graph , :rect , &amp; update_opts ( &amp;1 , rotate : 0.5 ) )","ref":"Scenic.Primitives.html#update_opts/2"},{"type":"module","title":"Scenic.PubSub","doc":"Scenic.PubSub is a combination pub/sub server and data cache. It is intended to be the interface between sensors (or other data sources) and Scenic scenes. Why Scenic.PubSub Sensors (or other data sources) and scenes often need to communicate, but tend to operate on different timelines. Some sensors update fairly slowly or don't behave well when asked to get data at random times by multiple clients. Scenic.PubSub is backed by a GenServer that collects data from a data source in a well-behaved manner, yet is able to serve that data on demand or by subscription to many clients. Global Scope It is important to note that Scenic.PubSub is global in scope. In other words, anything published into Scenic.PubSub is visible to all ViewPorts and Scenes . Registering Data Sources Before a process can start publishing data from a source, it must register a source id with Scenic.PubSub . This source id should be an atom. This prevents other processes from stepping on that data and alerts any subscribing processes that the data is coming online. Scenic.PubSub . register ( source_id ) The source_id parameter must be an atom that names the sensor. Subscribers will use this id to request data or subscriptions to the source. You can can also unregister data sources if they are no longer available. Scenic.PubSub . unregister ( source_id ) Simply exiting the data source process does also cleans up its registration. Publishing Data When a sensor process publishes data, two things happen. First, that data is cached in an :ets table so that future requests for that data from scenes happen quickly and don't need to bother the data source process. Second, any processes that have subscribed to that source are sent a message containing the new data. Scenic.PubSub . publish ( source_id , value ) The source_id parameter must be the atom that was previously registered. The value parameter can be anything that makes sense for the data source. Subscribing to a Data Source Scenes (or any other process) can subscribe to a data source. They will receive messages when the source updates its data, comes online, or goes away. Scenic.PubSub . subscribe ( source_id ) The source_id parameter is the atom registered for the data source. Note that the name source does NOT need to be registered when a listening process subscribes to it. When the source process eventually registers and starts publishing data, the listening subscribers will be notified. The subscribing process will then start receiving messages that can be handled with handle_info/2 event message sent to subscribers data published {{Scenic.PubSub, :data}, {source_id, value, timestamp}} source registered {{Scenic.PubSub, :registered}, {source_id, opts}} source unregistered {{Scenic.PubSub, :unregistered}, source_id} Scenes can also unsubscribe if they are no longer interested in updates. Scenic.PubSub . unsubscribe ( source_id ) Other functions Any process can get data from a source on demand, whether or not it is a subscriber. Scenic.PubSub . get ( source_id ) &gt;&gt; { :ok , data } Any process can list the currently registered data sources. Scenic.PubSub . list ( ) &gt;&gt; [ { source_id , opts , pid } ]","ref":"Scenic.PubSub.html"},{"type":"function","title":"Scenic.PubSub.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.PubSub.html#child_spec/1"},{"type":"function","title":"Scenic.PubSub.fetch/1","doc":"Retrieve the cached data for a named data source. This data is pulled from an :ets table and does not put load on the data source itself. Parameters source_id an atom that is registered to a data source. Return Value { :ok , { source_id , data , timestamp } } source_id is the atom representing the data source. data source_id whatever data the data source last published. timestamp is the time - from :os.system_time(:micro_seconds) - the last data was published. If the data source is either not registered, or has not yet published any data, get returns { :error , :no_data }","ref":"Scenic.PubSub.html#fetch/1"},{"type":"function","title":"Scenic.PubSub.get/1","doc":"Retrieve the cached data value for a named data source. This data is pulled from an :ets table and does not put load on the data source itself. Parameters source_id an atom that is registered to a data source. Return Value data If the data source is either not registered, or has not yet published any data, get returns nil","ref":"Scenic.PubSub.html#get/1"},{"type":"function","title":"Scenic.PubSub.get!/1","doc":"Retrieve the cached data value for a named data source. Raises an error if the value is not registered This data is pulled from an :ets table and does not put load on the data source itself. Parameters source_id an atom that is registered to a data source. Return Value data If the data source is either not registered, or has not yet published any data, get returns nil","ref":"Scenic.PubSub.html#get!/1"},{"type":"function","title":"Scenic.PubSub.list/0","doc":"List the registered data sources. Return Value list/0 returns a list of registered data sources [ { source_id , version , description , pid } ] source_id is the atom representing the data source. opts options list of metadata about the data source. :version is the version string supplied by the data source during registration. :description is the description string supplied by the data source during registration. :registered_at The system time the data source was registered at. pid is the pid of the data source's process.","ref":"Scenic.PubSub.html#list/0"},{"type":"function","title":"Scenic.PubSub.publish/2","doc":"Publish a data point from a data source. When a data source uses publish/2 to publish data, that data is recorded in the cache and a { { Scenic.PubSub , :data } , { source_id , my_value , timestamp } } message is sent to each subscriber. The timestamp is the current time in microseconds as returned from :os.system_time(:micro_seconds) . Parameters source_id an atom that is registered to a data source. data the data to publish. Return Value On success, returns :ok It returns {:error, :not_registered} if the caller is not the registered process for the data source.","ref":"Scenic.PubSub.html#publish/2"},{"type":"function","title":"Scenic.PubSub.query/1","doc":"Retrieve the full cached data for a named data source. This data is pulled from an :ets table and does not put load on the data source itself. Parameters source_id an atom that is registered to a data source. Return Value { :ok , { source_id , data , timestamp } } source_id is the atom representing the data source. data source_id whatever data the data source last published. timestamp is the time - from :os.system_time(:micro_seconds) - the last data was published. If the data source is either not registered, or has not yet published any data, get returns { :error , :not_found }","ref":"Scenic.PubSub.html#query/1"},{"type":"function","title":"Scenic.PubSub.register/2","doc":"Register the calling process as a data source for the named id. Parameters source_id the data source being registered. opts optional information about the data source. Supported options: :version ( String.t/0 ) - Data format version :description ( String.t/0 ) - Your appropriate description Return Value On success, returns {:ok, source_id} If source_id is already registered to another process, it returns { :error , :already_registered }","ref":"Scenic.PubSub.html#register/2"},{"type":"function","title":"Scenic.PubSub.subscribe/1","doc":"Subscribe the calling process to receive events about a data source. The messages the subscriber will start receiving about a data source are: event message sent to subscribers data published {{Scenic.PubSub, :data}, {source_id, value, timestamp}} source registered {{Scenic.PubSub, :registered}, {source_id, opts}} source unregistered {{Scenic.PubSub, :unregistered}, source_id} Parameters source_id an atom that is registered to a data source. Return Value On success, returns :ok","ref":"Scenic.PubSub.html#subscribe/1"},{"type":"function","title":"Scenic.PubSub.unregister/1","doc":"Unregister the calling process as a data source for a data source. Parameters source_id the data source being registered. Return Value Returns :ok","ref":"Scenic.PubSub.html#unregister/1"},{"type":"function","title":"Scenic.PubSub.unsubscribe/1","doc":"Unsubscribe the calling process from receive events about a data source. The caller will stop receiving events about a data source Parameters source_id an atom that is registered to a data source. Return Value Returns :ok","ref":"Scenic.PubSub.html#unsubscribe/1"},{"type":"behaviour","title":"Scenic.Scene","doc":"Overview Scenes are the core of the UI model. A Scene is a type of GenServer that maintains state, handles input, events and other messages, and plays a role managing the supervision of components/controls such as buttons and other input. A brief aside Before saying anything else I want to emphasize that the rest of your application, meaning device control logic, sensor reading / writing, services, whatever, does not need to have anything to do with Scenes. In many cases I recommend treating those as separate GenServers in their own supervision trees that you maintain. Then your Scenes would query or send information to/from them via cast or call messages. Part of the point of using Elixir/Erlang/OTP is separating this sort of logic into independent trees. That way, an error in one part of your application does not mean the rest of it will fail. Scenes Scenes are the core of the UI model. A scene consists of one or more graphs, and a set of event handlers and filters to deal with user input and other messages. Think of a scene as being a little like an HTML page. HTML pages have: Structure (the DOM) Logic (Javascript) Links to other pages. A Scene has: Structure (graphs), Logic (event handlers and filters) Transitions to other scenes. Well... it can request the ViewPort to go to a different scene. Your application is a collection of scenes that are in use at different times. There is only ever one scene showing in a ViewPort at a given time. However, scenes can instantiate components, effectively embedding their graphs inside the main one. More on that below. Graphs Each scene should maintain at least one graph. You can build graphs at compile time, or dynamically while your scene is running. Building them at compile time has two advantages Performance: It is clearly faster to build the graph once during build time than to build it repeatedly during runtime. Error checking: If your graph has an error in it, it is much better to have it stop compilation than cause an error during runtime. Example of building a graph during compile time: @graph Scenic.Graph . build ( font_size : 24 ) |&gt; button ( { &quot;Press Me&quot; , :button_id } , translate : { 20 , 20 } ) Rather than having a single scene maintain a massive graph of UI, graphs can reference graphs in other scenes. On a typical screen of UI, there is one scene that is the root. Each control, is its own scene process with its own state. These child scenes can in turn contain other child scenes. This allows for strong code reuse, isolates knowledge and logic to just the pieces that need it, and keeps the size of any given graph to a reasonable size. For example, the handlers of a check-box scene don't need to know anything about how a slider works, even though they are both used in the same parent scene. At best, they only need to know that they both conform to the Component.Input behavior, and can thus query or set each others value. Though it is usually the parent scene that does that. The application developer is responsible for building and maintaining the scene's graph. It only enters the world of the ViewPort when you call push_graph . Once you have called push_graph , that graph is sent to the drivers and is out of your immediate control. You update that graph by calling push_graph again. Scene Structure The overall structure of a scene has several parts. It is a GenServer , which means you have an input function and can implement the GenServer callbacks such as handle_info/2 , handle_cast/2 , handle_call/3 and any others. The terms you return from those callbacks is pretty much what you expect with the requirement that the state is always a scene structure. The init/3 callback takes 3 parameters. They are the scene structure (state), params that the parent scene set up, and opts, which includes things like the id, theme, and some styles that were set on the scene. There are several additional callbacks that your scene can support. The main ones are handle_input/2 , and handle_event/3 . If you are making a Component (a reusable scene), then there are additional callbacks that allow it to play nicely with others. Scene Example This example shows a simple scene that contains a button. When the button is clicked, the scene increments a counter and displays the number of clicks it has received. defmodule MySimpleScene do use Scenic.Scene alias Scenic.Graph import Scenic.Primitives import Scenic.Components @initial_count 0 # This graph is built at compile time so it doesn&#39;t do any work at runtime. # It could also be built in the init function (or any other) if you want # it to be dynamic based on the params or whatever. @graph Graph . build ( ) |&gt; group ( fn graph -&gt; graph |&gt; text ( &quot;Count: &quot; &lt;&gt; inspect ( @initial_count ) , id : :count ) |&gt; button ( &quot;Click Me&quot; , id : :btn , translate : { 0 , 30 } ) end , translate : { 100 , 100 } ) # Simple function to return @graph. # @graph is built at compile time and stored directly in the BEAM file every # time it is used. A simple accessor function will cause it to be stored only once. # Do this when you build graphs at compile time to save space in your file. defp graph ( ) , do : @graph # The Scenic.Scene init function @impl Scenic.Scene def init ( scene , _params , _opts ) do scene = scene |&gt; assign ( count : @initial_count ) |&gt; push_graph ( graph ( ) ) { :ok , scene } end @impl Scenic.Scene def handle_event ( { :click , :btn } , _ , %{ assigns : %{ count : count } } = scene ) do count = count + 1 # modify the graph to show the current click count graph = graph ( ) |&gt; Graph . modify ( :count , &amp; text ( &amp;1 , &quot;Count: &quot; &lt;&gt; inspect ( count ) ) ) # update the count and push the modified graph scene = scene |&gt; assign ( count : count ) |&gt; push_graph ( graph ) # return the updated scene { :noreply , scene } end end Scene State Scenes are just a specialized form of GenServer . This means they can react to messages and can have state. However, scene state is a bit like socket state in Phoenix in that It has a strict format, but you can add anything you want into its :assigns map. Multiple Graphs Any given scene can maintain multiple graphs and multiple draw scripts. They are identified from each other with an id that you attach. Normally when you use push_graph, you don't attach an ID. In that case the scene's id is used as the graph id. The act of pushing a graph to the ViewPort causes it to be compiled into a script, which is stored in an ETS table so that the drivers can quickly access it. To use a second, or third, graph that you scene has pushed, refer to it using a Scenic.Primitive.Script primitive. def init ( scene , param , opts ) do second_graph = Scenic.Graph . build ( ) |&gt; text ( &quot;Text in the second graph&quot; ) main_graph = Scenic.Graph . build ( ) |&gt; script ( &quot;my_fancy_id&quot; ) scene = scene |&gt; push_graph ( main_graph ) |&gt; push_graph ( second_graph , &quot;my_fancy_id&quot; ) { :ok , scene } end Note that it doesn't matter which graph you push first. They will link to each other via the string id that you supply. Communications Scenes are specialized GenServers. As such, they communicate with each other (and the rest of your application) through messages. You can receive messages with the standard handle_info , handle_cast , handle_call callbacks just like any other scene. Scenes have two new event handling callbacks that you can optionally implement. These are about user input vs UI events. Input vs. Events Input is data generated by the drivers and sent up to the scenes through Scenic.ViewPort . There is a limited set of input types and they are standardized so that the drivers can be built independently of the scenes. Input follows certain rules about which scene receives them. Events are messages that one scene generates for consumption by other scenes. For example, a Scenic.Component.Button scene would generate a {:click, msg} event that is sent to its parent scene. You can generate any message you want, however, the standard component libraries follow certain patterns to keep things sensible. Input Handling You handle incoming input events by adding handle_input/3 callback functions to your scene. Each handle_input/3 call passes in the input message itself, an input context struct, and your scene's state. You can then take the appropriate actions, including generating events (below) in response. Under normal operation, input that is not position dependent (keys, window events, more...) is sent to the root scene. Input that does have a screen position (cursor_pos, cursor button presses, etc.) is sent to the scene that contains the graph that was hit. Your scene can &quot;capture&quot; all input of a given type so that it is sent to itself instead of the default scene for that type. this is how a text input field receives the key input. First, the user selects that field by clicking on it. In response to the cursor input, the text field captures text input (and maybe transforms its graph to show that it is selected). Captured input types should be released when no longer needed so that normal operation can resume. The input messages are passed on to a scene's parent if not processed. Event Filtering In response to input, (or anything else... a timer perhaps?), a scene can generate an event (any term), which is sent backwards up the tree of scenes that make up the current aggregate graph. In this way, a Scenic.Component.Button scene can generate a {:click, msg} event that is sent to its parent. If the parent doesn't handle it, it is sent to that scene's parent. And so on until the event reaches the root scene. If the root scene also doesn't handle it then the event is dropped. To handle events, you add handle_event/3 functions to your scene. This function handles the event, and stops its progress backwards up the graph. It can handle it and allow it to continue up the graph. Or it can transform the event and pass the transformed version up the graph. You choose the behavior by returning either { :cont , msg , state } or { :halt , state } Parameters passed in to handle_event/3 are the event itself, a reference to the originating scene (which you can to communicate back to it), and your scene's state. A pattern I'm using is to handle an event at the filter and stop its progression. It also generates and sends a new event to its parent. I do this instead of transforming and continuing when I want to change the originating scene. No children There is an optimization you can use. If you know for certain that your component will not attempt to use any components, you can set has_children to false like this. use Scenic.Component , has_children : false Setting has_children to false means the scene won't create a dynamic supervisor for this scene, which saves some resources and imporoves startup time. For example, the Button component sets has_children to false .","ref":"Scenic.Scene.html"},{"type":"function","title":"Scenic.Scene.assign/2","doc":"Convenience function to assign a list or map of values into a scene struct.","ref":"Scenic.Scene.html#assign/2"},{"type":"function","title":"Scenic.Scene.assign/3","doc":"Convenience function to assign a value into a scene struct.","ref":"Scenic.Scene.html#assign/3"},{"type":"function","title":"Scenic.Scene.assign_new/2","doc":"Convenience function to assign a list of new values into a scene struct. Only values that do not already exist will be assigned","ref":"Scenic.Scene.html#assign_new/2"},{"type":"function","title":"Scenic.Scene.assign_new/3","doc":"Convenience function to assign a new values into a scene struct. The value will only be assigned if it does not already exist in the struct.","ref":"Scenic.Scene.html#assign_new/3"},{"type":"function","title":"Scenic.Scene.capture_input/2","doc":"Request one or more types of input that a scene would otherwise not receive if not captured. This is rarely used by scenes and even then mostly for things like key events outside of a text field. Any input types that were previously requested that are no longer in the request list are dropped. Request [] to cancel all input requests. returns :ok or an error This is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#capture_input/2"},{"type":"function","title":"Scenic.Scene.cast_children/2","doc":"","ref":"Scenic.Scene.html#cast_children/2"},{"type":"function","title":"Scenic.Scene.cast_parent/2","doc":"Cast a message to a scene's parent","ref":"Scenic.Scene.html#cast_parent/2"},{"type":"function","title":"Scenic.Scene.child/2","doc":"Get the pid of the child with the specified id. You can specify the same ID to more than one child. This is why the return is a list.","ref":"Scenic.Scene.html#child/2"},{"type":"function","title":"Scenic.Scene.children/1","doc":"Get a list of {id, pid} pairs for all the scene's children.","ref":"Scenic.Scene.html#children/1"},{"type":"function","title":"Scenic.Scene.fetch/2","doc":"Convenience function to fetch an assigned value out of a scene struct.","ref":"Scenic.Scene.html#fetch/2"},{"type":"function","title":"Scenic.Scene.fetch_captures/1","doc":"Fetch a list of input captured by the given scene. This is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#fetch_captures/1"},{"type":"function","title":"Scenic.Scene.fetch_child/2","doc":"Fetch the &quot;data&quot; of the child with the specified id. This function is intended to be used to query the current data of a component. The component must have implemented the Scenic.Scene.handle_fetch/2 callback. All of the built-in components support this. Unlike get_child , fetch_child returns the full data associated with component, not just the current value. For example a checkbox component might fetch the value {&quot;My Checkbox&quot;, true} You can specify the same ID to more than one child. This is why the return is a list.","ref":"Scenic.Scene.html#fetch_child/2"},{"type":"function","title":"Scenic.Scene.fetch_requests/1","doc":"Fetch a list of input requested by the given scene. This is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#fetch_requests/1"},{"type":"function","title":"Scenic.Scene.fetch_transform/1","doc":"Fetch the &quot;parent&quot; matrix that positions this scene. This matrix can be used to move from scene &quot;local&quot; coordinates to global coordinates.","ref":"Scenic.Scene.html#fetch_transform/1"},{"type":"function","title":"Scenic.Scene.get/3","doc":"Convenience function to get an assigned value out of a scene struct.","ref":"Scenic.Scene.html#get/3"},{"type":"function","title":"Scenic.Scene.get_child/2","doc":"Get the &quot;value&quot; of the child with the specified id. This function is intended to be used to query the current value of a component. The component must have implemented the Scenic.Scene.handle_get/2 callback. All of the built-in components support this. For example, you could use this to query the current value of a checkbox. You can specify the same ID to more than one child. This is why the return is a list.","ref":"Scenic.Scene.html#get_child/2"},{"type":"function","title":"Scenic.Scene.get_transform/1","doc":"Get the &quot;parent&quot; matrix that positions this scene. This matrix can be used to move from scene &quot;local&quot; coordinates to global coordinates.","ref":"Scenic.Scene.html#get_transform/1"},{"type":"function","title":"Scenic.Scene.global_to_local/2","doc":"Convert a point in global coordinates to scene local coordinates.","ref":"Scenic.Scene.html#global_to_local/2"},{"type":"function","title":"Scenic.Scene.handle_call/3","doc":"","ref":"Scenic.Scene.html#handle_call/3"},{"type":"callback","title":"Scenic.Scene.handle_event/3","doc":"Invoked when the Scene receives an event from another scene. Events are messages generated by a scene, that are passed backwards up the ViewPort's scene supervision tree. This is opposed to &quot;input&quot;, which comes directly from the drivers. When an event arrives at a scene, you can consume it, or pass it along to the scene above you in the ViewPort's supervision structure. To consume the input and have processing stop afterward, return either a {:halt, ...} or {:noreply, ...} value. They are effectively the same thing. To allow the scene's parent to process the input, return {:cont, event, state, ...} . Note that you can pass along the event unchanged or transform it in the process if you wish. The callback supports all the return values of the init callback in Genserver . In addition to the normal return values defined by GenServer, a Scene can add an optional {push: graph} term, which pushes the graph to the viewport. This has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:handle_event/3"},{"type":"callback","title":"Scenic.Scene.handle_fetch/2","doc":"Retrieve the current data associated with the scene and return it to the caller. If this callback is not implemented, the caller with get an {:error, :not_implemented}.","ref":"Scenic.Scene.html#c:handle_fetch/2"},{"type":"callback","title":"Scenic.Scene.handle_get/2","doc":"Get the current &quot;value&quot; associated with the scene and return it to the caller. If this callback is not implemented, the caller with receive nil.","ref":"Scenic.Scene.html#c:handle_get/2"},{"type":"callback","title":"Scenic.Scene.handle_input/3","doc":"Invoked when the Scene receives input from a driver. Input is messages sent directly from a driver, usually based on some action by the user. This is opposed to &quot;events&quot;, which are generated by other scenes. When input arrives at a scene, you can consume it, or pass it along to the scene above you in the ViewPort's supervision structure. To consume the input and have processing stop afterward, return either a {:halt, ...} or {:noreply, ...} value. They are effectively the same thing. To allow the scene's parent to process the input, return {:cont, input, state, ...} . Note that you can pass along the input unchanged or transform it in the process if you wish. The callback supports all the return values of the init callback in Genserver . In addition to the normal return values defined by GenServer, a Scene can add an optional {push: graph} term, which pushes the graph to the viewport. This has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:handle_input/3"},{"type":"callback","title":"Scenic.Scene.handle_put/2","doc":"Put the current &quot;value&quot; associated with the scene . Does nothing if this callback is not implemented.","ref":"Scenic.Scene.html#c:handle_put/2"},{"type":"callback","title":"Scenic.Scene.handle_update/3","doc":"Update the data and options of a scene. Usually implemented by Components. If this callback is not implemented, then changes to the component in the parent's graph will have no affect.","ref":"Scenic.Scene.html#c:handle_update/3"},{"type":"callback","title":"Scenic.Scene.init/3","doc":"Invoked when the Scene is started. args is the argument term you passed in via config or ViewPort.set_root. options is a list of information giving you context about the environment the scene is running in. If an option is not in the list, then it should be treated as nil. :viewport - This is the pid of the ViewPort that is managing this dynamic scene. It will be not set, or nil, if you are managing the Scene in a static supervisor yourself. :styles - This is the map of styles that your scene can choose to inherit (or not) from its parent scene. This is typically used by a child control that wants to visually fit into its parent's look. :id - This is the :id term that the parent set a component when it was invoked. The callback supports all the return values of the init callback in Genserver . In addition to the normal return values defined by GenServer, a Scene can return two new ones that push a graph to the viewport Returning {:ok, state, push: graph} will push the indicated graph to the ViewPort. This is preferable to the old push_graph() function.","ref":"Scenic.Scene.html#c:init/3"},{"type":"function","title":"Scenic.Scene.local_to_global/2","doc":"Convert a point in scene local coordinates to global coordinates.","ref":"Scenic.Scene.html#local_to_global/2"},{"type":"function","title":"Scenic.Scene.parent/1","doc":"Get the pid of the scene's parent.","ref":"Scenic.Scene.html#parent/1"},{"type":"function","title":"Scenic.Scene.push_graph/3","doc":"Push a graph to the scene's ViewPort. This function compiles a graph into a script, registers any requested inputs and stores it all in the ViewPort's ETS tables. Any components that are created or removed from the scene are started/stopped/updated as appropriate.","ref":"Scenic.Scene.html#push_graph/3"},{"type":"function","title":"Scenic.Scene.push_script/4","doc":"Push a named script to the scene's ViewPort.","ref":"Scenic.Scene.html#push_script/4"},{"type":"function","title":"Scenic.Scene.put_child/3","doc":"Put the &quot;value&quot; of the child with the specified id. This function is intended to be used to change the current value of a component. The component must have implemented the Scenic.Scene.handle_put/2 callback. All of the built-in components support this. For example, you could use this to change the current value of a checkbox. In this case, the returned value would be true or false . You can specify the same ID to more than one child. This will cause all the components with that id to receive the handle_put call.","ref":"Scenic.Scene.html#put_child/3"},{"type":"function","title":"Scenic.Scene.release_input/2","doc":"release all currently requested input. This is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#release_input/2"},{"type":"function","title":"Scenic.Scene.request_input/2","doc":"Request one or more types of input that a scene would otherwise not receive if not captured. This is rarely used by scenes and even then mostly for things like key events outside of a text field. Any input types that were previously requested that are no longer in the request list are dropped. Request [] to cancel all input requests. returns :ok or an error This is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#request_input/2"},{"type":"function","title":"Scenic.Scene.send_children/2","doc":"Cast a message to a scene's children","ref":"Scenic.Scene.html#send_children/2"},{"type":"function","title":"Scenic.Scene.send_event/2","doc":"Send an event message to a specific scene","ref":"Scenic.Scene.html#send_event/2"},{"type":"function","title":"Scenic.Scene.send_parent/2","doc":"Send a message to a scene's parent","ref":"Scenic.Scene.html#send_parent/2"},{"type":"function","title":"Scenic.Scene.send_parent_event/2","doc":"Send an event message to a scene's parent","ref":"Scenic.Scene.html#send_parent_event/2"},{"type":"function","title":"Scenic.Scene.stop/1","doc":"Cleanly stop a scene from running","ref":"Scenic.Scene.html#stop/1"},{"type":"function","title":"Scenic.Scene.terminate/2","doc":"","ref":"Scenic.Scene.html#terminate/2"},{"type":"function","title":"Scenic.Scene.unrequest_input/2","doc":"release all currently requested input. This is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#unrequest_input/2"},{"type":"function","title":"Scenic.Scene.update_child/4","doc":"Update the &quot;data&quot; of the child with the specified id. This function is intended to be used to update the current data of a component. The component must have implemented the Scenic.Scene.handle_update/3 callback. All of the built-in components support this. Unlike put_child , update_child effectively re-initializes the component with the new data. This would be the same data format you have provided when you created the component in the first place. For example, you might update a checkbox component with the value {&quot;New Label&quot;, true} You can specify the same ID to more than one child. This will cause all the components with that id to receive the handle_put call.","ref":"Scenic.Scene.html#update_child/4"},{"type":"type","title":"Scenic.Scene.response_opts/0","doc":"","ref":"Scenic.Scene.html#t:response_opts/0"},{"type":"type","title":"Scenic.Scene.t/0","doc":"","ref":"Scenic.Scene.html#t:t/0"},{"type":"module","title":"Scenic.Script","doc":"Overview Scenic.Script is the fundamental &quot;rendering&quot; data structure for Scenic. Prior to v0.11, drivers received Graphs from the ViewPort and were responsible for transforming them into a list of drawing commands that would ultimately draw the actual picture that is displayed as the Scenic UI. After some experience, it became apparent that this was a common task for almost all drivers and has been moved into the ViewPort and formalized in Scenic.Script. Simply put, Scenic.Script produces a list of static drawing commands that are sent, unmodified, to the drivers through the ViewPort. These scripts are generated for you when you use Scenic.Scene.push_graph/3 , or you can create them yourself by using this api. If you use Scenic.Script directly, you can create more complicated and/or reusable graphics than you could by using Graphs alone. Update Isolation Another way to use scripts is to separate large static bits of a graph from that which changes frequently. When a graph is pushed to the ViewPort, the entire thing is compiled into a script, which is sent as a whole to the Drivers. However if that graph references a script, only the reference to the script is sent, not the contents of the script. This means you can modify the graph frequently without sending the contents of the scripts. The opposite is also true. You can generate and push the scripts frequently without causing the graphs that reference them to be recompiled or resent. An example of this might be a graph that implements a chart of some sort. The contents of the chart could be a script that is updated as new data comes in without needing all the chrome around it to be recompiled or sent for every update. API Patterns This is a large module with many functions. Most of them are very small, however and simply add individual commands to the script. The general pattern is that you start by calling Scenic.Script.start(). This simply returns an empty list. Each drawing api adds an element to the head of the list. Then you end with Scenic.Script.finsh(), which reverses the list and performs some optimizations on it. alias Scenic.Script my_script = Script . start ( ) |&gt; Script . text ( &quot;A very simple script&quot; ) |&gt; Script . finish ( ) After the script is generated, you publish it to the ViewPort through either your scene's helper api Scenic.Scene.push_script/4 or directly throught the ViewPort api Scenic.ViewPort.put_script/4 Finally, to get the script to draw, you need to reference it from a graph. my_graph = Graph . build ( ) |&gt; script ( &quot;my_script_name&quot; ) It doesn't matter if you push the script before or after you push the graph that references it. scene = scene |&gt; push_script ( my_script , &quot;my_script_name&quot; ) |&gt; push_graph ( my_graph ) Example: the Checkbox check mark The canonical example is the checkmark symbol used in the Checkbox component. This is two lines, with rounded endpoints and rounded joint between them. It could be described using a Path primitive, but there is no need to send its instructions every time it is shown or hidden since its shape doesn't actually change. The Checkbox component creates and publishes this script using something very similar to the following example. alias Scenic.Script # build the checkmark script chx_script = Script . start ( ) |&gt; Script . push_state ( ) |&gt; Script . join ( :round ) |&gt; Script . stroke_width ( @border_width + 1 ) |&gt; Script . stroke_color ( theme . thumb ) |&gt; Script . begin_path ( ) |&gt; Script . move_to ( 0 , 8 ) |&gt; Script . line_to ( 5 , 13 ) |&gt; Script . line_to ( 12 , 1 ) |&gt; Script . stroke_path ( ) |&gt; Script . pop_state ( ) |&gt; Script . finish ( ) chx_id = scene . id &lt;&gt; &quot;_chk&quot; scene = push_script ( scene , chx_script , chx_id ) Building and using a custom script happens in three parts. First, the script itself is created using the Scenic.Script api. Then the script is published to the ViewPort using Scenic.Scene.push_script/4 with a unique name. Later, the graph for the checkbox references this script, which is what triggers it to be drawn. graph = Graph . build ( ) |&gt; script ( chx_id , id : :chx , hidden : ! checked? ) Script State The underlying rendering engine that consumes these scripts and draws the actual pictures maintains a set of current drawing state, which can be pushed and popped from a stack via the push_state/1 , pop_state/1 , and pop_push_state/1 apis. These functions are analogous to the state save/restore APIs in Canvas . Transforms Transforms are applied to the running script by multiplying matrices together. This is very similar to how games position elements of UI. It takes a little getting used to, but is very powerful. If you want to unroll the most recent applied transform, you should push then pop the state to get back to the previous transform stack. Binary Format The serialize/3 and deserialize/1 go back and forth from the list format to a binary representation of the script. The serialize/3 function produces an IO list, and deserialize goes back into a list of instructions. There is a standard format to the binary, but that needs to be independently documented. You can dig into the code behind serialize/3 to see it in action. Drivers, which normally do the serialization call, can intercept/override any command if they need something specific.","ref":"Scenic.Script.html"},{"type":"function","title":"Scenic.Script.arc_to/6","doc":"Add an arc segment to the path using the control points and radius. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#arc_to/6"},{"type":"function","title":"Scenic.Script.begin_path/1","doc":"Begin a new path.","ref":"Scenic.Script.html#begin_path/1"},{"type":"function","title":"Scenic.Script.bezier_to/7","doc":"Add a bezier curve segment to the path using the control points. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#bezier_to/7"},{"type":"function","title":"Scenic.Script.cap/2","doc":"Set the current end cap style. Can be any one of :butt , :round , or :square","ref":"Scenic.Script.html#cap/2"},{"type":"function","title":"Scenic.Script.circle/2","doc":"Add a circle to the current path. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#circle/2"},{"type":"function","title":"Scenic.Script.clear/2","doc":"Erase the entire drawing field output. The clear/1 function is equivalent to setting a color, creating a new rect path that covers the entire draw field, then filling it. clear/1 does all this in a single, compact script command.","ref":"Scenic.Script.html#clear/2"},{"type":"function","title":"Scenic.Script.close_path/1","doc":"Close the current path. This effectively adds a line segment from the current draw position back to where the path was started.","ref":"Scenic.Script.html#close_path/1"},{"type":"function","title":"Scenic.Script.deserialize/1","doc":"Transform a binary or io list into a readable script list. This is intended to help with debugging. Deserialization will only work for scripts serialized using the standard, un-hooked format.","ref":"Scenic.Script.html#deserialize/1"},{"type":"function","title":"Scenic.Script.draw_arc/4","doc":"Draw an arc defined by radius and an angle. Can be filled or stroked. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_arc/4"},{"type":"function","title":"Scenic.Script.draw_circle/3","doc":"Draw a circle defined by a radius. Can be filled or stroked. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_circle/3"},{"type":"function","title":"Scenic.Script.draw_ellipse/4","doc":"Draw an ellipse defined by two radii. Can be filled or stroked. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_ellipse/4"},{"type":"function","title":"Scenic.Script.draw_flag/1","doc":"draw_flag is a helper function to choose the appropriate fill and/or stroke flag given a map of styles.","ref":"Scenic.Script.html#draw_flag/1"},{"type":"function","title":"Scenic.Script.draw_line/6","doc":"Draw a line from a start point to a finish point. Can only be stroked. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_line/6"},{"type":"function","title":"Scenic.Script.draw_quad/10","doc":"Draw a quad defined by four points. Can be filled or stroked. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_quad/10"},{"type":"function","title":"Scenic.Script.draw_rectangle/4","doc":"Draw a rectangle defined by height and width. Can be filled or stroked. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_rectangle/4"},{"type":"function","title":"Scenic.Script.draw_rounded_rectangle/5","doc":"Draw a rounded rectangle defined by height, width, and radius. Can be filled or stroked. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_rounded_rectangle/5"},{"type":"function","title":"Scenic.Script.draw_sector/4","doc":"Draw a sector defined by radius and an angle. Can be filled or stroked. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_sector/4"},{"type":"function","title":"Scenic.Script.draw_sprites/3","doc":"Draw a collection of sprites. Draws one or more subsection from a single source image.","ref":"Scenic.Script.html#draw_sprites/3"},{"type":"function","title":"Scenic.Script.draw_text/2","doc":"Draw a a block of text. Can be filled. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_text/2"},{"type":"function","title":"Scenic.Script.draw_text/3","doc":"Draw a a block of text with automatic new lines. Can be filled. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_text/3"},{"type":"function","title":"Scenic.Script.draw_triangle/8","doc":"Draw a triangle defined by three points. Can be filled or stroked. Creates a new path and draws it.","ref":"Scenic.Script.html#draw_triangle/8"},{"type":"function","title":"Scenic.Script.ellipse/3","doc":"Add an ellipse to the current path. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#ellipse/3"},{"type":"function","title":"Scenic.Script.fill_color/2","doc":"Set the current fill to an single color. This only sets the fill paint type. You still need to call fill_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_color/2"},{"type":"function","title":"Scenic.Script.fill_image/2","doc":"Set the current fill to an image from the Static asset library. This image will be automatically repeated both horizontally and vertically. This only sets the fill paint type. You still need to call fill_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_image/2"},{"type":"function","title":"Scenic.Script.fill_linear/7","doc":"Set the current fill to linear gradient that goes between two colors. This only sets the fill paint type. You still need to call fill_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_linear/7"},{"type":"function","title":"Scenic.Script.fill_path/1","doc":"Fill the current path with the currently selected fill paint.","ref":"Scenic.Script.html#fill_path/1"},{"type":"function","title":"Scenic.Script.fill_radial/7","doc":"Set the current fill to radial gradient that goes between two colors. This only sets the fill paint type. You still need to call fill_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_radial/7"},{"type":"function","title":"Scenic.Script.fill_stream/2","doc":"Set the current fill to an image from an asset stream. This image will be automatically repeated both horizontally and vertically. This only sets the fill paint type. You still need to call fill_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_stream/2"},{"type":"function","title":"Scenic.Script.finish/1","doc":"Finish a script, preparing it to be sent to the ViewPort. This function cleans up the script, which should have been created by first calling start/0 then and series of calls to Scenic.Script functions that add commands to the script. finish/1 cleans up the script, reverses it, and runs an optimization pass. The resulting script is ready to be stored in the ViewPort.","ref":"Scenic.Script.html#finish/1"},{"type":"function","title":"Scenic.Script.font/2","doc":"Set the current font. Must be a valid reference into your static assets library.","ref":"Scenic.Script.html#font/2"},{"type":"function","title":"Scenic.Script.font_size/2","doc":"Set the current font size.","ref":"Scenic.Script.html#font_size/2"},{"type":"function","title":"Scenic.Script.join/2","doc":"Set the current line joint style. Can be any one of :bevel , :round , or :miter","ref":"Scenic.Script.html#join/2"},{"type":"function","title":"Scenic.Script.line_to/3","doc":"Add a new line segment from the current position to a specified location. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#line_to/3"},{"type":"function","title":"Scenic.Script.media/1","doc":"Extract a map of all the media (both static assets and streams) used in a script.","ref":"Scenic.Script.html#media/1"},{"type":"function","title":"Scenic.Script.miter_limit/2","doc":"Set the current miter limit for joints.","ref":"Scenic.Script.html#miter_limit/2"},{"type":"function","title":"Scenic.Script.move_to/3","doc":"Move the current draw position without adding a line segment.","ref":"Scenic.Script.html#move_to/3"},{"type":"function","title":"Scenic.Script.pop_push_state/1","doc":"Reverts the style/transform state of the script then immediately pushes it again. pop_push_state/1 is for when you have made changes that you want to revert, but then know you are going to make more changes that you revert again. This is functionally equivalent to calling pop_state/1 followed immediately by push_state/1 , except that it is done as a single operation in the script instead of two. This saves drawtime compute and makes the script smaller. Any adjacent pop/push pairs in the script will be converted to pop_push in the optimization phase of the finish/1 function. pop_push_state/1 must be preceded with either push_state/1 and followed by either pop_state/1 or another pop_push_state/1","ref":"Scenic.Script.html#pop_push_state/1"},{"type":"function","title":"Scenic.Script.pop_state/1","doc":"Reverts the style/transform state of the script to the most recently pushed state. This function restores the style and transform states from a stack of states. The idea is that you can make changes, then &quot;pop&quot; back to where the state was before. push_state/1 must be preceded with either push_state/1 or pop_push_state/1","ref":"Scenic.Script.html#pop_state/1"},{"type":"function","title":"Scenic.Script.push_state/1","doc":"Saves the current style/transform state of the script as it is running. This function saves the current style and transform states in a stack of states. The idea is that you can make changes, then &quot;pop&quot; back to where the state was before. push_state/1 must be paired with an eventual pop_state/1 or pop_push_state/1","ref":"Scenic.Script.html#push_state/1"},{"type":"function","title":"Scenic.Script.quad/9","doc":"Add a quad to the current path. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#quad/9"},{"type":"function","title":"Scenic.Script.quadratic_to/5","doc":"Add a quadratic curve segment to the path using the control points. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#quadratic_to/5"},{"type":"function","title":"Scenic.Script.rectangle/3","doc":"Add a rectangle to the current path. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#rectangle/3"},{"type":"function","title":"Scenic.Script.render_script/2","doc":"Recursively draw a script by reference. This adds a command that pauses the current script being rendered and recursively draws another script that is referenced by id. The new script being drawn starts with the currently set draw state and the current state is automatically restored with the script is completed. Then the current script continues drawing.","ref":"Scenic.Script.html#render_script/2"},{"type":"function","title":"Scenic.Script.rotate/2","doc":"Apply a rotation transform to the current transform stack.","ref":"Scenic.Script.html#rotate/2"},{"type":"function","title":"Scenic.Script.rounded_rectangle/4","doc":"Add a rounded rectangle to the current path. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#rounded_rectangle/4"},{"type":"function","title":"Scenic.Script.scale/3","doc":"Apply a scale transform to the current transform stack.","ref":"Scenic.Script.html#scale/3"},{"type":"function","title":"Scenic.Script.scissor/3","doc":"Set the current scissor rect. To remove the scissor rect, push the state before you use the scissor, then pop it afterwards.","ref":"Scenic.Script.html#scissor/3"},{"type":"function","title":"Scenic.Script.sector/3","doc":"Add a sector to the current path. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#sector/3"},{"type":"function","title":"Scenic.Script.serialize/1","doc":"Transform a script list into a binary IO list. Usually called from a driver. Returns an IO list. with { :ok , script } &lt;- ViewPort . get_script_by_id ( vp , &quot;my_script_id&quot; ) do Scenic.Script . serialize ( script ) |&gt; my_render_function ( ) end There are times when a driver will want to customize the serialization. For example, GLFW driver wants fixed width names for the streams. So it hooks the serialization of certain commands. io_list = Script . serialize ( script , fn { :font , id } -&gt; my_serialize_font ( id ) { :fill_stream , id } -&gt; my_serialize_fill_stream ( id ) { :stroke_stream , id } -&gt; my_serialize_stroke_stream ( id ) other -&gt; other end","ref":"Scenic.Script.html#serialize/1"},{"type":"function","title":"Scenic.Script.serialize/2","doc":"Transform a script list into a binary IO list with a map like interceptor function. Usually called from a driver. Returns an IO list. with { :ok , script } &lt;- ViewPort . get_script ( vp , id ) do io_list = Script . serialize ( script , fn { :font , id } -&gt; my_serialize_font ( id ) { :fill_stream , id } -&gt; my_serialize_fill_stream ( id ) { :stroke_stream , id } -&gt; my_serialize_stroke_stream ( id ) other -&gt; other end ) end","ref":"Scenic.Script.html#serialize/2"},{"type":"function","title":"Scenic.Script.serialize/3","doc":"Transform a script list into a binary IO list with a map_reduce like interceptor function. Usually called from a driver. Returns an IO list. { io_list , count } = Script . serialize ( script , 0 , fn { :font , id } , c -&gt; { my_serialize_font ( id ) , c + 1 } { :fill_stream , id } , c -&gt; { my_serialize_fill_stream ( id ) , c + 1 } { :stroke_stream , id } , c -&gt; { my_serialize_stroke_stream ( id ) , c + 1 } other , c -&gt; { other , c + 1 } end )","ref":"Scenic.Script.html#serialize/3"},{"type":"function","title":"Scenic.Script.start/0","doc":"Create a new Script.","ref":"Scenic.Script.html#start/0"},{"type":"function","title":"Scenic.Script.stroke_color/2","doc":"Set the current stroke to an single color. This only sets the stroke paint type. You still need to call stroke_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_color/2"},{"type":"function","title":"Scenic.Script.stroke_image/2","doc":"Set the current stroke to an image from the Static asset library. This image will be automatically repeated both horizontally and vertically. This only sets the stroke paint type. You still need to call stroke_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_image/2"},{"type":"function","title":"Scenic.Script.stroke_linear/7","doc":"Set the current stroke to linear gradient that goes between two colors. This only sets the stroke paint type. You still need to call stroke_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_linear/7"},{"type":"function","title":"Scenic.Script.stroke_path/1","doc":"Stroke the current path with the currently selected stroke width/paint.","ref":"Scenic.Script.html#stroke_path/1"},{"type":"function","title":"Scenic.Script.stroke_radial/7","doc":"Set the current stroke to radial gradient that goes between two colors. This only sets the stroke paint type. You still need to call stroke_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_radial/7"},{"type":"function","title":"Scenic.Script.stroke_stream/2","doc":"Set the current stroke to an image from an asset stream. This image will be automatically repeated both horizontally and vertically. This only sets the stroke paint type. You still need to call stroke_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_stream/2"},{"type":"function","title":"Scenic.Script.stroke_width/2","doc":"Set the current stroke width. This only sets the stroke sidth. You still need to call stroke_path/1 or one of the draw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_width/2"},{"type":"function","title":"Scenic.Script.text_align/2","doc":"Set the current horizontal text alignment. Can be any one of :left , :right , or :center","ref":"Scenic.Script.html#text_align/2"},{"type":"function","title":"Scenic.Script.text_base/2","doc":"Set the current vertical text alignment. Can be any one of :top , :middle , :alphabetic , or :bottom","ref":"Scenic.Script.html#text_base/2"},{"type":"function","title":"Scenic.Script.transform/7","doc":"Apply an arbitrary transform to the current transform stack.","ref":"Scenic.Script.html#transform/7"},{"type":"function","title":"Scenic.Script.translate/3","doc":"Apply a translation transform to the current transform stack.","ref":"Scenic.Script.html#translate/3"},{"type":"function","title":"Scenic.Script.triangle/7","doc":"Add a triangle to the current path. This adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#triangle/7"},{"type":"type","title":"Scenic.Script.fill_stroke/0","doc":"","ref":"Scenic.Script.html#t:fill_stroke/0"},{"type":"type","title":"Scenic.Script.id/0","doc":"","ref":"Scenic.Script.html#t:id/0"},{"type":"type","title":"Scenic.Script.script_op/0","doc":"","ref":"Scenic.Script.html#t:script_op/0"},{"type":"type","title":"Scenic.Script.t/0","doc":"","ref":"Scenic.Script.html#t:t/0"},{"type":"module","title":"Scenic.ViewPort","doc":"Overview The job of the ViewPort is to coordinate the flow of information between the scenes and the drivers. Scenes and Drivers should not know anything about each other. An app should work identically from its point of view no matter if there is one, multiple, or no drivers currently running. Drivers are all about rendering output and collecting input from a single source. Usually hardware, but can also be the network or files. Drivers only care about graphs and should not need to know anything about the logic or state encapsulated in Scenes. The goal is to isolate app data and logic from render data and logic. The ViewPort is the connection between them that makes sense of the flow of information. OUTPUT Practically speaking, the ViewPort is the owner of the ETS tables that carry the graphs (and any other necessary support info). If the ViewPort crashes, then all that information needs to be rebuilt. The ViewPort monitors all running scenes and does the appropriate cleanup when any of them goes DOWN. The scene is responsible for generating graphs and writing them to the graph ETS table. ( Note: We also tried casting the graph to the ViewPort so that the table could be non-public, but that had issues) The drivers should only read from the graph tables. INPUT When user input happens, the drivers send it to the ViewPort . Input that does not depend on screen position (key presses, audio window events, etc.) is sent to the root scene unless some other scene has captured that type of input (see captured input below). If the input event does depend on position (cursor position, cursor button presses, scrolling, etc.) then the ViewPort needs to scan the hierarchical graph of graphs, to find the correct scene, and the item in that scene that was &quot;hit&quot;. The ViewPort then sends the event to that scene, with the position projected into the scene's local coordinate space (via the built-up stack of matrix transformations) CAPTURED INPUT A scene can request to &quot;capture&quot; all input events of a certain type. This means that all events of that type are sent to a certain scene process regardless of position or root. In this way, a text input scene nested deep in the tree can capture key presses. Or a button can capture cursor_pos events after it has been pressed. If a scene has &quot;captured&quot; a position dependent input type, that position is projected into the scene's coordinate space before sending the event. Note that instead of walking the graph of graphs, the transforms provided in the input &quot;context&quot; field are used. You could, in theory change that to something else before capturing, but I wouldn't really recommend it. Any scene can cancel the current capture. This would probably leave the scene that thinks it has &quot;captured&quot; the input in an inconsistent state, so this is not recommended. Dynamically Creating View Ports Pass in the same set of opts that you would use when starting Scenic in your supervision tree. For example: # Assuming you use the default view port name from the generator { :ok , view_port } = Scenic.ViewPort . info ( :main_viewport ) opts = [ module : Scenic.Driver.Local , window : [ resizeable : false , title : &quot;My Example Scenic App&quot; ] , on_close : :stop_system ] { :ok , [ opts ] } = Scenic.Driver . validate ( [ opts ] ) Scenic.ViewPort . start_driver ( view_port , opts )","ref":"Scenic.ViewPort.html"},{"type":"function","title":"Scenic.ViewPort.all_script_ids/1","doc":"Retrieves a list of all registered script ids.","ref":"Scenic.ViewPort.html#all_script_ids/1"},{"type":"function","title":"Scenic.ViewPort.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.ViewPort.html#child_spec/1"},{"type":"function","title":"Scenic.ViewPort.del_graph/2","doc":"Delete a graph by name. Same as del_script/2","ref":"Scenic.ViewPort.html#del_graph/2"},{"type":"function","title":"Scenic.ViewPort.del_script/2","doc":"Delete a script by name. Also unregisters the name/id pairing","ref":"Scenic.ViewPort.html#del_script/2"},{"type":"function","title":"Scenic.ViewPort.find_point/2","doc":"Find a scene_pid/primitive under the given point in global coordinates","ref":"Scenic.ViewPort.html#find_point/2"},{"type":"function","title":"Scenic.ViewPort.get_script/2","doc":"Retrieve a script","ref":"Scenic.ViewPort.html#get_script/2"},{"type":"function","title":"Scenic.ViewPort.handle_continue_input/2","doc":"","ref":"Scenic.ViewPort.html#handle_continue_input/2"},{"type":"function","title":"Scenic.ViewPort.info/1","doc":"Retrieve a %ViewPort{} struct given just the viewport's pid","ref":"Scenic.ViewPort.html#info/1"},{"type":"function","title":"Scenic.ViewPort.input/2","doc":"Send raw input to a viewport. This is used primarily by drivers to send raw user input to the viewport. Having said that, nothing stops a scene from using it to send input into the system. There are a few cases where that is useful. See the input docs for the input formats you can send.","ref":"Scenic.ViewPort.html#input/2"},{"type":"function","title":"Scenic.ViewPort.input_types/0","doc":"Returns a list of the valid input types","ref":"Scenic.ViewPort.html#input_types/0"},{"type":"function","title":"Scenic.ViewPort.put_graph/4","doc":"Put a graph by name. This compiles the graph to a collection of scripts","ref":"Scenic.ViewPort.html#put_graph/4"},{"type":"function","title":"Scenic.ViewPort.put_script/4","doc":"Put a script by name. returns {:ok, id}","ref":"Scenic.ViewPort.html#put_script/4"},{"type":"function","title":"Scenic.ViewPort.root_id/0","doc":"Returns the id of the first script in the drawing tree Used by drivers","ref":"Scenic.ViewPort.html#root_id/0"},{"type":"function","title":"Scenic.ViewPort.set_root/3","doc":"Set the root scene/graph of the ViewPort. This will stop the currently running scene, including all of it's child components. Then it starts the new scene including all of it's child components.","ref":"Scenic.ViewPort.html#set_root/3"},{"type":"function","title":"Scenic.ViewPort.set_theme/2","doc":"Set the root theme for the ViewPort. Warning This will restart the current root scene","ref":"Scenic.ViewPort.html#set_theme/2"},{"type":"function","title":"Scenic.ViewPort.start/1","doc":"Start a new ViewPort","ref":"Scenic.ViewPort.html#start/1"},{"type":"function","title":"Scenic.ViewPort.start_driver/2","doc":"","ref":"Scenic.ViewPort.html#start_driver/2"},{"type":"function","title":"Scenic.ViewPort.stop/1","doc":"Stop a running viewport","ref":"Scenic.ViewPort.html#stop/1"},{"type":"function","title":"Scenic.ViewPort.stop_driver/2","doc":"","ref":"Scenic.ViewPort.html#stop_driver/2"},{"type":"type","title":"Scenic.ViewPort.event/0","doc":"","ref":"Scenic.ViewPort.html#t:event/0"},{"type":"type","title":"Scenic.ViewPort.t/0","doc":"","ref":"Scenic.ViewPort.html#t:t/0"},{"type":"module","title":"Scenic.ViewPort.Input","doc":"The low-level interface for working in input into and out of a ViewPort . You will typically use the input related functions in Scenic.Scene , which wrap this module and make them easy to use from a Scene module. If you wanted monitor input from some other GenServer , or inject input into a ViewPort , then this is the API to use. Input events begin when a driver sends an event to the ViewPort it is attached to. In order to keep scenes simple, and to reduce the amount of work and data transferred when input is created (for example, a moving mouse...), events are only sent to any scenes that have indicated that they are listening. There are two ways a scene indicates that it is interested in an input event. Requested Input Normally, a scene &quot;requests&quot; input. This will route any keyboard or other location independent events to the scene. However, any positional input, such as :cursor_button will only be received it if is over an item in a graph managed by a scene that has the input: true style. graph |&gt; rect ( { 20 , 40 } , t : { 10 , 10 } , id : :rect_in , input : true , fill : :blue ) |&gt; rect ( { 20 , 40 } , t : { 10 , 50 } , id : :rect_other , fill : :blue ) In the above example, the scene would only receive :cursor_button events if the :rect_in rect is clicked. This is because it is the only rect that has the input: true style on it. Cursor clicks over the :rect_other rect, are not delivered to the scene. Captured Input If you look at the code behind components such as Button or Slider, you will see that when the button is clicked, it &quot;captures&quot; the :cursor_button input type. This causes the caller to receive all input events of that type, regardless of the :input style. This means that even :cursor_button events that would be otherwise be routed to some other scene are sent only to the scene that has captured the input. The other scene that has only &quot;requested&quot; the event does not receive it. If multiple scenes have captured an input type, the most recent call wins. When scene releases the capture, the event type remains captured but is now sent to the second scene that had been overridden. Sending Input When a driver (or any other caller, but it is typically a Scenic.Driver ) wants to send an input event to the ViewPort, it creates a message and sends it to it's ViewPort with the Scenic.ViewPort.Input.send/2 function. Drivers have no knowledge of the running scenes. The ViewPort takes care of that routing. Input events are validated against Scenic.ViewPort.Input.validate/1 function.","ref":"Scenic.ViewPort.Input.html"},{"type":"function","title":"Scenic.ViewPort.Input.capture/3","doc":"Capture one or more types of input. Returns :ok or an error Options :pid - Send input to the specified pid instead of the caller process.","ref":"Scenic.ViewPort.Input.html#capture/3"},{"type":"function","title":"Scenic.ViewPort.Input.fetch_captures/2","doc":"Retrieve a list of input captured by the caller. Returns: { :ok, list }","ref":"Scenic.ViewPort.Input.html#fetch_captures/2"},{"type":"function","title":"Scenic.ViewPort.Input.fetch_captures!/1","doc":"Retrieve a list of input captured by all processes. Returns: { :ok, list }","ref":"Scenic.ViewPort.Input.html#fetch_captures!/1"},{"type":"function","title":"Scenic.ViewPort.Input.fetch_requests/2","doc":"Retrieve a list of input requested by the caller or the process requested_by. Returns: { :ok, inputs }","ref":"Scenic.ViewPort.Input.html#fetch_requests/2"},{"type":"function","title":"Scenic.ViewPort.Input.fetch_requests!/1","doc":"Retrieve a list of input requested by all processes. Returns: { :ok, inputs }","ref":"Scenic.ViewPort.Input.html#fetch_requests!/1"},{"type":"function","title":"Scenic.ViewPort.Input.release/3","doc":"Release the captured inputs from the calling process. Options :pid - Release from the specified pid instead of the caller process.","ref":"Scenic.ViewPort.Input.html#release/3"},{"type":"function","title":"Scenic.ViewPort.Input.release!/2","doc":"Release the captured inputs from ALL processes","ref":"Scenic.ViewPort.Input.html#release!/2"},{"type":"function","title":"Scenic.ViewPort.Input.request/3","doc":"Request one or more types of input. Returns :ok or an error Options :pid - Send input to the specified pid instead of the caller process.","ref":"Scenic.ViewPort.Input.html#request/3"},{"type":"function","title":"Scenic.ViewPort.Input.send/2","doc":"Send raw input to a viewport. This is used primarily by drivers to send raw user input to the viewport. Having said that, nothing stops a scene or any other process from using it to send input into the system. There are a few cases where that is useful. See the input types for the input formats you can send.","ref":"Scenic.ViewPort.Input.html#send/2"},{"type":"function","title":"Scenic.ViewPort.Input.unrequest/3","doc":"Unrequest the captured inputs from the calling process. Options :pid - Unrequest from the specified pid instead of the caller process.","ref":"Scenic.ViewPort.Input.html#unrequest/3"},{"type":"function","title":"Scenic.ViewPort.Input.validate/1","doc":"Validate an input message. Returns :ok if the message is valid. Returns {:error, :invalid} if the message is not valid.","ref":"Scenic.ViewPort.Input.html#validate/1"},{"type":"type","title":"Scenic.ViewPort.Input.class/0","doc":"","ref":"Scenic.ViewPort.Input.html#t:class/0"},{"type":"type","title":"Scenic.ViewPort.Input.positional/0","doc":"","ref":"Scenic.ViewPort.Input.html#t:positional/0"},{"type":"type","title":"Scenic.ViewPort.Input.t/0","doc":"","ref":"Scenic.ViewPort.Input.html#t:t/0"},{"type":"module","title":"Scenic.Assets.Static","doc":"Manages static assets, which are resources such as fonts or images (jpg or png) that ship with your application and do not change over time. These assets live as seperate files and are hashed so that they are rejected if they change in any way after you compile your application. They are cacheable by the relay server if you remote your Scenic UI. In previous versions of Scenic, static assets were rather complicated to set up and maintain. Starting with v0.11, Scenic has an assets build pipeline that manages the static assets library for you. Required Configuration Setting up the static asset pipeline requites several inputs that need to be maintained. Assets Directory : Typically /assets in your main app source directory. This is the folder that holds your raw asset files. Assets Module : A module in your application that builds and holds the asset library. Assets Config : Configuration scripts in your application that indicates where the assets directory is and your assets module. Assets Directory The assets directory typically is typically called /assets and lives at the root of your application source directory. This can be changed in the config options. Example: my_app_src assets fonts roboto . ttf custom_font . ttf images parrot . jpg my_logo . png config lib etc ... Once the rest of the configuration is complete, adding a new font is as simple as dropping the *.ttf file into the /assets/fonts directory and compiling your assets module. Similar is true for images. Assets Library When your application is running, there needs to be a module that contains the built asset library referring to your static assets. This library holds things like the hash of the contents of each asset, and it's parsed metadata. You must create this module and compile it with your application. The following example is what this module should look like. Replace MyApplication and :my_application with the actual name of your application. defmodule MyApplication.Assets do use Scenic.Assets.Static , otp_app : :my_application , sources : [ &quot;assets&quot; , { :scenic , &quot;deps/scenic/assets&quot; } ] , alias : [ parrot : &quot;images/parrot.jpg&quot; ] end Notice that there are several configuration sections in your assets module. Sources is the list of folders to look in to find assets. For example, if you take a dependency on a package that contains assets, you will need to add it's assets folder here. If can omit the sources section if you only use a single assets folder and scenic's default fonts. In other words, the sources configuration shown above is also the default. The :alias list creates shortcuts that refer to the files in the assets library. This is useful if you think an asset id may change during development but want a constant way to refer to it in your code. In the above example, the atom :parrot is mapped to the file images/parrot.jpb and are interchangeable with each other in a graph. In this example, the two rect fills are identical as the :parrot alias was created in the configuration script. Graph . build ( ) |&gt; rect ( { 100 , 50 } , fill : { :image , &quot;images/parrot.jpg&quot; } ) |&gt; rect ( { 100 , 50 } , fill : { :image , :parrot } ) The fonts fonts/roboto.ttf and fonts/roboto_mono.ttf are considered the default fonts for Scenic and are automatically aliased to :roboto and :roboto_mono . It is expected that you will include those two fonts in your /assets/fonts directory. IMPORTANT NOTE: When you add a new asset to the assets directory, you may need to force this module to recompile for them to be usable. Adding or removing a return at the end should do the trick. In the future, there will be a file system watcher (much like Phoenix has) that will do this automatically. Until then, it is pretty easy to do manually. Assets Configuration The final piece is some configuration that connects scenic and your assets module togther. Put this in your application's config.exs file. config :scenic , :assets , module : MyApplication.Assets Troubleshooting If you have added an asset to your assets directory and you think it should be in your library, but it isn't, or you can't compile a scene because the asset can't be found, then start troubleshooting with the following steps. Force your assets module to rebuild. Touch it in some way such as adding or removing a carriage return at the end, then compile again. Check that you are using the correct id for the asset in your graph. If you are using an alias, check it's spelling and its assignment in the config script. Confirm that the asset itself has valid contents, whether it is a font (.ttf) or an image (.jpg or .jpeg or .png) That usually does it. Under the Covers When your assets module is compiled, several steps are executed by Scenic.Assets.Static The files in your assets directory are parsed for validity and metadata. Valid files move on to the next step The valid assets files are hashed to create a cryptographic signature that is used later when the files are loaded to confirm that they are unchanged. The asset files are copied into the /priv/static directory, which is where they are actually loaded from at run time. The name of the file in this directory is a Base.url_encode64/2 version of the hash of the file's contents. A map is created, which is the actual asset library used at runtime. This map has the original file name as keys and holds the hashes, and parsed metadata as the contents. This map is stored as a literal object in your assets module and is the reason it needs to be compiled when you add a new asset. If you are curious and want to see the library yourself, you can query the MyApplication.Assets.library/0 function, which is added at compile time. Alternately, the function Scenic.Assets.Static.library/0 should return the same library. Future Work There are two pieces of work to the static assets pipeline that are planned for the future. First is a file system watcher that automatically flags your assets module to be recompiled when the contents of the assets directory changes. This would work in a similar way to the file system watcher used by Phoenix. The second, larger, piece of work is to include optional transform scripts/code when your assets module is compiled. This would let you do things like putting a very high resolution image in the sources folder and down-scaling at compile time as appropriate for the target device you are compiling for. In the meantime, just put in the assets you want to use directly.","ref":"Scenic.Assets.Static.html"},{"type":"function","title":"Scenic.Assets.Static.assign/4","doc":"","ref":"Scenic.Assets.Static.html#assign/4"},{"type":"function","title":"Scenic.Assets.Static.library/0","doc":"Return the compiled asset library.","ref":"Scenic.Assets.Static.html#library/0"},{"type":"function","title":"Scenic.Assets.Static.load/1","doc":"Load the binary contents of an asset given it's id or hash. Return is in the form of {:ok, bin} If the asset is not in the library, {:error, :not_found} is returned. The contents of the file will be hashed and compared against the hash found in the library. If this test fails, {:error, :hash_failed} is returned. If the output file cannot be read, it returns a posix error.","ref":"Scenic.Assets.Static.html#load/1"},{"type":"function","title":"Scenic.Assets.Static.load/2","doc":"","ref":"Scenic.Assets.Static.html#load/2"},{"type":"function","title":"Scenic.Assets.Static.meta/1","doc":"Fetch the metadata for an asset by id. Return is in the form of {:ok, metadata} If the hash is not in the library, :error is returned. Example: { :ok , meta } = Scenic.Assets.Static . meta ( :parrot )","ref":"Scenic.Assets.Static.html#meta/1"},{"type":"function","title":"Scenic.Assets.Static.meta/2","doc":"","ref":"Scenic.Assets.Static.html#meta/2"},{"type":"function","title":"Scenic.Assets.Static.module/0","doc":"Return the configured asset library module.","ref":"Scenic.Assets.Static.html#module/0"},{"type":"function","title":"Scenic.Assets.Static.to_hash/1","doc":"Transform an asset id into the file hash. If you pass in a valid hash, it is returned unchanged Example: alias Scenic.Assets.Static library = Static . library ( ) { :ok , &quot;VvWQFjblIwTGsvGx866t8MIG2czWyIc8by6Xc88AOns&quot; } = Static . hash ( library , :parrot ) { :ok , &quot;VvWQFjblIwTGsvGx866t8MIG2czWyIc8by6Xc88AOns&quot; } = Static . hash ( library , &quot;images/parrot.png&quot; ) { :ok , &quot;VvWQFjblIwTGsvGx866t8MIG2czWyIc8by6Xc88AOns&quot; } = Static . hash ( library , &quot;VvWQFjblIwTGsvGx866t8MIG2czWyIc8by6Xc88AOns&quot; )","ref":"Scenic.Assets.Static.html#to_hash/1"},{"type":"function","title":"Scenic.Assets.Static.to_hash/2","doc":"","ref":"Scenic.Assets.Static.html#to_hash/2"},{"type":"type","title":"Scenic.Assets.Static.id/0","doc":"","ref":"Scenic.Assets.Static.html#t:id/0"},{"type":"type","title":"Scenic.Assets.Static.t/0","doc":"","ref":"Scenic.Assets.Static.html#t:t/0"},{"type":"module","title":"Scenic.Assets.Stream","doc":"Manage streaming assets (for now only compressed images and bitmaps) that are available to all Scenes and ViewPorts. The Scenic.Assets.Stream API gives to access to a running GenServer that manages an :ets table and subscriptions to changes to named streams. This means that streaming assets are available globally to all Scenes and ViewPorts. You should be aware that if you have a GenServer that is rapidly updating a stream, but no scene's are listening, then you are doing unnecessary work. If you have only a single Scene in a single ViewPort listening to that stream, then create the stream in the scene. If you have multiple Scenes listening to a stream, or the same stream in multiple ViewPorts, then create and update the stream in an independent GenServer that you manage outside of Scenic.","ref":"Scenic.Assets.Stream.html"},{"type":"function","title":"Scenic.Assets.Stream.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Assets.Stream.html#child_spec/1"},{"type":"function","title":"Scenic.Assets.Stream.delete/1","doc":"Fully delete a named stream. If you recreate the stream after deleting it, you can place any asset type into the new stream.","ref":"Scenic.Assets.Stream.html#delete/1"},{"type":"function","title":"Scenic.Assets.Stream.exists!/1","doc":"Check if a named stream has been published. Returns a :ok if the stream is published. Raises an error if it is not.","ref":"Scenic.Assets.Stream.html#exists!/1"},{"type":"function","title":"Scenic.Assets.Stream.exists?/1","doc":"Check if a named stream has been published. Returns a boolean indicating if the stream is published.","ref":"Scenic.Assets.Stream.html#exists?/1"},{"type":"function","title":"Scenic.Assets.Stream.fetch/1","doc":"Fetch the currently published asset in a named stream. Returns {:ok, asset} on success. Returns {:error, :not_found} if the stream is not available.","ref":"Scenic.Assets.Stream.html#fetch/1"},{"type":"function","title":"Scenic.Assets.Stream.put/2","doc":"Put a streamable asset into a named stream. If the named stream does not exist yet, it is created. If it already exists, then it's content is updated with the asset. Returns :ok on success. Note: Once a stream is create, the asset being updated must be the same type as the asset that was originally created. I.e. you can't replace a Bitmap with an Image. This will make more sense in the future as other assets types (audio) become supported. The contents of the asset is (lightly) validated as it is put into the :ets table. If the content is invalid, or a different type than what is already in the stream, then it returns {:error, :invalid, asset_type} .","ref":"Scenic.Assets.Stream.html#put/2"},{"type":"function","title":"Scenic.Assets.Stream.put!/2","doc":"Same as put, but reverses the params order (making it pipe-able) and raises on failures. Returns the asset on success.","ref":"Scenic.Assets.Stream.html#put!/2"},{"type":"function","title":"Scenic.Assets.Stream.subscribe/1","doc":"Subscribe to changes in a named stream. Call this from a GenServer, typically a Driver or something you manage yourself. When an asset stream is updated you will receive the following message. {{Stream, :put}, stream_type, id} You can match against stream_type to select certain kids of assets. Use the id to fetch the contents of the asset. When an asset stream is deleted, you will receive the following message. {{Stream, :delete}, stream_type, id} You can subscribe to an stream before it has been published. You will then start receiving put messages when it is created. Your subscription will not end if the stream is deleted.","ref":"Scenic.Assets.Stream.html#subscribe/1"},{"type":"function","title":"Scenic.Assets.Stream.unsubscribe/1","doc":"Unsubscribe to changes in a named stream. Once your process unsubscribes to a named stream, it will stop receiving all messages related to it","ref":"Scenic.Assets.Stream.html#unsubscribe/1"},{"type":"type","title":"Scenic.Assets.Stream.asset/0","doc":"","ref":"Scenic.Assets.Stream.html#t:asset/0"},{"type":"type","title":"Scenic.Assets.Stream.id/0","doc":"","ref":"Scenic.Assets.Stream.html#t:id/0"},{"type":"module","title":"Scenic.Assets.Stream.Bitmap","doc":"This module helps you to prepare images, in the form of a bitmap, that are to be streamed and displayed through the Scenic.Assets.Stream module. A bitmap is a rectangular field of pixels. Each pixel can be addressed and assigned a color. When the bitmap is put into Scenic.Assets.Stream it becomes an image that can be displayed in a scene via Scenic.Primitive.Style.Paint.Stream . Committed vs. Mutable Bitmaps are interesting because a typical pattern is to change the color of many pixels in a rapid burst, then send the image up. The bitmaps can become quite large tho, so if we were to make a copy of it every time a single pixel was changed, that could become quite slow. Unfortunately, writing a NIF that manipulates individual pixels quickly and without making a copy, breaks the immutable, functional model of Erlang/Elixir. The compromise is that a Bitmap can be either in a &quot;commited&quot; state, which can be put into Scenic.Assets.Stream , but not changed, or in a &quot;mutable&quot; state, which can be manipulated rapidly, but not streamed to scenes. When a new bitmap is built, it starts in the mutable state, unless the commit: true option is set. alias Scenic.Assets.Stream.Bitmap bitmap = Bitmap . build ( :rgb , 20 , 10 , clear : :blue ) |&gt; Bitmap . put ( 2 , 3 , :red ) |&gt; Bitmap . put ( 9 , 10 , :yellow ) |&gt; Bitmap . commit ( ) Scenic.Assets.Stream . put ( &quot;stream_id&quot; , bitmap ) In the above example, a new bitmap is created, that can hold an rgb color in every pixel, is 20 pixels wide, 10 pixels high, and starts with the entire image set to the color :blue . The :commit option is not set, so it is mutable. Then two of the pixels are set to other colors. One :red and the other :yellow . Finally, the image is committed, making it usable, but no longer mutable. After the image is completed, it is sent to Scenic.Assets.Stream , which makes it available for use in a scene. Color Depth Bitmaps can be one of four depths. Each consumes a different amount of memory per pixel. If you are running on a constrained memory device, or are worried about bandwidth when remoting the UI, then you should choose the depth that you actually use. If you have lots of memory, then :rgba is usually the fastest format. Depth Bytes per pixel Notes :g 1 Simple Greyscale. 256 shades of grey :ga 2 Greyscale plus an alhpa channel :rgb 3 Red/Green/Blue Millions of colors :rgba 4 Red/Green/Blue/Alpha","ref":"Scenic.Assets.Stream.Bitmap.html"},{"type":"function","title":"Scenic.Assets.Stream.Bitmap.build/4","doc":"Build a new bitmap with a given depth, width and height. Build creates a new bitmap in memory. It begins in a mutable state and will be set to transparent black unless the :clear option is specified. The valid depths are :g, :ga, :rgb, :rgba as explained in the following table Depth Bytes per pixel Notes :g 1 Simple Greyscale. 256 shades of grey :ga 2 Greyscale plus an alhpa channel :rgb 3 Red/Green/Blue Millions of colors :rgba 4 Red/Green/Blue/Alpha Options :clear Set the new bitmap so that every pixel is the specified color. :commit Set to true to start the bitmap committed. Set to false for mutable. The default if not specified is mutable.","ref":"Scenic.Assets.Stream.Bitmap.html#build/4"},{"type":"function","title":"Scenic.Assets.Stream.Bitmap.clear/2","doc":"Set the color value of all pixels in a bitmap. This effectively erases the bitmap, replacing it with a solid field of the supplied color. Only works with mutable bitmaps. The color you provide can be any valid value from the Scenic.Color module. If the color you provide doesn't match the depth of the bitmap, this will transform the color as appropriate to fit. For example, putting an :rgb color into a :g (greyscale) bit map, will set the level of grey to be the average value of the red, green, and blue channels of the supplied color","ref":"Scenic.Assets.Stream.Bitmap.html#clear/2"},{"type":"function","title":"Scenic.Assets.Stream.Bitmap.commit/1","doc":"Change a bitmap from mutable to committed. Committed bitmaps can be used by Scenic.Assets.Stream . They will not work with the put and clear functions in this module.","ref":"Scenic.Assets.Stream.Bitmap.html#commit/1"},{"type":"function","title":"Scenic.Assets.Stream.Bitmap.get/3","doc":"Get the color value of a single pixel in a bitmap. Works with either committed or mutable bitmaps.","ref":"Scenic.Assets.Stream.Bitmap.html#get/3"},{"type":"function","title":"Scenic.Assets.Stream.Bitmap.mutable/1","doc":"Change a bitmap from committed to mutable. This makes a copy of the bitmap's memory to preserve the Erlang model. Mutable bitmaps are not usable by Scenic.Assets.Stream .","ref":"Scenic.Assets.Stream.Bitmap.html#mutable/1"},{"type":"function","title":"Scenic.Assets.Stream.Bitmap.put/4","doc":"Set the color value of a single pixel in a bitmap. Only works with mutable bitmaps. The color you provide can be any valid value from the Scenic.Color module. If the color you provide doesn't match the depth of the bitmap, this will transform the color as appropriate to fit. For example, putting an :rgb color into a :g (greyscale) bit map, will set the level of grey to be the average value of the red, green, and blue channels of the supplied color","ref":"Scenic.Assets.Stream.Bitmap.html#put/4"},{"type":"function","title":"Scenic.Assets.Stream.Bitmap.put_offset/3","doc":"Set the color value of a single pixel in a bitmap using an offset from the start. Only works with mutable bitmaps. The color you provide can be any valid value from the Scenic.Color module. Unlike the put function, which specifies the pixel by x and y position, put_offset takes an offset directly into the data. The offset would be the same as y * width + x.","ref":"Scenic.Assets.Stream.Bitmap.html#put_offset/3"},{"type":"type","title":"Scenic.Assets.Stream.Bitmap.depth/0","doc":"","ref":"Scenic.Assets.Stream.Bitmap.html#t:depth/0"},{"type":"type","title":"Scenic.Assets.Stream.Bitmap.m/0","doc":"","ref":"Scenic.Assets.Stream.Bitmap.html#t:m/0"},{"type":"type","title":"Scenic.Assets.Stream.Bitmap.meta/0","doc":"","ref":"Scenic.Assets.Stream.Bitmap.html#t:meta/0"},{"type":"type","title":"Scenic.Assets.Stream.Bitmap.t/0","doc":"","ref":"Scenic.Assets.Stream.Bitmap.html#t:t/0"},{"type":"module","title":"Scenic.Assets.Stream.Image","doc":"This module helps you to prepare images, in the form of a compressed blob such as a jpg or png file, that are to be streamed and displayed through the Scenic.Assets.Stream module. A typical use case is receiving pre-compressed images from a physical camera, then streaming them as the fill of a rect in a scene. This module is very simple. The only function is from_binary/1, where you supply a binary that is a valid compressed image format. That format is verified and the metadata is parsed out of it. The result is a term that can be supplied to the Scenic.Assets.Stream module. Example: alias Scenic.Assets.Stream def handle_info ( { :camera_frame , bin } , state ) do # If the supplied bin is not a valid image, let it crash { :ok , img } = Stream.Image . from_binary ( bin ) Stream . put ( &quot;camera&quot; , img ) { :noreply , state } end","ref":"Scenic.Assets.Stream.Image.html"},{"type":"function","title":"Scenic.Assets.Stream.Image.from_binary/1","doc":"Create a streamable image resource from a compressed image binary. On success, this returns {:ok, img} The supplied binary must be a valid jpeg or png format. If it is either invalid or an unrecognized format, this will return {:error, :invalid}","ref":"Scenic.Assets.Stream.Image.html#from_binary/1"},{"type":"type","title":"Scenic.Assets.Stream.Image.meta/0","doc":"","ref":"Scenic.Assets.Stream.Image.html#t:meta/0"},{"type":"type","title":"Scenic.Assets.Stream.Image.t/0","doc":"","ref":"Scenic.Assets.Stream.Image.html#t:t/0"},{"type":"behaviour","title":"Scenic.Component","doc":"A Component is Scene that is optimized to be used as a child of another scene. These are typically controls that you want to define once and use in multiple places. Standard Components Scenic includes a several standard components that you can use in your scenes. These were chosen to be in the main library because: They are used frequently Their use promotes a certain amount of &quot;common&quot; look and feel All of these components are typically added/modified via the helper functions in the Scenic.Components module. Helper Component Module Description button/3 Scenic.Component.Button A simple button checkbox/3 Scenic.Component.Input.Checkbox A boolean checkbox control dropdown/3 Scenic.Component.Input.Dropdown A menu-like dropdown control radio_group/3 Scenic.Component.Input.RadioGroup A group of radio controls slider/3 Scenic.Component.Input.Slider A slider ranging from one value to another text_field/3 Scenic.Component.Input.TextField A text input field. toggle/3 Scenic.Component.Input.Toggle A boolean toggle control. defmodule MyApp.Scene.MyScene do use Scenic.Scene import Scenic.Components @impl Scenic.Scene def init ( scene , text , opts ) do graph = Scenic.Graph . build ( ) |&gt; button ( &quot;Press Me&quot; , id : :press_me ) |&gt; slider ( { { 0 , 100 } , 0 } , id : :slide_me ) { :ok , push_graph ( scene , graph ) } end end Creating Custom Components Creating a custom component that you can use in your scenes is just like creating a scene with an extra validation function. This validation function is used when the graph that uses your component is built in order to make sure it uses data that conforms to what your component expects. defmodule MyApp.Component.Fancy do use Scenic.Component @impl Scenic.Component def validate ( data ) when is_bitstring ( data ) , do : { :ok , data } def validate ( _ ) , do : { :error , &quot;Descriptive error message goes here.&quot; } @impl Scenic.Scene def init ( scene , data , opts ) do { :ok , scene } end end Generating/Sending Events Communication from a component to it's parent is usually done via event messages. Scenic knows how to route events to a component's parent. If that parent doesn't handle it, then it is automatically routed to the parent's parent. If it gets all the way to the ViewPort itself, then it is ignored. defmodule MyApp.Component.Fancy do # ... validate, and other setup ... @impl Scenic.Scene def init ( scene , data , opts ) do # setup and push a graph here... { :ok , assign ( scene , id : opts [ :id ] } end @impl Scenic.Scene def handle_input ( { :cursor_button , { 0 , :release , _ , _ } } , :btn , % Scene { assigns : %{ id : id } } = scene ) do :ok = send_parent_event ( scene , { :click , id } ) { :noreply , scene } end end Notice how the component saved the original id that was passed in to the init function via the opts list. This is then used to identify the click to the parent. This is a common pattern. Optional: Fetch/Put Handlers If you would like the parent scene to be able to query your component's state without waiting for the component to send events, you can optionally implement the following handle_call functions. This is an &quot;informal&quot; spec... You don't have to implement it, but it is nice when you do. defmodule MyApp.Component.Fancy do use Scenic.Component # ... init, validate, and other functions ... def handle_call ( :fetch , _ , %{ assigns : %{ value : value } } = scene ) do { :reply , { :ok , value } , scene } end def handle_call ( { :put , value } , _ , scene ) when is_bitstring ( value ) do { :reply , :ok , assign ( scene , value : value ) } end def handle_call ( { :put , _ } , _ , scene ) do { :reply , { :error , :invalid } , scene } end end To make the above example more practical, you would probably also modify and push a graph when handling the :put message. See the code for the standard input components for deeper examples. Optional: has_children: false If you know for certain that your component will not itself use any components, you can set :has_children to false like this. defmodule MyApp.Component.Fancy do use Scenic.Component , has_children : false # ... end When :has_children is set to false , no DynamicSupervisor is started to manage the scene's children, overall resource use is improved, and startup time is faster. You will not, however, be able to nested components in any scene where :has_children is false . For example, the Scenic.Component.Button component sets :has_children to false . This option is available for any Scene, not just components.","ref":"Scenic.Component.html"},{"type":"callback","title":"Scenic.Component.add_to_graph/3","doc":"Add this component to a Graph. A standard add_to_graph/3 is automatically added to your component. Override this callback if you want to customize it.","ref":"Scenic.Component.html#c:add_to_graph/3"},{"type":"callback","title":"Scenic.Component.bounds/2","doc":"Compute the bounding box of the component. This function can be called outside of the context of a running component. The box should be computed as if it was running with the given data and styles.","ref":"Scenic.Component.html#c:bounds/2"},{"type":"callback","title":"Scenic.Component.default_pin/2","doc":"Provide a default pin for this component. If this callback is not implemented, then the default pin will be {0,0}.","ref":"Scenic.Component.html#c:default_pin/2"},{"type":"callback","title":"Scenic.Component.validate/1","doc":"Validate that the data for a component is correctly formed. This callback is required.","ref":"Scenic.Component.html#c:validate/1"},{"type":"module","title":"Scenic.Component.Button","doc":"Add a button to a graph A button is a small scene that is pretty much just some text drawn over a rounded rectangle. The button scene contains logic to detect when the button is pressed, tracks it as the pointer moves around, and when it is released. Data title title - a bitstring describing the text to show in the button Messages If a button press is successful, it sends an event message to the host scene in the form of: { :click , id } These messages can be received and handled in your scene via Scenic.Scene.handle_event/3 . For example: ... @impl Scenic.Scene def init ( _ , _opts ) do graph = Graph . build ( ) |&gt; Scenic.Components . button ( &quot;Sample Button&quot; , id : :sample_btn_id , t : { 10 , 10 } ) state = %{ } { :ok , state , push : graph } end @impl Scenic.Scene def handle_event ( { :click , :sample_btn_id } , _from , state ) do IO . puts ( &quot;Sample button was clicked!&quot; ) { :cont , event , state } end Styles Buttons honor the following standard styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :primary Sendable Styles Styles can be sent directly to the Button Component by adding a :styles list. graph |&gt; button ( &quot;Example&quot; , styles : [ font_size : 32 , text_align : :right ] ) The following standard styles are supported :font - The default is :roboto :font_size - The default is 20 :text_align - The default is :center Options Buttons the following options. :width - :auto (default) or pass in a number to set the width of the button :height - :auto (default) or pass in a number to set the height of the button. :radius - pass in a number to set the radius of the button's rounded rectangle. The default is 3 Buttons do not use the inherited :font_size style as they should look consistent regardless of what size the surrounding text is. Theme Buttons work well with the following predefined themes: :primary , :secondary , :success , :danger , :warning , :info , :text , :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text in the button :background - the normal background of the button :border - the border of the button :active - the background while the button is pressed Usage You should add/modify components via the helper functions in Scenic.Components Examples The following example creates a simple button and positions it on the screen. graph |&gt; button ( &quot;Example&quot; , id : :button_id , translate : { 20 , 20 } ) The next example makes the same button as before, but colors it as a warning button. See the options list above for more details. graph |&gt; button ( &quot;Example&quot; , id : :button_id , translate : { 20 , 20 } , theme : :warning ) The final example changes the text size and alignment graph |&gt; button ( &quot;Example&quot; , id : :button_id , translate : { 20 , 20 } , theme : :warning , styles : [ text_size : 32 , text_align : :right ] )","ref":"Scenic.Component.Button.html"},{"type":"function","title":"Scenic.Component.Button.add_to_graph/3","doc":"Callback implementation for Scenic.Component.add_to_graph/3 .","ref":"Scenic.Component.Button.html#add_to_graph/3"},{"type":"function","title":"Scenic.Component.Button.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Component.Button.html#child_spec/1"},{"type":"module","title":"Scenic.Component.Input.Caret","doc":"Add a blinking text-input caret to a graph. Data height height - The height of the caret. The caller (TextEdit) calculates this based on its :font_size (often the same thing). Options color - any valid color . You can change the color of the caret by setting the color option Graph . build ( ) |&gt; caret ( 20 , color : :white ) Usage The caret component is used by the TextField component and usually isn't accessed directly, although you are free to do so if it fits your needs. There is no short-cut helper function so you will need to add it to the graph manually. The following example adds a blue caret to a graph. graph |&gt; Caret . add_to_graph ( 24 , id : :caret , color : :blue )","ref":"Scenic.Component.Input.Caret.html"},{"type":"function","title":"Scenic.Component.Input.Caret.add_to_graph/3","doc":"Callback implementation for Scenic.Component.add_to_graph/3 .","ref":"Scenic.Component.Input.Caret.html#add_to_graph/3"},{"type":"function","title":"Scenic.Component.Input.Caret.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Component.Input.Caret.html#child_spec/1"},{"type":"module","title":"Scenic.Component.Input.Checkbox","doc":"Add a checkbox to a graph Data {text, checked?} text - must be a bitstring checked? - must be a boolean and indicates if the checkbox is set. Messages When the state of the checkbox, it sends an event message to the host scene in the form of: {:value_changed, id, checked?} Styles Buttons honor the following styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Theme Checkboxes work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text in the button :background - the background of the box :border - the border of the box :active - the border of the box while the button is pressed :thumb - the color of the check mark itself Usage You should add/modify components via the helper functions in Scenic.Components Examples The following example creates a checkbox and positions it on the screen. graph |&gt; checkbox ( { &quot;Example&quot; , true } , id : :checkbox_id , translate : { 20 , 20 } )","ref":"Scenic.Component.Input.Checkbox.html"},{"type":"function","title":"Scenic.Component.Input.Checkbox.add_to_graph/3","doc":"Callback implementation for Scenic.Component.add_to_graph/3 .","ref":"Scenic.Component.Input.Checkbox.html#add_to_graph/3"},{"type":"function","title":"Scenic.Component.Input.Checkbox.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Component.Input.Checkbox.html#child_spec/1"},{"type":"module","title":"Scenic.Component.Input.Dropdown","doc":"Add a dropdown to a graph Data {items, initial_item} items - must be a list of items, each of which is: {text, id} . See below... initial_item - the id of the initial selected item. It can be any term you want, however it must be an item_id in the items list. See below. Per item data: {text, item_id} text - a string that will be shown in the dropdown. item_id - any term you want. It will identify the item that is currently selected in the dropdown and will be passed back to you during event messages. Messages When the state of the checkbox, it sends an event message to the host scene in the form of: {:value_changed, id, selected_item_id} Options Dropdowns honor the following list of options. Styles Buttons honor the following styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Additional Styles Buttons honor the following list of additional styles. :width - pass in a number to set the width of the button. :height - pass in a number to set the height of the button. :direction - what direction should the menu drop. Can be either :down or :up . The default is :down . Theme Dropdowns work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text :background - the background of the component :border - the border of the component :active - the background of selected item in the dropdown list :thumb - the color of the item being hovered over Usage You should add/modify components via the helper functions in Scenic.Components Examples The following example creates a dropdown and positions it on the screen. graph |&gt; dropdown ( { [ { &quot;Dashboard&quot; , :dashboard } , { &quot;Controls&quot; , :controls } , { &quot;Primitives&quot; , :primitives } ] , :controls } , id : :dropdown_id , translate : { 20 , 20 } )","ref":"Scenic.Component.Input.Dropdown.html"},{"type":"function","title":"Scenic.Component.Input.Dropdown.add_to_graph/3","doc":"Callback implementation for Scenic.Component.add_to_graph/3 .","ref":"Scenic.Component.Input.Dropdown.html#add_to_graph/3"},{"type":"function","title":"Scenic.Component.Input.Dropdown.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Component.Input.Dropdown.html#child_spec/1"},{"type":"module","title":"Scenic.Component.Input.RadioButton","doc":"Add a single radio button to a graph. Data {text, id} {text, id, selected?} text - a bitstring of the text to display id - any term. Identifies the radio button. selected? - boolean. true if selected. false if not . Default is false if this term is not provided. Usage The RadioButton component is used by the RadioGroup component and usually isn't accessed directly, although you are free to do so if it fits your needs. There is no short-cut helper function so you will need to add it to the graph manually. The following example adds a caret to a graph. graph |&gt; RadioButton . add_to_graph ( { &quot;A button&quot; , :an_id , true } )","ref":"Scenic.Component.Input.RadioButton.html"},{"type":"function","title":"Scenic.Component.Input.RadioButton.add_to_graph/3","doc":"Callback implementation for Scenic.Component.add_to_graph/3 .","ref":"Scenic.Component.Input.RadioButton.html#add_to_graph/3"},{"type":"function","title":"Scenic.Component.Input.RadioButton.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Component.Input.RadioButton.html#child_spec/1"},{"type":"module","title":"Scenic.Component.Input.RadioGroup","doc":"Add a radio group to a graph The data format for RadioGroup has changed since v0.10! Data {radio_buttons, checked_id} radio_buttons must be a list of radio button data. See below. checked_id Is the id of the currently selected radio from the list. radio_buttons list: {text, radio_id} text - must be a bitstring button_id - can be any term you want. It will be passed back to you as the group's value. checked? - must be a boolean and indicates if the button is selected. checked? is not required and will default to false if not supplied. Example showing the full data format { [ { &quot;One&quot; , :one } , { &quot;Two&quot; , :two } , { &quot;Three&quot; , :three } ] , :two } Messages When the state of the radio group changes, it sends an event message to the host scene in the form of: {:value_changed, id, radio_id} Options Radio Buttons honor the following list of options. :theme - This sets the color scheme of the button. This can be one of pre-defined button schemes :light , :dark , or it can be a completely custom scheme like this: {text_color, box_background, border_color, pressed_color, checkmark_color} . Styles Radio Buttons honor the following styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Theme Radio buttons work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text :background - the background of the component :border - the border of the component :active - the background of the circle while the button is pressed :thumb - the color of inner selected-mark Usage You should add/modify components via the helper functions in Scenic.Components Examples The following example creates a radio group and positions it on the screen. graph |&gt; radio_group ( { [ { &quot;Radio A&quot; , :radio_a } , { &quot;Radio B&quot; , :radio_b } , { &quot;Radio C&quot; , :radio_c } , ] , :radio_b } , id : :radio_group_id , translate : { 20 , 20 } )","ref":"Scenic.Component.Input.RadioGroup.html"},{"type":"function","title":"Scenic.Component.Input.RadioGroup.add_to_graph/3","doc":"Callback implementation for Scenic.Component.add_to_graph/3 .","ref":"Scenic.Component.Input.RadioGroup.html#add_to_graph/3"},{"type":"function","title":"Scenic.Component.Input.RadioGroup.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Component.Input.RadioGroup.html#child_spec/1"},{"type":"module","title":"Scenic.Component.Input.Slider","doc":"Add a slider to a graph Data { extents, initial_value} extents gives the range of values. It can take several forms... {min, max} If min and max are integers, then the slider value will be an integer. {min, max} If min and max are floats, then the slider value will be an float. [a, b, c] A list of terms. The value will be one of the terms initial_value Sets the initial value (and position) of the slider. It must make sense with the extents you passed in. Messages When the state of the slider changes, it sends an event message to the host scene in the form of: {:value_changed, id, value} Options Sliders honor the following list of options. Styles Sliders honor the following styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Theme Sliders work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :border - the color of the slider line :thumb - the color of slider thumb Usage You should add/modify components via the helper functions in Scenic.Components Examples The following example creates a numeric slider and positions it on the screen. graph |&gt; slider ( { { 0 , 100 } , 0 } , id : :num_slider , translate : { 20 , 20 } ) The following example creates a list slider and positions it on the screen. graph |&gt; slider ( { [ :white , :cornflower_blue , :green , :chartreuse ] , :cornflower_blue } , id : :slider_id , translate : { 20 , 20 } )","ref":"Scenic.Component.Input.Slider.html"},{"type":"function","title":"Scenic.Component.Input.Slider.add_to_graph/3","doc":"Callback implementation for Scenic.Component.add_to_graph/3 .","ref":"Scenic.Component.Input.Slider.html#add_to_graph/3"},{"type":"function","title":"Scenic.Component.Input.Slider.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Component.Input.Slider.html#child_spec/1"},{"type":"module","title":"Scenic.Component.Input.TextField","doc":"Add a text field input to a graph Data initial_value initial_value - is the string that will be the starting value Messages When the text in the field changes, it sends an event message to the host scene in the form of: {:value_changed, id, value} Styles Text fields honor the following styles :hidden - If false the component is rendered. If true , it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Additional Options Text fields honor the following list of additional options. :filter - Adding a filter option restricts which characters can be entered into the text_field component. The value of filter can be one of: :all - Accept all characters. This is the default :number - Any characters from &quot;0123456789.,&quot; &quot;filter_string&quot; - Pass in a string containing all the characters you will accept function/1 - Pass in an anonymous function. The single parameter will be the character to be filtered. Return true or false to keep or reject it. :hint - A string that will be shown (greyed out) when the entered value of the component is empty. :hint_color - any valid color . :type - Can be one of the following options: :all - Show all characters. This is the default. :password - Display a string of '*' characters instead of the value. :width - set the width of the control. Theme Text fields work well with the following predefined themes: :light , :dark To pass in a custom theme, supply a map with at least the following entries: :text - the color of the text :background - the background of the component :border - the border of the component :focus - the border while the component has focus Usage You should add/modify components via the helper functions in Scenic.Components Examples graph |&gt; text_field ( &quot;Sample Text&quot; , id : :text_id , translate : { 20 , 20 } ) graph |&gt; text_field ( &quot;&quot; , id : :pass_id , type : :password , hint : &quot;Enter password&quot; , translate : { 20 , 20 } )","ref":"Scenic.Component.Input.TextField.html"},{"type":"function","title":"Scenic.Component.Input.TextField.add_to_graph/3","doc":"Callback implementation for Scenic.Component.add_to_graph/3 .","ref":"Scenic.Component.Input.TextField.html#add_to_graph/3"},{"type":"function","title":"Scenic.Component.Input.TextField.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Component.Input.TextField.html#child_spec/1"},{"type":"module","title":"Scenic.Component.Input.Toggle","doc":"Add toggle to a Scenic graph. Data on? on? - true if the toggle is on, pass false if not. Styles Toggles honor the following styles. The :light and :dark styles look nice. The other bundled themes...not so much. You can also supply your own theme . :hidden - If false the toggle is rendered. If true, it is skipped. The default is false . :theme - The color set used to draw. See below. The default is :dark Additional Options Toggles also honor the following additional options. :border_width - the border width. Defaults to 2 . :padding - the space between the border and the thumb. Defaults to 2 :thumb_radius - the radius of the thumb. This determines the size of the entire toggle. Defaults to 10 . :compat - use the pre-v0.11 positioning. The default is false Theme To pass in a custom theme, supply a map with at least the following entries: :border - the color of the border around the toggle :background - the color of the track when the toggle is off . :text - the color of the thumb. :thumb - the color of the track when the toggle is on . Optionally, you can supply the following entries: :thumb_pressed - the color of the thumb when pressed. Defaults to :gainsboro . Usage You should add/modify components via the helper functions in Scenic.Components Examples The following example creates a toggle. graph |&gt; toggle ( true , translate : { 20 , 20 } ) The next example makes a larger toggle. graph |&gt; toggle ( true , translate : { 20 , 20 } , thumb_radius : 14 )","ref":"Scenic.Component.Input.Toggle.html"},{"type":"function","title":"Scenic.Component.Input.Toggle.add_to_graph/3","doc":"Callback implementation for Scenic.Component.add_to_graph/3 .","ref":"Scenic.Component.Input.Toggle.html#add_to_graph/3"},{"type":"function","title":"Scenic.Component.Input.Toggle.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Scenic.Component.Input.Toggle.html#child_spec/1"},{"type":"behaviour","title":"Scenic.Primitive","doc":"Please see Primitives Overview for a high-level description. What is a primitive A primitive is the simplest thing Scenic knows how to draw on the screen. There is a, fixed set of them, but they can be combined in a graph to draw very complicated images. In general, each Primitive has a piece of data that it expects to operate on. For example, Primitive.Text requires a bitstring. Primitive.Circle requires a radius. Please see the documentation for each primitive for details. How to use primitives By far, the easiest way to use primitives is to import the helper functions in Scenic.Primitives . These helpers can both add primitives to a scene you are building and modify later as you react to events. import Scenic.Primitives @graph Scenic.Graph . build ( ) |&gt; rect ( { 100 , 50 } , stroke : { 1 , :yellow } ) |&gt; rectangle ( { 100 , 50 } , stroke : { 1 , :yellow } ) Once you get a primitive out of a graph via functions such as Graph.modify , or Graph.get , You can use the generic helpers in this module to access or manipulate them. Standard Primitives The set of primitives supported in Scenic is fixed in any given version. They have been chosen to provide the maximum flexibility when combined together, while still requiring the minimal amount of code and maintenance. See the documentation for each primitive's module for details on it's data type. Helper Primitive Module Description arc/3 Scenic.Primitive.Arc Draw an arc around a circle circle/3 Scenic.Primitive.Circle Draw a full circle ellipse/3 Scenic.Primitive.Ellipse Draw an ellipse group/3 Scenic.Primitive.Group Create a group line/3 Scenic.Primitive.Line Draw a line path/3 Scenic.Primitive.Path Draw a complicated path quad/3 Scenic.Primitive.Quad Draw a quad rect/3 Scenic.Primitive.Rectangle Draw a rectangle rrect/3 Scenic.Primitive.RoundedRectangle Draw a rounded rectangle script/3 Scenic.Primitive.Script Run a referenced draw script sector/3 Scenic.Primitive.Sector A boolean toggle control. sprites/3 Scenic.Primitive.Sprites Draw a sector text/3 Scenic.Primitive.Text Draw a string of text triangle/3 Scenic.Primitive.Triangle Draw a triangle","ref":"Scenic.Primitive.html"},{"type":"function","title":"Scenic.Primitive.build/3","doc":"Generic builder to create a new primitive. This function is used internally. You should almost always use the helpers in Scenic.Primitives instead. Parameters: module - The module of the primitive you are building data - the primitive-specific data being set into the primitive opts - a list of style and transform options to apply to the primitive Returns the built primitive.","ref":"Scenic.Primitive.html#build/3"},{"type":"callback","title":"Scenic.Primitive.compile/2","doc":"","ref":"Scenic.Primitive.html#c:compile/2"},{"type":"function","title":"Scenic.Primitive.contains_point?/2","doc":"Determines if a point is contained within a primitive. The supplied point must already be projected into the local coordinate space of the primitive. In other words, this test does NOT take into account any transforms that have been applied to the primitive. The input mechanism takes care of this for you by projecting incoming points by the inverse-matrix of a primitive before calling this function... Note that some primitives, such as Group, do not inherently have a notion of containing a point. In those cases, this function will always return false. Parameters: primitive - The primitive point - The point to test Returns true or false .","ref":"Scenic.Primitive.html#contains_point?/2"},{"type":"function","title":"Scenic.Primitive.delete_style/2","doc":"Deletes a specified style from a primitive. Does nothing if the style is not set. Parameters: primitive - The primitive type - atom representing the style to delete. Returns the updated primitive.","ref":"Scenic.Primitive.html#delete_style/2"},{"type":"function","title":"Scenic.Primitive.delete_transform/2","doc":"Deletes a specified transform from a primitive. Does nothing if the transform is not set. Parameters: primitive - The primitive type - atom representing the transform to delete. Returns the updated primitive.","ref":"Scenic.Primitive.html#delete_transform/2"},{"type":"function","title":"Scenic.Primitive.get/1","doc":"Get the value of the primitive-specific data. Parameters: primitive - The primitive Returns the value of the primitive-specific data.","ref":"Scenic.Primitive.html#get/1"},{"type":"function","title":"Scenic.Primitive.get_style/3","doc":"Get the value of a specific style set on the primitive. If the style is not set, it returns default Parameters: primitive - The primitive type - atom representing the style to get. default - default value to return if the style is not set. Returns the value of the style.","ref":"Scenic.Primitive.html#get_style/3"},{"type":"function","title":"Scenic.Primitive.get_styles/1","doc":"Get the styles map from a primitive. Parameters: primitive - The primitive Returns the map of styles set directly onto this primitive. This does not include any inherited styles.","ref":"Scenic.Primitive.html#get_styles/1"},{"type":"function","title":"Scenic.Primitive.get_transform/3","doc":"Get the value of a specific transform set on the primitive. If the transform is not set, it returns default Parameters: primitive - The primitive type - atom representing the transform to get. default - default value to return if the transform is not set. Returns the value of the transform.","ref":"Scenic.Primitive.html#get_transform/3"},{"type":"function","title":"Scenic.Primitive.get_transforms/1","doc":"Get the transforms map from a primitive. Parameters: primitive - The primitive Returns the map of transforms set directly onto this primitive. This does not include any inherited transforms.","ref":"Scenic.Primitive.html#get_transforms/1"},{"type":"function","title":"Scenic.Primitive.merge_opts/2","doc":"Merge an options-list of styles and transforms onto a primitive. This function might go through a name-change in the future. It is really more of a merge. The supplied list of styles and transforms Parameters: primitive - The primitive Returns the value of the primitive-specific data.","ref":"Scenic.Primitive.html#merge_opts/2"},{"type":"function","title":"Scenic.Primitive.put/3","doc":"Put primitive-specific data onto the primitive. Like many of the functions in the Scenic.Primitive module, you are usually better off using the helper functions in Scenic.Primitives instead. Parameters: primitive - The primitive data - The data to set opts - A list of style/transform options to merge Returns the updated primitive.","ref":"Scenic.Primitive.html#put/3"},{"type":"function","title":"Scenic.Primitive.put_style/3","doc":"Update the value of a specific style set on the primitive. Parameters: primitive - The primitive type - atom representing the style to get. data - the value to set on the style. Returns the updated primitive.","ref":"Scenic.Primitive.html#put_style/3"},{"type":"function","title":"Scenic.Primitive.put_styles/2","doc":"Update the styles map in a primitive. Parameters: primitive - The primitive styles - The new styles map Returns the primitive with the updated styles.","ref":"Scenic.Primitive.html#put_styles/2"},{"type":"function","title":"Scenic.Primitive.put_transform/3","doc":"Update the value of a specific transform set on the primitive. Parameters: primitive - The primitive type - atom representing the transform to get. data - the value to set on the transform. Returns the updated primitive.","ref":"Scenic.Primitive.html#put_transform/3"},{"type":"function","title":"Scenic.Primitive.put_transforms/2","doc":"Update the transforms map in a primitive. Parameters: primitive - The primitive transforms - The new transforms map Returns the primitive with the updated transforms.","ref":"Scenic.Primitive.html#put_transforms/2"},{"type":"callback","title":"Scenic.Primitive.valid_styles/0","doc":"","ref":"Scenic.Primitive.html#c:valid_styles/0"},{"type":"callback","title":"Scenic.Primitive.validate/1","doc":"","ref":"Scenic.Primitive.html#c:validate/1"},{"type":"type","title":"Scenic.Primitive.t/0","doc":"","ref":"Scenic.Primitive.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Arc","doc":"Draw an arc on the screen. An arc is a segment that traces part of the outline of a circle. If you are looking for something shaped like a piece of pie, then you want a segment. Arcs are often drawn on top of a segment to get an affect where a piece of pie is filled in, but only the curvy edge is stroked. Note that you can fill an arc, but that will result in a shape that looks like a potato wedge. Data {radius, angle} The data for an arc is a tuple. radius - the radius of the arc angle - the angle the arc is swept through in radians Note The format for Arc has changed since v0.10. It used to be {radius, start_angle, end_angle}. You can achieve the same effect in the new, simpler format by using the same radius and the new angle is the difference between the old end_angle and start_angle. Then you can apply a rotation transform to get it in the right position. Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the primitive cap - says how to draw the ends of the arc. stroke - stroke the outline of the primitive. In this case, only the curvy part. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; arc ( { 100 , 1.5 } , stroke : { 1 , :yellow } )","ref":"Scenic.Primitive.Arc.html"},{"type":"function","title":"Scenic.Primitive.Arc.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Arc.html#compile/2"},{"type":"function","title":"Scenic.Primitive.Arc.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Arc.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Arc.styles_t/0","doc":"","ref":"Scenic.Primitive.Arc.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Arc.t/0","doc":"","ref":"Scenic.Primitive.Arc.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Circle","doc":"Draw a circle on the screen. Data radius The data for an arc is a single number. radius - the radius of the arc Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the primitive stroke - stroke the outline of the primitive. In this case, only the curvy part. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; circle ( 100 , stroke : { 1 , :yellow } )","ref":"Scenic.Primitive.Circle.html"},{"type":"function","title":"Scenic.Primitive.Circle.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Circle.html#compile/2"},{"type":"function","title":"Scenic.Primitive.Circle.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Circle.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Circle.styles_t/0","doc":"","ref":"Scenic.Primitive.Circle.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Circle.t/0","doc":"","ref":"Scenic.Primitive.Circle.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Component","doc":"Add a child component to a graph. When a scene pushes a graph containing a Component to its ViewPort, a new scene, containing the component, is created and added as a child to the scene that created it. Any events the new component creates are sent up the parent. The parent can use functions in the Scenic.Scene module to manage its children, send them messages and such. The standard components, such as button, slider, etc. have wrapper functions making them very easy to add to a graph. However, if you have a custom component you can add it to any graph manually using the add_to_graph/3 function. You typically want to give components an :id . This will be used to identify events coming from that components back to your scene. import Components # contains the button helper graph |&gt; button ( &quot;Press Me&quot; , id : :press_me ) |&gt; MyComponent . add_to_graph ( { &quot;Some data&quot; , 123 } , id : :my_component )","ref":"Scenic.Primitive.Component.html"},{"type":"function","title":"Scenic.Primitive.Component.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Component.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Component.styles_t/0","doc":"","ref":"Scenic.Primitive.Component.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Component.t/0","doc":"","ref":"Scenic.Primitive.Component.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Ellipse","doc":"Draw an ellipse on the screen. Data {radius_1, radius_2} The data for an arc is a single number. radius_1 - the radius of the ellipse in one direction radius_2 - the radius of the ellipse in the other direction Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the primitive stroke - stroke the outline of the primitive. In this case, only the curvy part. Note: you can achieve the same effect with a Circle primitive by applying a :scale transform to it with unequal values on the axes Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; ellipse ( { 75 , 100 } , stroke : { 1 , :yellow } )","ref":"Scenic.Primitive.Ellipse.html"},{"type":"function","title":"Scenic.Primitive.Ellipse.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Ellipse.html#compile/2"},{"type":"function","title":"Scenic.Primitive.Ellipse.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Ellipse.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Ellipse.styles_t/0","doc":"","ref":"Scenic.Primitive.Ellipse.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Ellipse.t/0","doc":"","ref":"Scenic.Primitive.Ellipse.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Group","doc":"A container to hold other primitives. Any styles placed on a group will be inherited by the primitives in the group. Any transforms placed on a group will be multiplied into the transforms in the primitives in the group. Data uids The data for an arc is a list of internal uids for the primitives it contains. You will not typically add these ids yourself. You should use the helper functions with a callback to do that for you. See Usage below. Styles The group is special in that it accepts all styles and transforms, even if they are non-standard. These are then inherited by any primitives, including SceneRefs. Any styles you place on the group itself will be inherited by the primitives contained in the group. However, these styles will not be inherited by any component in the group. Transforms If you add a transform to a group, then everything in the group will also be moved by that transform, including child components. This is a very handy way to create some UI, then position, scale, or rotate it as needed without having to adjust the inner elements. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; group ( fn ( g ) -&gt; g |&gt; rect ( { 200 , 100 } , fill : :blue ) |&gt; test ( &quot;In a Group&quot; , fill : :yellow , translate : { 20 , 40 } ) end , translate : { 100 , 100 } , font : :roboto )","ref":"Scenic.Primitive.Group.html"},{"type":"function","title":"Scenic.Primitive.Group.delete/2","doc":"","ref":"Scenic.Primitive.Group.html#delete/2"},{"type":"function","title":"Scenic.Primitive.Group.increment/2","doc":"","ref":"Scenic.Primitive.Group.html#increment/2"},{"type":"function","title":"Scenic.Primitive.Group.insert_at/3","doc":"","ref":"Scenic.Primitive.Group.html#insert_at/3"},{"type":"function","title":"Scenic.Primitive.Group.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Group.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Group.styles_t/0","doc":"","ref":"Scenic.Primitive.Group.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Group.t/0","doc":"","ref":"Scenic.Primitive.Group.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Line","doc":"Draw a line on the screen. Data {point_a, point_b} The data for a line is a tuple containing two points. point_a - position to start drawing from point_b - position to draw to Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. cap - says how to draw the ends of the line. stroke - stroke the outline of the primitive. In this case, only the curvy part. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; line ( { { 0 , 0 } , { 20 , 40 } } , stroke : { 1 , :yellow } )","ref":"Scenic.Primitive.Line.html"},{"type":"function","title":"Scenic.Primitive.Line.bounds/3","doc":"","ref":"Scenic.Primitive.Line.html#bounds/3"},{"type":"function","title":"Scenic.Primitive.Line.centroid/1","doc":"Returns a the midpoint of the line. This is used as the default pin when applying rotate or scale transforms.","ref":"Scenic.Primitive.Line.html#centroid/1"},{"type":"function","title":"Scenic.Primitive.Line.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Line.html#compile/2"},{"type":"function","title":"Scenic.Primitive.Line.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Line.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Line.styles_t/0","doc":"","ref":"Scenic.Primitive.Line.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Line.t/0","doc":"","ref":"Scenic.Primitive.Line.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Path","doc":"Draw a complex path on the screen described by a list of actions. Data list_of_commands The data for a path is a list of commands. They are interpreted in order when the path is drawn. See below for the commands it will accept. Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the primitive stroke - stroke the outline of the primitive. In this case, only the curvy part. cap - says how to draw the ends of the line. join - control how segments are joined. miter_limit - control how segments are joined. Commands :begin - start a new path segment :close_path - draw a line back to the start of the current segment {:move_to, x, y} - move the current draw position {:line_to, x, y} - draw a line from the current position to a new location. {:bezier_to, c1x, c1y, c2x, c2y, x, y} - draw a bezier curve from the current position to a new location. {:quadratic_to, cx, cy, x, y} - draw a quadratic curve from the current position to a new location. {:arc_to, x1, y1, x2, y2, radius} - draw an arc from the current position to a new location. Path vs. Script Both the Path and the Script primitives use the Scenic.Script to create scripts that are sent to the driver for drawing. The difference is that a Path is far more limited in what it can do, and is inserted inline with the compiled graph that created it. The script primitive, on the other hand, has full access to the API set of Scenic.Script and accesses scripts by reference. The inline vs. reference difference is important. A simple path will consume fewer resources. BUT it will cause the entire graph to be recompiled and resent to the driver if you change it. A script primitive references a script that you create separately from the graph. This means that any changes to the graph (such as an animation) will NOT need to recompile or resend the script. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; path ( [ :begin , { :move_to , 0 , 0 } , { :bezier_to , 0 , 20 , 0 , 50 , 40 , 50 } , { :line_to , 30 , 60 } , :close_path ] , fill : :blue )","ref":"Scenic.Primitive.Path.html"},{"type":"function","title":"Scenic.Primitive.Path.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled. Note: Path is a &quot;Meta&quot; primitive. It isn't really a primitive that is represented in a draw script. Instead, it generates it's own mini-script, which is included inline to the graph it is contained in. Note: The compiled script is backwards. This is an inline script, which means it is inserted into a larger script as part of the graph compile process and Script.finish() will be called on that later.","ref":"Scenic.Primitive.Path.html#compile/2"},{"type":"function","title":"Scenic.Primitive.Path.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Path.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Path.cmd/0","doc":"","ref":"Scenic.Primitive.Path.html#t:cmd/0"},{"type":"type","title":"Scenic.Primitive.Path.styles_t/0","doc":"","ref":"Scenic.Primitive.Path.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Path.t/0","doc":"","ref":"Scenic.Primitive.Path.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Quad","doc":"Draw a quad on the screen. Data {point_a, point_b, point_c, point_d} The data for a line is a tuple containing four points. point_a - position to start drawing from point_b - position to draw to point_c - position to draw to point_d - position to draw to Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the primitive stroke - stroke the outline of the primitive. In this case, only the curvy part. join - control how segments are joined. miter_limit - control how segments are joined. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; quad ( { { 10 , 0 } , { 20 , 40 } , { 17 , 50 } , { 0 , 10 } } , stroke : { 1 , :yellow } )","ref":"Scenic.Primitive.Quad.html"},{"type":"function","title":"Scenic.Primitive.Quad.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Quad.html#compile/2"},{"type":"function","title":"Scenic.Primitive.Quad.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Quad.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Quad.styles_t/0","doc":"","ref":"Scenic.Primitive.Quad.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Quad.t/0","doc":"","ref":"Scenic.Primitive.Quad.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Rectangle","doc":"Draw a rectangle on the screen. Data {width, height} The data for a line is a tuple containing two numbers. width - width of the rectangle height - height of the rectangle Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the primitive stroke - stroke the outline of the primitive. In this case, only the curvy part. join - control how segments are joined. miter_limit - control how segments are joined. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; rect ( { 100 , 50 } , stroke : { 1 , :yellow } ) |&gt; rectangle ( { 100 , 50 } , stroke : { 1 , :yellow } ) Note: rect is a shortcut for rectangle and they can be used interchangeably.","ref":"Scenic.Primitive.Rectangle.html"},{"type":"function","title":"Scenic.Primitive.Rectangle.centroid/1","doc":"Returns the centroid of the rectangle. This is used as the default pin when applying rotate or scale transforms.","ref":"Scenic.Primitive.Rectangle.html#centroid/1"},{"type":"function","title":"Scenic.Primitive.Rectangle.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Rectangle.html#compile/2"},{"type":"function","title":"Scenic.Primitive.Rectangle.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Rectangle.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Rectangle.styles_t/0","doc":"","ref":"Scenic.Primitive.Rectangle.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Rectangle.t/0","doc":"","ref":"Scenic.Primitive.Rectangle.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.RoundedRectangle","doc":"Draw a rectangle with rounded corners on the screen. Data {width, height, radius} The data for a line is a tuple containing three numbers. width - width of the rectangle height - height of the rectangle radius - radius of the corners Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the primitive stroke - stroke the outline of the primitive. In this case, only the curvy part. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; rrect ( { 100 , 50 , 4 } , stroke : { 1 , :yellow } ) |&gt; rounded_rectangle ( { 100 , 50 , 4 } , stroke : { 1 , :yellow } ) Note: rrect is a shortcut for rounded_rectangle and they can be used interchangeably.","ref":"Scenic.Primitive.RoundedRectangle.html"},{"type":"function","title":"Scenic.Primitive.RoundedRectangle.centroid/1","doc":"Returns a the centroid of the rectangle. This is used as the default pin when applying rotate or scale transforms.","ref":"Scenic.Primitive.RoundedRectangle.html#centroid/1"},{"type":"function","title":"Scenic.Primitive.RoundedRectangle.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.RoundedRectangle.html#compile/2"},{"type":"function","title":"Scenic.Primitive.RoundedRectangle.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.RoundedRectangle.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.RoundedRectangle.styles_t/0","doc":"","ref":"Scenic.Primitive.RoundedRectangle.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.RoundedRectangle.t/0","doc":"","ref":"Scenic.Primitive.RoundedRectangle.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Script","doc":"A reference to a draw script. The Script primitive is used to refer to a script that you created and loaded into the ViewPort separately from the graph. This script also has full access to the Scenic.Script API. For example, the check mark shape in the Checkbox control is a draw script that is reference by the checkbox control's graph. A graph can reference the same script multiple times, which is very efficient as the script is only sent to the drivers once. If the graph is modified later, then any scripts it references will not need to be resent to the drivers. This is an isolation of concerns. The same is true in reverse. If you rebuild a script and send it to the ViewPort , the script will be sent to the drivers, but any graphs that reference it do not need to be. Script vs. Path Both the Path and the Script primitives use the Scenic.Script to create scripts that are sent to the driver for drawing. The difference is that a Path is far more limited in what it can do, and is inserted inline with the compiled graph that created it. The script primitive, on the other hand, has full access to the API set of Scenic.Script and accesses scripts by reference. The inline vs. reference difference is important. A simple path will consume fewer resources. BUT it will cause the entire graph to be recompiled and resent to the driver if you change it. A script primitive references a script that you create separately from the graph. This means that any changes to the graph (such as an animation) will NOT need to recompile or resend the script. Usage You should add/modify primitives via the helper functions in Scenic.Primitives This example is based on the check mark script from the Checkbox control. alias Scenic.Script # build the checkmark script my_script = Script . start ( ) |&gt; Script . push_state ( ) |&gt; Script . join ( :round ) |&gt; Script . stroke_width ( 3 ) |&gt; Script . stroke_color ( :light_blue ) |&gt; Script . begin_path ( ) |&gt; Script . move_to ( 0 , 8 ) |&gt; Script . line_to ( 5 , 13 ) |&gt; Script . line_to ( 12 , 1 ) |&gt; Script . stroke_path ( ) |&gt; Script . pop_state ( ) |&gt; Script . finish ( ) # push the script to the ViewPort scene = push_script ( scene , my_script , &quot;My Script&quot; ) # refer to the script in a graph, and position it graph |&gt; script ( &quot;My Script&quot; , translate : { 3 , 2 } )","ref":"Scenic.Primitive.Script.html"},{"type":"function","title":"Scenic.Primitive.Script.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Script.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Script.styles_t/0","doc":"","ref":"Scenic.Primitive.Script.html#t:styles_t/0"},{"type":"module","title":"Scenic.Primitive.Sector","doc":"Draw an sector on the screen. An sector is a shape that looks like a piece of pie. Data {radius, angle} The data for an Sector is a tuple. radius - the radius of the Sector angle - the angle the Sector is swept through in radians Note The format for Sector has changed since v0.10. It used to be {radius, start_angle, end_angle}. You can achieve the same effect in the new, simpler format by using the same radius and the new angle is the difference between the old end_angle and start_angle. Then you can apply a rotation transform to get it in the right position. Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the primitive stroke - stroke the outline of the primitive. In this case, only the curvy part. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; sector ( { 100 , 1.5 } , stroke : { 1 , :yellow } )","ref":"Scenic.Primitive.Sector.html"},{"type":"function","title":"Scenic.Primitive.Sector.bounds/2","doc":"","ref":"Scenic.Primitive.Sector.html#bounds/2"},{"type":"function","title":"Scenic.Primitive.Sector.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Sector.html#compile/2"},{"type":"function","title":"Scenic.Primitive.Sector.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Sector.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Sector.styles_t/0","doc":"","ref":"Scenic.Primitive.Sector.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Sector.t/0","doc":"","ref":"Scenic.Primitive.Sector.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Sprites","doc":"Draw one or more sprites from a single source image. Overview The term &quot;sprite&quot; means one or more subsections of a larger image that get rendered to the screen. You can do many things with sprites including animations and zooming in and out of an image and more. Data Format { source_image_id, draw_commands } source_image_id refers to an image in the Scenic.Assets.Static library. This can be either the file name from your asset sources or an alias that you set up in your configuration scripts. draw_commands is a list of source/destination drawing commands that are executed in order when the primitive renders. [ {{src_x, src_y}, {src_w, src_h}, {dst_x, dst_y}, {dst_w, dst_h}} ] Each draw command is an x/y position and width/height of a rectangle in the source image, followed by the x/y position and width/height rectangle in the destination space. In other words, This copies rectangular images from the source indicated by image_id and draws them in the coordinate space of the graph. The size of the destination rectangle does NOT need to be the same as the source. This allows you to grow or shrink the image as needed. You can use this to zoom in or zoom out of the source image. Animations Sprites are common in the game industry and can be used to create animations, manage large numbers of small images and more. For example, in many games a character walking is built as a series of frames in an animation that all live together in a single image file. When it comes time to draw, the different frames are rendered to the screen one after the other to give the appearance that the character is animating. A simpler example would be an image of a device with a blinking light on it. The same device would be in the source image twice. Once with the light on, and once with it off. Then you render the appropriate portion of source image on a timer. Usage You should add/modify primitives via the helper functions in Scenic.Primitives This example draws the same source rectangle twice in different locations. The first is at full size, the second is expanded 10x. graph |&gt; sprites ( { &quot;images/my_sprites.png&quot; , [ { { 0 , 0 } , { 10 , 20 } , { 10 , 10 } , { 10 , 20 } } , { { 0 , 0 } , { 10 , 20 } , { 100 , 100 } , { 100 , 200 } } , ] } )","ref":"Scenic.Primitive.Sprites.html"},{"type":"function","title":"Scenic.Primitive.Sprites.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Sprites.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Sprites.draw_cmd/0","doc":"","ref":"Scenic.Primitive.Sprites.html#t:draw_cmd/0"},{"type":"type","title":"Scenic.Primitive.Sprites.draw_cmds/0","doc":"","ref":"Scenic.Primitive.Sprites.html#t:draw_cmds/0"},{"type":"type","title":"Scenic.Primitive.Sprites.styles_t/0","doc":"","ref":"Scenic.Primitive.Sprites.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Sprites.t/0","doc":"","ref":"Scenic.Primitive.Sprites.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Text","doc":"Draw text on the screen. Data text The data for a Text primitive is a bitstring text - the text to draw Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the text. Only solid colors! font - name (or key) of font to use font_size - point size of the font text_align - horizontal alignment of lines of text text_base - vertical alignment of lines of text line_height - spacing between lines of text Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; text ( &quot;Some example text&quot; , fill : :green , font : :roboto_mono , font_size : 64 )","ref":"Scenic.Primitive.Text.html"},{"type":"function","title":"Scenic.Primitive.Text.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Text.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Text.styles_t/0","doc":"","ref":"Scenic.Primitive.Text.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Text.t/0","doc":"","ref":"Scenic.Primitive.Text.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Triangle","doc":"Draw a triangle on the screen. Data {point_a, point_b, point_c} The data for a line is a tuple containing three points. point_a - position to start drawing from point_b - position to draw to point_c - position to draw to Styles This primitive recognizes the following styles hidden - show or hide the primitive scissor - &quot;scissor rectangle&quot; that drawing will be clipped to. fill - fill in the area of the primitive stroke - stroke the outline of the primitive. In this case, only the curvy part. join - control how segments are joined. miter_limit - control how segments are joined. Usage You should add/modify primitives via the helper functions in Scenic.Primitives graph |&gt; triangle ( { { 10 , 0 } , { 20 , 40 } , 0 , 20 } } , stroke : { 1 , :yellow } )","ref":"Scenic.Primitive.Triangle.html"},{"type":"function","title":"Scenic.Primitive.Triangle.centroid/1","doc":"Returns the centroid of the triangle. This is used as the default pin when applying rotate or scale transforms.","ref":"Scenic.Primitive.Triangle.html#centroid/1"},{"type":"function","title":"Scenic.Primitive.Triangle.compile/2","doc":"Compile the data for this primitive into a mini script. This can be combined with others to generate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Triangle.html#compile/2"},{"type":"function","title":"Scenic.Primitive.Triangle.valid_styles/0","doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Triangle.html#valid_styles/0"},{"type":"type","title":"Scenic.Primitive.Triangle.styles_t/0","doc":"","ref":"Scenic.Primitive.Triangle.html#t:styles_t/0"},{"type":"type","title":"Scenic.Primitive.Triangle.t/0","doc":"","ref":"Scenic.Primitive.Triangle.html#t:t/0"},{"type":"behaviour","title":"Scenic.Primitive.Style","doc":"Modify the look of a primitive by applying a Style. Styles are optional modifiers that you can put on any primitive. Each style does a specific thing and some only affect certain primitives. Graph . build ( ) |&gt; rect ( { 100 , 50 } , fill : blue , stroke : { 2 , :yellow } ) The above example draws a rectangle, that is filled with blue and outlined in yellow. The primitive is Scenic.Primitive.Rectangle and the styles are :fill and :stroke . Inheritance Styles are inherited by primitives that are placed in a group. This allows you to set styles that will be used by many primitives. Those primitives can override the style set on the group by setting it again. Example: Graph . build ( font : :roboto , font_size : 24 ) |&gt; text ( &quot;Some text drawn using roboto&quot; ) |&gt; text ( &quot;Text using roboto_mono&quot; , font : :roboto_mono ) |&gt; text ( &quot;back to drawing in roboto&quot; ) In the above example, the text primitives inherit the fonts set on the root group when the Graph is created. The middle text primitive overrides the :font style, but keeps using the :font_size set on the group. Components In general, styles are NOT inherited across a component boundary unless they are explicitly set on the component itself. This allows components to manage their own consistent look and feel. The exception to this rule is the :theme style. This IS inherited across groups and into components. This allows you to set an overall color scheme such as :light or :dark that makes sense with the components.","ref":"Scenic.Primitive.Style.html"},{"type":"function","title":"Scenic.Primitive.Style.default/0","doc":"The default styles if none are set. %{ font : :roboto , line_height : 1.2 , font_size : 24 , text_align : :left , text_base : :alphabetic }","ref":"Scenic.Primitive.Style.html#default/0"},{"type":"function","title":"Scenic.Primitive.Style.valid_styles/0","doc":"List of the valid style types","ref":"Scenic.Primitive.Style.html#valid_styles/0"},{"type":"callback","title":"Scenic.Primitive.Style.validate/1","doc":"","ref":"Scenic.Primitive.Style.html#c:validate/1"},{"type":"type","title":"Scenic.Primitive.Style.t/0","doc":"","ref":"Scenic.Primitive.Style.html#t:t/0"},{"type":"module","title":"Scenic.Primitive.Style.Cap","doc":"Set how to draw the end of a line. Example: graph |&gt; line ( { { 0 , 0 } , { 100 , 100 } } , cap : :round ) Data Format Cap can be any of the following values: :butt - End of the line is flat, passing through the end point. :round - End of the line is round, radiating from the end point. :square - End of the line is flat, but projecting a square around the end point.","ref":"Scenic.Primitive.Style.Cap.html"},{"type":"module","title":"Scenic.Primitive.Style.Fill","doc":"Fill primitives with the specified paint. Example: graph |&gt; rectangle ( { 10 , 20 } , fill : :blue ) Data Format Any valid paint. This can any be any paint format defined by the following modules: Scenic.Primitive.Style.Paint.Color Scenic.Primitive.Style.Paint.Image Scenic.Primitive.Style.Paint.LinearGradient Scenic.Primitive.Style.Paint.RadialGradient Scenic.Primitive.Style.Paint.Stream See the documentation for the paint module for further details.","ref":"Scenic.Primitive.Style.Fill.html"},{"type":"module","title":"Scenic.Primitive.Style.Font","doc":"Set the font used to draw text. Example: graph |&gt; text ( &quot;Hello World&quot; , font : &quot;fonts/my_fancy_font.ttf&quot; ) Data Format You can use any font loaded into your static assets library. You can also refer to the font by either it's library file name, or an alias that you have configured. The following example shows both ways to identify a font. Graph . build ( ) |&gt; text ( &quot;By name&quot; , font : &quot;fonts/roboto.ttf&quot; ) |&gt; text ( &quot;By alias&quot; , font : :roboto ) Standard Fonts You are highly encouraged to use Roboto and Roboto Mono as the standard system fonts for Scenic. Aliases are automatically set up for them. Alias Font :roboto &quot;fonts/roboto.ttf&quot; :roboto_mono &quot;fonts/roboto_mono.ttf&quot; It is expected that you will include the roboto.ttf and roboto_mono.ttf files in your asset source folder. You don't technically need to, but if you don't then those aliases won't work.","ref":"Scenic.Primitive.Style.Font.html"},{"type":"function","title":"Scenic.Primitive.Style.Font.err_invalid/1","doc":"","ref":"Scenic.Primitive.Style.Font.html#err_invalid/1"},{"type":"module","title":"Scenic.Primitive.Style.FontSize","doc":"The point-size to draw text in. Example: graph |&gt; text ( &quot;Small&quot; , font_size : 12.5 ) |&gt; text ( &quot;Large&quot; , font_size : 64 ) Data Format Any number greater than or equal to 6.","ref":"Scenic.Primitive.Style.FontSize.html"},{"type":"module","title":"Scenic.Primitive.Style.Hidden","doc":"Flags whether or not to draw a primitive. Example: graph |&gt; rect ( { 100 , 200 } , hidden : true ) Data Format true - &quot;Hide&quot; the primitive. Drawing is skipped. false - &quot;Show&quot; the primitive. Drawing is run. Note: setting hidden: true on a group will hide all the primitives in the group. This is very efficient as it simply skips drawing the group and everything in it. The Hidden style is a handy way to create a set of primitives that you can quickly show and hide on demand.","ref":"Scenic.Primitive.Style.Hidden.html"},{"type":"module","title":"Scenic.Primitive.Style.Input","doc":"Flags whether or not track cursor_button events on this primitive. Example: graph |&gt; rect ( { 100 , 200 } , id : :my_rect , input : :cursor_button ) Data Format The data for the input style is the type of input you want to receive when the cursor is positioned over the primitive. This can be any single member or combination (in a list) of the following input types :cursor_button - Went when a button on the cursor (mouse) was used. :cursor_pos - Sent when the cursor moves over the primitive. :cursor_scroll - Sent when the cursor's scroll wheel moves. graph |&gt; rect ( { 100 , 200 } , id : :my_rect , input : [ :cursor_button , :cursor_pos ] )","ref":"Scenic.Primitive.Style.Input.html"},{"type":"module","title":"Scenic.Primitive.Style.Join","doc":"Set how to connect two lines in a path. Works with primitives that have clear joints, such as Rectangle, Quad, Triangle, and Path. Example: graph |&gt; triangle ( { { 0 , 40 } , { 40 , 40 } , { 40 , 0 } } join : :round , stroke : { 2 , :green } ) Data Format Join can be any of the following values: :miter - Miter the pointy part of the joint. :round - Round the entire joint. :bevel - Bevel the joint.","ref":"Scenic.Primitive.Style.Join.html"},{"type":"module","title":"Scenic.Primitive.Style.LineHeight","doc":"Adjust the vertical spacing of lines of text in a single block. Data Format This is expressed as a percentage of the size of the font. So a value of 1.2 would mean 120% the font size as the spacing from baseline to baseline. The behavior of this style is intended to be very similar to the line_height CSS style. Example: graph |&gt; text ( &quot;Some Text \\r \\n More Text&quot; , line_height : 1.1 ) The default if :line_height is not specified is 1.2 . Set this style if you want to override it. Note This style is not actually represented in the low-level Scenic.Script format. Instead it is a hint that is processed when a graph is &quot;compiled&quot; into a script. Essentially it instructs the graph compiler to automatically apply transforms to each line in a multi-line text string that separate out the lines of text from each other.","ref":"Scenic.Primitive.Style.LineHeight.html"},{"type":"module","title":"Scenic.Primitive.Style.MiterLimit","doc":"Automatically miter joints if they are too sharp. Example: graph |&gt; triangle ( { { 0 , 40 } , { 40 , 40 } , { 40 , 0 } } , miter_limit : 2 , stroke : { 2 , :green } ) Data Format A number greater than zero.","ref":"Scenic.Primitive.Style.MiterLimit.html"},{"type":"module","title":"Scenic.Primitive.Style.Scissor","doc":"Define a &quot;Scissor Rectangle&quot; that drawing will be clipped to. Example: graph |&gt; triangle ( { { 0 , 40 } , { 40 , 40 } , { 40 , 0 } } , miter_limit : 2 , fill : :green , scissor : { 20 , 40 } ) Data Format {width, height} width - Width of the scissor rectangle. height - Height of the scissor rectangle.","ref":"Scenic.Primitive.Style.Scissor.html"},{"type":"module","title":"Scenic.Primitive.Style.Stroke","doc":"Draw an outline around a primitive with the given paint. Example: graph |&gt; triangle ( { { 0 , 40 } , { 40 , 40 } , { 40 , 0 } } miter_limit : 2 , stroke : { 2 , :green } ) Data Format {width, paint} width - Width of the border being stroked. paint - Any paint data. The paint can any be any format defined by the following modules: Scenic.Primitive.Style.Paint.Color Scenic.Primitive.Style.Paint.Image Scenic.Primitive.Style.Paint.LinearGradient Scenic.Primitive.Style.Paint.RadialGradient Scenic.Primitive.Style.Paint.Stream See the documentation for the paint module for further details.","ref":"Scenic.Primitive.Style.Stroke.html"},{"type":"module","title":"Scenic.Primitive.Style.TextAlign","doc":"Set the horizontal alignment of the text with regard to the start point. Example: graph |&gt; text ( &quot;Some Text&quot; , text_align : :center ) Data Format TextAlign can be any one of the following values :left - Left side alignment. :right - Right side alignment. :center - Centered alignment.","ref":"Scenic.Primitive.Style.TextAlign.html"},{"type":"module","title":"Scenic.Primitive.Style.TextBase","doc":"Set the vertical alignment of text. Example: graph |&gt; text ( &quot;Some Text&quot; , text_base : :alphabetic ) Data Format TextBase can be any one of the following values :top - The top of the em square. :middle - The middle of the em square. :alphabetic - The normal alphabetic baseline. :bottom - The bottom of the bounding box. The default if :text_base is undefined is :alphabetic . The alphabetic baseline is at the bottom of characters such as &quot;a&quot;, but above the bottom of characters with descending tails, such as &quot;g&quot; or &quot;y&quot;. This the standard baseline from the world of typography. It may be unintuitive if you expected it to be at the top of the characters, like most of the primitives in Scenic. If that is what you want, then set :text_base to :top","ref":"Scenic.Primitive.Style.TextBase.html"},{"type":"module","title":"Scenic.Primitive.Style.Theme","doc":"Themes are a way to bundle up a set of colors that are intended to be used by components invoked by a scene. There are a set of pre-defined themes. You can also pass in a map of color values. Unlike other styles, The currently set theme is given to child components. Each component gets to pick, choose, or ignore any colors in a given style. Predefined Themes :dark - This is the default and most common. Use when the background is dark. :light - Use when the background is light colored. Specialty Themes The remaining themes are designed to color the standard components and don't really make much sense when applied to the root of a graph. You could, but it would be... interesting. The most obvious place to use them is with Button components. :primary - Blue background. This is the primary button type indicator. :secondary - Grey background. Not primary type indicator. :success - Green background. :danger - Red background. Use for irreversible or dangerous actions. :warning - Orange background. :info - Lightish blue background. :text - Transparent background.","ref":"Scenic.Primitive.Style.Theme.html"},{"type":"module","title":"Scenic.Primitive.Style.Paint","doc":"Paint is used to &quot;fill&quot; the area of primitives. When you apply the :fill style to a primitive, you must supply valid paint data. There are five types of paint. Scenic.Primitive.Style.Paint.Color Scenic.Primitive.Style.Paint.Image Scenic.Primitive.Style.Paint.LinearGradient Scenic.Primitive.Style.Paint.RadialGradient Scenic.Primitive.Style.Paint.Stream See the documentation for the paint module for further details.","ref":"Scenic.Primitive.Style.Paint.html"},{"type":"module","title":"Scenic.Primitive.Style.Paint.Color","doc":"Fill a primitive with a single color The color paint is used as the data for the :fill style. Data Format {:color, valid_color} The full format is a tuple with two parameters. The first is the :color atom indicating that this is color paint data. The second is any valid color (see below). Valid Colors You can pass in any color format that is supported by the Scenic.Color.to_rgba/1 function. This includes any named color. See the documentation for Scenic.Color for more information. Example: graph |&gt; rect ( { 100 , 200 } , fill : { :color , :blue } ) |&gt; rect ( { 100 , 200 } , stroke : { 1 , { :color , :green } } ) Shortcut Format valid_color Because the color paint type is used so frequently, you can simply pass in any valid color and the :fill style will infer that it is to be used as paint. Example: graph |&gt; rect ( { 100 , 200 } , fill : :blue ) |&gt; rect ( { 100 , 200 } , stroke : { 1 , :green } )","ref":"Scenic.Primitive.Style.Paint.Color.html"},{"type":"module","title":"Scenic.Primitive.Style.Paint.Image","doc":"Fill a primitive with an image from Scenic.Assets.Static Data Format {:image, id} Fill with the static image indicated by id The id can be either the name of the file when the static assets library was built or an alias that you set up in your conig. The following example has the alias :parrot pointing to the &quot;images/parrot.png&quot; file, so both fills are identical. Graph . build ( ) |&gt; rect ( { 100 , 50 } , fill : { :image , &quot;images/parrot.jpg&quot; } ) |&gt; rect ( { 100 , 50 } , fill : { :image , :parrot } ) Note that this is a fill, and the images will repeat automatically if the primitive being filled is larger than the source image. If you want more control, such as no repeats, a subsection of the image, or scaling the image up or down when you draw it, use the Sprites primitive.","ref":"Scenic.Primitive.Style.Paint.Image.html"},{"type":"module","title":"Scenic.Primitive.Style.Paint.LinearGradient","doc":"Fill a primitive with a linear gradient between two colors Data Format {:linear, {start_x, start_y, end_x, end_y, color_start, color_end}} This example fills with a smooth linear gradient that goes from blue in the upper left corner of the rect to yellow in the lower right corner. Graph . build ( ) |&gt; rect ( { 100 , 50 } , fill : { :linear , { 0 , 0 , 100 , 50 , :blue , :yellow } } )","ref":"Scenic.Primitive.Style.Paint.LinearGradient.html"},{"type":"module","title":"Scenic.Primitive.Style.Paint.RadialGradient","doc":"Fill a primitive with a radial gradient between two colors Data Format {:radial, {center_x, center_y, inner_radius, outer_radius, color_start, color_end}} This example fills a rect with a smooth linear gradient that goes from blue in the center and transitions to yellow in an outer ring. Graph . build ( ) |&gt; rect ( { 100 , 50 } , fill : { :linear , { 50 , 25 , 10 , 45 , :blue , :yellow } } )","ref":"Scenic.Primitive.Style.Paint.RadialGradient.html"},{"type":"module","title":"Scenic.Primitive.Style.Paint.Stream","doc":"Fill a primitive with an image or bitmap from Scenic.Assets.Stream Data Format {:stream, key} Fill with the static image indicated by key This example fills a rect with the contents of the &quot;color_cycle&quot; stream. When the source of the stream updates the bitmap it contains, the rect's fill will automatically be updated. Graph . build ( ) |&gt; rect ( { 100 , 50 } , fill : { :stream , &quot;color_cycle&quot; } ) See the documentation for Scenic.Assets.Stream for more information on how to create and manage streams.","ref":"Scenic.Primitive.Style.Paint.Stream.html"},{"type":"behaviour","title":"Scenic.Primitive.Transform","doc":"Change the position, rotation, scale and more of a primitive. Unlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix transforms. This is common in video games and provides powerful control of your primitives. A matrix is an array of numbers that can be used to change the positions, rotations, scale and more of locations. Don't worry! You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers. Multiple transforms can be applied to any primitive. Transforms combine down the graph to create a very flexible way to manage your scene. There are a fixed set of transform helpers that create matrices for you. Matrix hand specify a matrix. Pin set a pin to rotate or scale around. Most primitives define a sensible default pin. Rotate rotate around the pin. Scale scale larger or smaller. Centered around the pin. Translate move/translate horizontally and veritcally. Specifying Transforms You apply transforms to a primitive the same way you specify styles. graph = Graph . build |&gt; circle ( 100 , fill : { :color , :green } , translate : { 200 , 200 } ) |&gt; ellipse ( { 40 , 60 , fill : { :color , :red } , rotate : 0.4 , translate : { 100 , 100 } ) Don't worry about the order you apply transforms to a single object. Scenic will multiply them together in the correct way when it comes time to render them.","ref":"Scenic.Primitive.Transform.html"},{"type":"function","title":"Scenic.Primitive.Transform.combine/1","doc":"Given a Map describing the transforms on a primitive, calculate the combined matrix that should be applied. This is trickier than just multiplying them together. Rotations, translations and scale, need to be done in the right order, which is why this function is provided. You will not normally need to use this function. It is used internally by the input system.","ref":"Scenic.Primitive.Transform.html#combine/1"},{"type":"callback","title":"Scenic.Primitive.Transform.validate/1","doc":"","ref":"Scenic.Primitive.Transform.html#c:validate/1"},{"type":"module","title":"Scenic.Primitive.Transform.Matrix","doc":"Apply an arbitrary matrix. Applies an arbitrary 4x4 matrix to a primitive. For now, only the 2-D part of the matrix actually does anything. Am using 4x4 though for future compatibility. Example: @matrix [ 0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 , 11 , 12 , 13 , 14 , 15 ] |&gt; Scenic.Math.Matrix.Matrix.Utils . to_binary ( ) graph |&gt; text ( &quot;Transformer!&quot; , matrix : @matrix )","ref":"Scenic.Primitive.Transform.Matrix.html"},{"type":"function","title":"Scenic.Primitive.Transform.Matrix.validate/1","doc":"Callback implementation for Scenic.Primitive.Transform.validate/1 .","ref":"Scenic.Primitive.Transform.Matrix.html#validate/1"},{"type":"module","title":"Scenic.Primitive.Transform.Pin","doc":"Set the pin for rotate and scale transforms. When rotating or scaling, you need to set the point that doesn't move. This is the pin. If you don't set one, Scenic will try to use a sensible default for whatever primitive you are transforming. Use the :pin option to set it explicitly {pin_x, pin_y} Example: graph |&gt; text ( &quot;Rotated!&quot; , rotate : 1.2 , pin : { 10 , 20 } )","ref":"Scenic.Primitive.Transform.Pin.html"},{"type":"function","title":"Scenic.Primitive.Transform.Pin.validate/1","doc":"Callback implementation for Scenic.Primitive.Transform.validate/1 .","ref":"Scenic.Primitive.Transform.Pin.html#validate/1"},{"type":"module","title":"Scenic.Primitive.Transform.Rotate","doc":"Apply a rotation matrix. Always rotates around the z-axis (coming out of the screen). The value is given in radians. Positive values rotate clockwise. The rotation is pinned to the sensible default for each primitive, or to the :pin that you assign explicitly. Example: graph |&gt; text ( &quot;Rotated!&quot; , rotate : 1.2 ) |&gt; text ( &quot;Rotated!&quot; , rotate : 1.2 , pin : { 10 , 20 } ) Shortcut Rotation is common enough that you can use :r as a shortcut. Example: graph |&gt; text ( &quot;Rotated!&quot; , r : 1.2 )","ref":"Scenic.Primitive.Transform.Rotate.html"},{"type":"function","title":"Scenic.Primitive.Transform.Rotate.validate/1","doc":"Callback implementation for Scenic.Primitive.Transform.validate/1 .","ref":"Scenic.Primitive.Transform.Rotate.html#validate/1"},{"type":"module","title":"Scenic.Primitive.Transform.Scale","doc":"Apply a scale matrix. Increase or shrink by the provided multiplier. This can take two forms: multiplier - scale both x and y directions by the same multiplier {mul_x, mul_y} - scale x and y directions independently Scaling is pinned to the sensible default for each primitive, or to the :pin that you assign explicitly. Example: graph |&gt; text ( &quot;Scaled!&quot; , scale : 1.2 ) |&gt; text ( &quot;Scaled!&quot; , scale : { 1.0 , 1.2 } , pin : { 10 , 20 } ) Shortcut Scaling is common enough that you can use :s as a shortcut. Example: graph |&gt; text ( &quot;Scaled!&quot; , s : 1.2 )","ref":"Scenic.Primitive.Transform.Scale.html"},{"type":"function","title":"Scenic.Primitive.Transform.Scale.validate/1","doc":"Callback implementation for Scenic.Primitive.Transform.validate/1 .","ref":"Scenic.Primitive.Transform.Scale.html#validate/1"},{"type":"module","title":"Scenic.Primitive.Transform.Translate","doc":"Apply a translation matrix. This is used to position primitives on the screen {x, y} - move the primitive by the given amounts Example: graph |&gt; text ( &quot;Scaled!&quot; , translate : { 10 , 20 } ) Shortcut Translating is common enough that you can use :t as a shortcut. Example: graph |&gt; text ( &quot;Scaled!&quot; , t : { 10 , 20 } )","ref":"Scenic.Primitive.Transform.Translate.html"},{"type":"function","title":"Scenic.Primitive.Transform.Translate.validate/1","doc":"Callback implementation for Scenic.Primitive.Transform.validate/1 .","ref":"Scenic.Primitive.Transform.Translate.html#validate/1"},{"type":"module","title":"Scenic.Math","doc":"Helper functions that support Scenic mathematical operations. The math functions are fairly straightforward. When performance is needed some have been broken out into a NIF. The NIF functions are currently written for compatibility over top speed and as such, there is an opportunity to further improve them by calling out to CPU-specific vector instructions in the future.","ref":"Scenic.Math.html"},{"type":"type","title":"Scenic.Math.line/0","doc":"","ref":"Scenic.Math.html#t:line/0"},{"type":"type","title":"Scenic.Math.matrix/0","doc":"","ref":"Scenic.Math.html#t:matrix/0"},{"type":"type","title":"Scenic.Math.matrix_list/0","doc":"","ref":"Scenic.Math.html#t:matrix_list/0"},{"type":"type","title":"Scenic.Math.point/0","doc":"","ref":"Scenic.Math.html#t:point/0"},{"type":"type","title":"Scenic.Math.quad/0","doc":"","ref":"Scenic.Math.html#t:quad/0"},{"type":"type","title":"Scenic.Math.triangle/0","doc":"","ref":"Scenic.Math.html#t:triangle/0"},{"type":"type","title":"Scenic.Math.vector_2/0","doc":"","ref":"Scenic.Math.html#t:vector_2/0"},{"type":"module","title":"Scenic.Math.Line","doc":"A collection of functions to work with lines. Lines are always two points in a tuple. { point_a , point_b } { { x0 , y0 } , { x1 , y1 } }","ref":"Scenic.Math.Line.html"},{"type":"function","title":"Scenic.Math.Line.intersection/2","doc":"Find the point of intersection between two lines. Parameters: line_a - A line defined by two points. {point_a, point_b} line_b - A line defined by two points. {point_a, point_b} Returns: A point Examples iex&gt; Scenic.Math.Line.intersection({{1, 1}, {3, 3}}, {{3, 1}, {1, 3}}) {2.0, 2.0}","ref":"Scenic.Math.Line.html#intersection/2"},{"type":"function","title":"Scenic.Math.Line.parallel/2","doc":"Find a new line that is parallel to the given line and separated by the given distance. Parameters: line - A line defined by two points. {point_a, point_b} distance - The perpendicular distance to the new line. Returns: A line Examples iex&gt; Scenic.Math.Line . parallel ( { { 1 , 1 } , { 1 , 2 } } , 2 ) { { 3.0 , 1.0 } , { 3.0 , 2.0 } }","ref":"Scenic.Math.Line.html#parallel/2"},{"type":"function","title":"Scenic.Math.Line.round/1","doc":"Round the points that define a line so that they are made up of integers. Parameters: line - A line defined by two points. {point_a, point_b} Returns: A line Examples iex&gt; Scenic.Math.Line . round ( { { 1.5 , 1.6 } , { 2.1 , 2.56 } } ) { { 2 , 2 } , { 2 , 3 } }","ref":"Scenic.Math.Line.html#round/1"},{"type":"function","title":"Scenic.Math.Line.trunc/1","doc":"Truncate the points that define a line so that they are made up of integers. Parameters: line - A line defined by two points. {point_a, point_b} Returns: A line Examples iex&gt; Scenic.Math.Line . trunc ( { { 1.1 , 1.1 } , { 2.0 , 2.0 } } ) { { 1 , 1 } , { 2 , 2 } } iex&gt; Scenic.Math.Line . trunc ( { { - 1 , 1 } , { - 2.0 , 2.0 } } ) { { - 1 , 1 } , { - 2 , 2 } }","ref":"Scenic.Math.Line.html#trunc/1"},{"type":"module","title":"Scenic.Math.Matrix","doc":"A collection of functions to work with matrices. All the matrix fucntions in this module work exclusively with the binary form of a matrix, which is a compact binary of 16 4-byte floats. If you would like to convert back and forth from the more human friendly list version, then please use the functions in Scenic.Math.Matrix.Utils","ref":"Scenic.Math.Matrix.html"},{"type":"function","title":"Scenic.Math.Matrix.add/2","doc":"Add two matrices together. This operation is implemented as a NIF for performance. Parameters: matrix_a: The first matrix matrix_b: The second matrix Returns: The resulting matrix","ref":"Scenic.Math.Matrix.html#add/2"},{"type":"function","title":"Scenic.Math.Matrix.adjugate/1","doc":"Calculate the adjugate of a matrix This operation is implemented as a NIF for performance. Parameters: matrix: A matrix Returns: The resulting matrix","ref":"Scenic.Math.Matrix.html#adjugate/1"},{"type":"function","title":"Scenic.Math.Matrix.build_rotate_around/2","doc":"Build a matrix that represents a 2D rotation around a point. Parameters: angle: the amount to rotate, in radians pin: position to pin the rotation around Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#build_rotate_around/2"},{"type":"function","title":"Scenic.Math.Matrix.build_rotation/1","doc":"Build a matrix that represents a 2D rotation around the origin. Parameters: angle: the amount to rotate, in radians Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#build_rotation/1"},{"type":"function","title":"Scenic.Math.Matrix.build_scale/1","doc":"Build a matrix that represents a scaling operation. Parameters: scale: the amount to scale by. Can be either a number or a vector_2 Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#build_scale/1"},{"type":"function","title":"Scenic.Math.Matrix.build_translation/1","doc":"Build a matrix that represents a simple translation. Parameters: vector_2: the vector defining how much to translate Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#build_translation/1"},{"type":"function","title":"Scenic.Math.Matrix.close?/3","doc":"Test if two matrices are close in value to each other. Parameters: matrix_a: The first matrix matrix_b: The second matrix tolerance: Defines what close means. Defaults to: 0.000001 Returns: A boolean","ref":"Scenic.Math.Matrix.html#close?/3"},{"type":"function","title":"Scenic.Math.Matrix.determinant/1","doc":"Calculate the determinant of a matrix This operation is implemented as a NIF for performance. Parameters: matrix: A matrix Returns: The resulting matrix","ref":"Scenic.Math.Matrix.html#determinant/1"},{"type":"function","title":"Scenic.Math.Matrix.div/2","doc":"Divide a matrix by a scalar. This operation is implemented as a NIF for performance. Parameters: matrix: A matrix divisor: A number (scalar) to divide by Returns: The resulting matrix","ref":"Scenic.Math.Matrix.html#div/2"},{"type":"function","title":"Scenic.Math.Matrix.get/3","doc":"Get a single value out of a binary matrix. Parameters: matrix: The source matrix x: the column to pull the data from y: the row to pull the data from Returns: A number","ref":"Scenic.Math.Matrix.html#get/3"},{"type":"function","title":"Scenic.Math.Matrix.get_xy/1","doc":"Extract the 2D vector represented by the matrix. Parameters: matrix: The source matrix Returns: A vector_2","ref":"Scenic.Math.Matrix.html#get_xy/1"},{"type":"function","title":"Scenic.Math.Matrix.identity/0","doc":"The identity matrix","ref":"Scenic.Math.Matrix.html#identity/0"},{"type":"function","title":"Scenic.Math.Matrix.invert/1","doc":"Inverte a matrix. This operation is implemented as a NIF for performance. Parameters: matrix: A matrix Returns: The resulting matrix","ref":"Scenic.Math.Matrix.html#invert/1"},{"type":"function","title":"Scenic.Math.Matrix.mul/1","doc":"Multiply a list of matrices together. This operation is implemented as a NIF for performance. Parameters: matrix_list: A list of matrices Returns: The resulting matrix","ref":"Scenic.Math.Matrix.html#mul/1"},{"type":"function","title":"Scenic.Math.Matrix.mul/2","doc":"Multiply a matrix by another matrix or a scalar. This operation is implemented as a NIF for performance. Parameters: matrix: A matrix multiplier: A number (scalar) or a matrix to multiply by Returns: The resulting matrix","ref":"Scenic.Math.Matrix.html#mul/2"},{"type":"function","title":"Scenic.Math.Matrix.project_vector/2","doc":"Project a vector by a matrix. This operation is implemented as a NIF for performance. Parameters: matrix: A matrix vector: The vector to project Returns: The projected vector","ref":"Scenic.Math.Matrix.html#project_vector/2"},{"type":"function","title":"Scenic.Math.Matrix.project_vectors/2","doc":"Project a list of vectors by a matrix. This operation is implemented as a NIF for performance. Parameters: matrix: A matrix vectors: The list of vectors to project Returns: A list of projected vectors","ref":"Scenic.Math.Matrix.html#project_vectors/2"},{"type":"function","title":"Scenic.Math.Matrix.put/4","doc":"Put a single value into a binary matrix. Parameters: matrix: The source matrix x: the column to pull the data from y: the row to pull the data from v: the value to put into the matrix. Must be a number. Returns: A number","ref":"Scenic.Math.Matrix.html#put/4"},{"type":"function","title":"Scenic.Math.Matrix.rotate/2","doc":"Multiply a matrix by a rotation. Parameters: matrix: The incoming source matrix angle: the amount to rotate, in radians or nil (which does nothing Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#rotate/2"},{"type":"function","title":"Scenic.Math.Matrix.scale/2","doc":"Multiply a matrix by a scale factor. Parameters: matrix: The incoming source matrix scale: the amount to scale by. Can be either a number, a vector, or nil (which does nothing) Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#scale/2"},{"type":"function","title":"Scenic.Math.Matrix.sub/2","doc":"Subtract one matrix from another. This operation is implemented as a NIF for performance. Parameters: matrix_a: The first matrix matrix_b: The second matrix, which is subtracted from the first Returns: The resulting matrix","ref":"Scenic.Math.Matrix.html#sub/2"},{"type":"function","title":"Scenic.Math.Matrix.translate/2","doc":"Multiply a matrix by a translation. Parameters: matrix: The incoming source matrix vector_2: the vector to translate by or nil (which does nothing) Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#translate/2"},{"type":"function","title":"Scenic.Math.Matrix.transpose/1","doc":"Transpose a matrix This operation is implemented as a NIF for performance. Parameters: matrix: A matrix Returns: The resulting matrix","ref":"Scenic.Math.Matrix.html#transpose/1"},{"type":"function","title":"Scenic.Math.Matrix.zero/0","doc":"A matrix where all the values are 0","ref":"Scenic.Math.Matrix.html#zero/0"},{"type":"module","title":"Scenic.Math.Matrix.Utils","doc":"Helper functions for working with matrices. The matrix format for the main Scenic.Math.Matrix functions is a 64 byte binary blob containing 16 4-byte floats. This is great for doing the math in code, but not so great for reading or understanding the values by a human. These functions transform more readable/writable formats into the binary blob and vice versa.","ref":"Scenic.Math.Matrix.Utils.html"},{"type":"function","title":"Scenic.Math.Matrix.Utils.to_binary/1","doc":"Convert a readable format into a binary blob. Parameters: matrix_list - a list of 16 numbers Returns: A binary matrix blob","ref":"Scenic.Math.Matrix.Utils.html#to_binary/1"},{"type":"function","title":"Scenic.Math.Matrix.Utils.to_list/1","doc":"Convert a binary matrix into a list of 16 numbers. Parameters: matrix - a binary matrix Returns: A list of 16 numbers","ref":"Scenic.Math.Matrix.Utils.html#to_list/1"},{"type":"module","title":"Scenic.Math.Vector2","doc":"A collection of functions to work with 2D vectors. 2D vectors are always two numbers in a tuple. { 3 , 4 } { 3.5 , 4.7 }","ref":"Scenic.Math.Vector2.html"},{"type":"function","title":"Scenic.Math.Vector2.add/2","doc":"Add two vectors together. Parameters: vector2_a - the first vector to be added vector2_b - the second vector to be added Returns: A new vector which is the result of the addition Examples iex&gt; Scenic.Math.Vector2 . add ( { 1.0 , 5.0 } , { 3.0 , 3.0 } ) { 4.0 , 8.0 }","ref":"Scenic.Math.Vector2.html#add/2"},{"type":"function","title":"Scenic.Math.Vector2.bounds/1","doc":"Given a list of vectors, find the {left, top, right, bottom} of the bounding box.","ref":"Scenic.Math.Vector2.html#bounds/1"},{"type":"function","title":"Scenic.Math.Vector2.clamp/3","doc":"Clamp a vector to the space between two other vectors. Parameters: vector2 - the vector to be clamped min - the vector defining the minimum boundary max - the vector defining the maximum boundary Returns: A vector derived from the space between two other vectors","ref":"Scenic.Math.Vector2.html#clamp/3"},{"type":"function","title":"Scenic.Math.Vector2.cross/2","doc":"Calculates the cross product of two vectors. Parameters: vector2_a - the first vector vector2_b - the second vector Returns: A number which is the result of the cross product","ref":"Scenic.Math.Vector2.html#cross/2"},{"type":"function","title":"Scenic.Math.Vector2.distance/2","doc":"","ref":"Scenic.Math.Vector2.html#distance/2"},{"type":"function","title":"Scenic.Math.Vector2.distance_squared/2","doc":"","ref":"Scenic.Math.Vector2.html#distance_squared/2"},{"type":"function","title":"Scenic.Math.Vector2.div/2","doc":"Divide a vector by a scalar. Parameters: vector2 - the vector scalar - the scalar value Returns: A new vector which is the result of the division","ref":"Scenic.Math.Vector2.html#div/2"},{"type":"function","title":"Scenic.Math.Vector2.dot/2","doc":"Calculates the dot product of two vectors. Parameters: vector2_a - the first vector vector2_b - the second vector Returns: A number which is the result of the dot product","ref":"Scenic.Math.Vector2.html#dot/2"},{"type":"function","title":"Scenic.Math.Vector2.down/0","doc":"A vector that points straight down by 1.","ref":"Scenic.Math.Vector2.html#down/0"},{"type":"function","title":"Scenic.Math.Vector2.in_bounds?/2","doc":"Determine if a vector is in the bounds (or clamp space) between two other vectors. Parameters: vector2 - the vector to be tested bounds - a vector defining the boundary Returns: true or false","ref":"Scenic.Math.Vector2.html#in_bounds?/2"},{"type":"function","title":"Scenic.Math.Vector2.in_bounds?/3","doc":"Determine if a vector is in the bounds (or clamp space) between two other vectors. Parameters: vector2 - the vector to be tested min - the vector defining the minimum boundary max - the vector defining the maximum boundary Returns: A vector derived from the space between two other vectors","ref":"Scenic.Math.Vector2.html#in_bounds?/3"},{"type":"function","title":"Scenic.Math.Vector2.invert/1","doc":"Invert a vector. Parameters: vector_2 - the vector to be inverted Returns: The inverted vector Examples iex&gt; Scenic.Math.Vector2 . invert ( { 2 , 2 } ) { - 2 , - 2 }","ref":"Scenic.Math.Vector2.html#invert/1"},{"type":"function","title":"Scenic.Math.Vector2.left/0","doc":"A vector that points left by 1.","ref":"Scenic.Math.Vector2.html#left/0"},{"type":"function","title":"Scenic.Math.Vector2.length/1","doc":"Calculates the length of the vector. This is slower than calculating the squared length. Parameters: vector2 - the vector Returns: A number which is the length","ref":"Scenic.Math.Vector2.html#length/1"},{"type":"function","title":"Scenic.Math.Vector2.length_squared/1","doc":"Calculates the squared length of the vector. This is faster than calculating the length if all you want to do is compare the lengths of two vectors against each other. Parameters: vector2 - the vector Returns: A number which is the square of the length","ref":"Scenic.Math.Vector2.html#length_squared/1"},{"type":"function","title":"Scenic.Math.Vector2.lerp/3","doc":"Calculate the lerp of two vectors. See This explanation for more info. Parameters: vector_a - the first vector vector_b - the second vector t - the &quot;t&quot; value (see link above). Must be between 0 and 1. Returns: A vector, which is the result of the lerp.","ref":"Scenic.Math.Vector2.html#lerp/3"},{"type":"function","title":"Scenic.Math.Vector2.max/2","doc":"Find a new vector derived from the highest x and y from two given vectors. Parameters: vector2_a - the first vector vector2_b - the second vector Returns: A vector derived from the highest x and y from two given vectors","ref":"Scenic.Math.Vector2.html#max/2"},{"type":"function","title":"Scenic.Math.Vector2.min/2","doc":"Find a new vector derived from the lowest x and y from two given vectors. Parameters: vector2_a - the first vector vector2_b - the second vector Returns: A vector derived from the lowest x and y from two given vectors","ref":"Scenic.Math.Vector2.html#min/2"},{"type":"function","title":"Scenic.Math.Vector2.mul/2","doc":"Multiply a vector by a scalar. Parameters: vector2 - the vector scalar - the scalar value Returns: A new vector which is the result of the multiplication","ref":"Scenic.Math.Vector2.html#mul/2"},{"type":"function","title":"Scenic.Math.Vector2.nlerp/3","doc":"Calculate the nlerp (normalized lerp) of two vectors. See This explanation for more info. Parameters: vector_a - the first vector vector_b - the second vector t - the &quot;t&quot; value (see link above). Must be between 0 and 1. Returns: A vector, which is the result of the nlerp.","ref":"Scenic.Math.Vector2.html#nlerp/3"},{"type":"function","title":"Scenic.Math.Vector2.normalize/1","doc":"Normalize a vector so it has the same angle, but a length of 1. Parameters: vector2 - the vector Returns: A vector with the same angle as the original, but a length of 1","ref":"Scenic.Math.Vector2.html#normalize/1"},{"type":"function","title":"Scenic.Math.Vector2.one/0","doc":"A vector that points to {1,1}.","ref":"Scenic.Math.Vector2.html#one/0"},{"type":"function","title":"Scenic.Math.Vector2.project/2","doc":"Project a vector into the space defined by a matrix Parameters: vector - the vector, or a list of vectors matrix - the matrix Returns: A projected vector (or list of vectors)","ref":"Scenic.Math.Vector2.html#project/2"},{"type":"function","title":"Scenic.Math.Vector2.right/0","doc":"A vector that points right by 1.","ref":"Scenic.Math.Vector2.html#right/0"},{"type":"function","title":"Scenic.Math.Vector2.round/1","doc":"Round the values of a vector to the nearest integers. Parameters: vector_2 - the vector to be rounded Returns: The integer vector Examples iex&gt; Scenic.Math.Vector2 . round ( { 1.2 , 1.56 } ) { 1 , 2 }","ref":"Scenic.Math.Vector2.html#round/1"},{"type":"function","title":"Scenic.Math.Vector2.sub/2","doc":"Subtract one vector from another. Parameters: vector2_a - the first vector vector2_b - the second vector, which will be subtracted from the first Returns: A new vector which is the result of the subtraction","ref":"Scenic.Math.Vector2.html#sub/2"},{"type":"function","title":"Scenic.Math.Vector2.trunc/1","doc":"Truncate the values of a vector into integers. Parameters: vector_2 - the vector to be truncated Returns: The integer vector Examples iex&gt; Scenic.Math.Vector2 . trunc ( { 1.6 , 1.2 } ) { 1 , 1 }","ref":"Scenic.Math.Vector2.html#trunc/1"},{"type":"function","title":"Scenic.Math.Vector2.unity_x/0","doc":"A vector that points to {1,0}.","ref":"Scenic.Math.Vector2.html#unity_x/0"},{"type":"function","title":"Scenic.Math.Vector2.unity_y/0","doc":"A vector that points to {0,1}.","ref":"Scenic.Math.Vector2.html#unity_y/0"},{"type":"function","title":"Scenic.Math.Vector2.up/0","doc":"A vector that points straight up by 1.","ref":"Scenic.Math.Vector2.html#up/0"},{"type":"function","title":"Scenic.Math.Vector2.zero/0","doc":"A vector that points to the origin.","ref":"Scenic.Math.Vector2.html#zero/0"},{"type":"exception","title":"Scenic.Driver.Error","doc":"","ref":"Scenic.Driver.Error.html"},{"type":"extras","title":"Upgrading to v0.11","doc":"","ref":"upgrading_to_v0-11.html"},{"type":"extras","title":"Upgrading to v0.11 - Overview","doc":"Version v0.11 is a MAJOR overhaul from the top to the bottom. For the first time, Scenic feels like something approaching a 1.0 in design. This guide is a good first pass. If you see things that need improving, please contribute! Scenic.Cache is gone. It is replaced by a much easier to use asset pipeline. push_graph is back. WHAT! Didn't it go away last time? Yes. I've been struggling with the way scene state is handled. Coupled with the scene state change (next in this list), it finally makes sense. State for a scene is now tracked similar to how you add state to a socket in a Phoenix Channel or a Plug conn. The state is always a %Scene{} object and you can assign() state into it. The driver engine is a complete re-write. Existing drivers that render will need to be re-written. Sorry. The good news is that they all pretty much did the same thing in generating a &quot;script&quot; of draw commands that was sent over to some renderer. This is now standardized and moved to the ViewPort layer. Drivers are MUCH simpler as a result and more portable. The ViewPort, and even the Scene engines themselves are also re-writes, but their API is very similar to the old version, so not much news there except for the way Scene state is tracked. There is an entirely new Script engine for generating draw scripts that can be sent to drivers. This is quite powerful There are numerous other additions to Scenic The Component primitive is used to refer to, and start components. The Script primitive refers to arbitrary scripts that you can send to drivers. The :line_height style now sets the spacing between lines of text. Works like CSS. The :text_base style lets you align text vertically. There is a new Scenic.Asset.Stream type for dynamic textures. New Sprite Sheet support via the Sprites primitive Built-in mouse cursor support on Nerves (works, but is not optimized yet) There are multiple smaller deprecations. Notably The :text_height style is replaced by :line_height, which works the same way line_height does in CSS. The Path primitive (which almost got cut, but survived) no longer has the solid and hole commands. The Box Gradient fill is gone. The :clear_color style (which was always weird) is gone. You can now set a theme on the viewport (in config), which sets the background color. The SceneRef primitive is gone, and replaced with a combination of Component and Script primitives. The :font_blur primitive is gone. Sorry. Didn't have a close enough analog in Canvas Input events are no longer implicitly requested for a scene. You can explicitly request the input events you want using Scene.request_input/2 or Scene.capture_input/2 The format of the input messages have changed - see the docs The optional styles on some of the standard components (Button) have changed to be more consistent with the standard styles. See documentation. Important :scenic_driver_local is the new standard renderer for Scenic. Both :scenic_driver_glfw and :scenic_drives_nerves_rpi are retired as of v0.11. The options for the new local driver are NOT the same as they were for the glfw driver. Please read the docs for it. Please see the new driver overview . I'm sure there's more. Feel free to add any notes if you find something that isn't covered.","ref":"upgrading_to_v0-11.html#overview"},{"type":"extras","title":"Upgrading to v0.11 - Motivation","doc":"The primary motivation for Scenic has always been to provide control surface UI for devices that don't necessarily have a human nearby watching over them. This means IoT, Industrial Control, Critical Systems, Infrastructure, etc... It can be used for other thing (and has been!), but the design choices are more about devices than flash. I like to say that there are 3 kinds of UI. Think of these as 3 layers, with highest fidelity and lowest latency requirements at the top, and lowest fidelity but best latency tolerance at the bottom. Category 1: At the top are games and anything else that uses all the available resources, renders to maximum fidelity. These applications are power hungry, run on local hardware due to latency sensitivity (although there is a lot of research going into cloud hosting) and they strive for the maximum in visual fidelity. Category 2: The middle layer is still UI that has latency sensitivity and is meant to be used by consumers in real-time, but the fidelity is dialed way back. Examples in this category are Flutter, QT, and most modern client-heavy web frameworks. When you see consumer appliances with a pretty interface that seems slightly sluggish, but is still trying to be pretty, that is in this layer. They walk the line between using the least expensive hardware they can, and still being pretty for everyday consumers. Category 3: The bottom layer knows it is running on inexpensive hardware and usually doesn't have a human using the actual device it runs on directly. It is designed up front to be latency tolerant, consume few resources, to be functional over flashy. Examples include old-school web 1.0 servers, X11 and... Scenic. Scenic's prime target has always been devices that are deployed in the field. They may or may not have a screen / human interface directly attached (most often don't) and are operated remotely. Category 3 devices do jobs that are more valuable than the device is. The small controller device that operates the solar farm is worth less than the farm or the electricity it produces. In contrast, our fancy Thermomix blender has a Category 2 UI, and is way more expensive than any of the meals it makes. Or even many meals put together. The requirements for a category 3 UI on devcies are Must be highly robust. Or at least recover quickly and not affect the rest of the device. Must be conservative with resources. Must be remotable. (The UI can be displayed and used on a different device) Must be latency tolerant. In versions 0.10 and early, Scenic did well on robustness and conservative resource use. It was designed to be latency tolerant, but that was never put to the test as it was not at all remotable. - yet. Version 0.11 finally takes a crack at making Scenic remotable. Enough time and use has passed that usage patterns have become visible. Some things have worked well (the pattern of scene/primitives/styles/transforms/components) and some things have not (the driver model repeated the same basic complicated code in every driver and the static assets cache was a constant struggle). Now that the Kry10 Operating System is operational (Scenic long awaited design target), it was time to fix the things that didn't work so well and properly build remoting. These are the sorts of changes that have ripples up the stack and create breaking changes. So best to get it all done in fell swoop.","ref":"upgrading_to_v0-11.html#motivation"},{"type":"extras","title":"Upgrading to v0.11 - Upgrading a v0.10 project to v0.11","doc":"Update mix.exs Delete your old scenic dependencies in mix.exs , they now look like this: { :scenic , &quot;~&gt; 0.11.0&quot; } , { :scenic_driver_local , &quot;~&gt; 0.11.0&quot; } , You may need to use mix deps.clean --all and/or mix deps.unlock to get it to work. Change the incoming viewport options to be a keyword list The main options for your Scenic app have changed from a map to a Keyword list. For example, if this was your old options map: %{ name : :main_viewport , size : { 1200 , 600 } , default_scene : { MyProject.RootScene , nil } , drivers : [ %{ module : Scenic.Driver.Glfw , name : :glfw , opts : [ resizeable : false , title : @title ] } ] } It would now look like this: [ name : :main_viewport , size : { 1200 , 600 } , default_scene : { MyProject.RootScene , nil } , drivers : [ [ module : Scenic.Driver.Local , name : :local ] ] ] Finally, where you are adding Scenic to the supervision tree, you will probably have to wrap these options in another list, assuming you use the above config exactly as is: children = [ { Scenic , [ default_viewport_config ( ) ] } , ] where default_viewport_config() resolves to the above config list. Change the driver module Assuming you have already upgraded your dependencies in mix.exs, you just need to make sure that you're using the correct driver module in your config. drivers : [ [ module : Scenic.Driver.Local , name : :local ] ]","ref":"upgrading_to_v0-11.html#upgrading-a-v0-10-project-to-v0-11"},{"type":"extras","title":"Upgrading to v0.11 - Scene State","doc":"The most immediate change that you will need to be addressed is now state in a scene is stored and how scenes are started up. In the old system, I was trying to hard to keep the developer focused on the functionality of their scene, and less with the mechanics of how it worked in the deeper layers. This created a state problem. Essentially, the scene developer needs to keep state for whatever the scene is supposed to be doing. But, the scene engine itself also needs to keep state in order track child components, its ViewPort , push graphs to the ViewPort, etc. I've tried various things to keep these states separate and clean. In end... it was all messy. The only thing that really works is to adopt the same state model as sockets/conns from Phoenix and Plug. That is, there is no state kept under the covers. The state presented to a scene is always now a %Scenic.Scene{} struct. Just like Plug and Sockets, there is an :assigns map in the struct that the scene developer uses to store their state. Just like those others systems, assigns() helpers are provided. This will require some porting work as you move to v0.11, but at least it feels like the right long-term solution. Upgrade steps Upgrade init/2 to init/3 Previously init/2 accepted params, and a list of options. Now it also accepts a scene as the first parameter. This scene must be saved into the state, or set as the entire state of the scene. An example implementation is below. @impl Scenic.Scene def init ( scene , _params , _opts ) do # put your init logic here { :ok , scene } end Update the scene to use push_graph/2 Previously in v0.10, graphs were pushed by including a push: graph option at the end of each callback: def handle_cast ( msg , state ) do new_graph = calc_new_graph ( state ) { :noreply , %{ state | graph : new_graph } , push : new_graph } end This has now been deprecated, in favour of the function push_graph/2 Example: def handle_cast ( msg , scene ) do new_graph = calc_new_graph ( scene , msg ) new_scene = scene |&gt; assign ( graph : new_graph ) |&gt; push_graph ( new_graph ) { :noreply , new_scene } end Note that, in this example, we are holding the Scene variable inside the state. This scene is passed in as the new param to init/3 now, and we MUST use this scene when we perform a push_graph. We CANNOT simply construct a new scene and use that, it must be the orginal one. Example defmodule MyDevice.Scene.Example do use Scenic.Scene import Scenic.Primitives def init ( scene , _param , _opts ) do graph = Scenic.Graph . build ( font : :roboto ) |&gt; text ( &quot;This is an example&quot; , id : :text ) scene = scene |&gt; assign ( some_state : 123 , graph : graph ) |&gt; push_graph ( graph ) { :ok , scene } end # display any received events def handle_event ( event , _ , %{ assigns : %{ graph : graph } } = scene ) do graph = Graph . modify ( graph , :text , &amp; text ( &amp;1 , inspect ( event ) ) ) scene = scene |&gt; assign ( graph : graph ) |&gt; push_graph ( graph ) { :noreply , scene } end end","ref":"upgrading_to_v0-11.html#scene-state"},{"type":"extras","title":"Upgrading to v0.11 - push_graph is back!","doc":"As part of my struggles to find the right scene state model, the push_graph function came, and went, and is now back again. push_graph/2 is the way you send a graph from a scene to the scene's ViewPort for compilation and eventual display through the drivers. Now that all of the scene's state is stored in one place it is finally clear that push_graph can take a scene and a graph, and return a modified scene. It is important to track the scene that is returned, as that is how any components that the graph may spin up are accounted for. def init ( scene , _param , _opts ) do graph = Scenic.Graph . build ( font : :roboto ) |&gt; button ( &quot;Press Me&quot; , id : :press_me ) scene = push_graph ( scene , graph ) { :ok , scene } end end In the above example, the scene/process that runs the button labeled :press_me is not started until it is pushed to the ViewPort. This function does quite a bit of work and can start or stop child component processes, tracks pids, compiles the graph for rendering, prepares any input records for input events and more. You can call it as often as you want, but be aware that you may end up causing work to no benefit as the drivers all update on their own heartbeat. In other words, you can push a graph 1000 times per second, but it will still only be drawn 30 times per second or less as as the driver sees fit.","ref":"upgrading_to_v0-11.html#push_graph-is-back"},{"type":"extras","title":"Upgrading to v0.11 - handle_input signature has changed","doc":"This is another breaking changed. The old version of handle_input in a scene or component included the relevant id in the input message, which was mixing metaphors, and include a fairly opaque context object that was only there because of the way scene state was handled. Now that scene state is completely explicit and passed through to the scene, this can be cleaned up. The new handle_input function takes three parameters and looks like this. def handle_input ( input_event , hit_id , scene ) The input event is now just that. Nothing else is added to it. The hit id in your graph (if any) is passed as the second parameter. It is nil if there was nothing hit or if the input event didn't make sense for that sort of thing. Here is an example from the Button control. In this case, update_color calls the push_graph function and returns the updated state. # pressed in the button @impl Scenic.Scene def handle_input ( { :cursor_button , { 0 , :press , _ , _ } } , :btn , scene ) do :ok = capture_input ( scene , :cursor_button ) scene = scene |&gt; update_color ( true , true ) |&gt; assign ( pressed : true ) { :noreply , scene } end Also notice that which mouse button was clicked is now a number instead of :left or :right. it was presumptive to assume that :left was the primary button. This is neutral and no longer handedness-biased.","ref":"upgrading_to_v0-11.html#handle_input-signature-has-changed"},{"type":"extras","title":"Upgrading to v0.11 - Upgrading custom Scenic.Components","doc":"Change verify/1 to validate/1 The name of the function which validates incoming parameters has changed, but the behaviour is essentially the same. An example implementation is below. @impl Scenic.Component def validate ( data ) when is_bitstring ( data ) , do : { :ok , data } def validate ( _ ) , do : { :error , &quot;Descriptive error message goes here.&quot; }","ref":"upgrading_to_v0-11.html#upgrading-custom-scenic-components"},{"type":"extras","title":"Upgrading to v0.11 - The Static Asset Library","doc":"I, and everybody else, always struggled with the various attempts at the Scenic.Cache modules . It was close, but not quite right. The goal is to sensibly load and use static assets like images and fonts, while maintaining cryptographic hashes for security purposes. The old system worked, but required byzantine steps to get it running. The new asset pipeline is designed to feel familiar to the Phoenix static asset system. You create an &quot;assets&quot; directory in the root of your project, set up some config to point to it, and create your own Assets module to hold the data. (This part is more like NimblePublisher than Phoenix, but it works really well.) Then you can just drop images or fonts into you assets folder and they show up and are usable. Example directory structure my_cool_project assets fonts roboto . ttf my_font . ttf images parrot . jpg Example config config :scenic , :assets , module : MyCoolProject.Assets Example Assets Module defmodule MyCoolProject.Assets do use Scenic.Assets.Static , otp_app : :my_cool_project , alias : [ parrot : &quot;images/parrot.jpg&quot; ] end Example use in a Scene Graph . build ( ) |&gt; text ( &quot;Some Text&quot; , font : &quot;fonts/my_font.ttf&quot; ) |&gt; rect ( { 100 , 200 } , fill : { :image , &quot;images/parrot.jpg&quot; } ) |&gt; rect ( { 100 , 200 } , fill : { :image , :parrot } ) # uses the alias set up in config","ref":"upgrading_to_v0-11.html#the-static-asset-library"},{"type":"extras","title":"Upgrading to v0.11 - The Streaming Asset Pipeline","doc":"What used to be called the Scenic.Cache.Dynamic , is now Scenic.Assets.Stream and Scenic.Assets.Stream.Texture. This is for images that you generate on the fly (charts, bit rendered game screens, rotating colors, etc) or frames that you capture live from a camera. The goal is to seperate the source of these images from the consumers (the drivers) in a way that is latency/bandwidth friendly and is easy to use. The Scenic.Assets.Stream module is a process/api that manages an :ets table of streaming assets. This allows a camera to capture frames at whatever rate makes sense for it and to put them into the table when it sees fit. This data is then distributed to any listening drivers, who can do the right thing with it. Example camera source - ( from some camera source... tbd by developer... ) def handle_info ( { :camera_0 , texture } , state ) do :ok = Stream . put ( &quot;camera_0&quot; , texture ) end Example use in a Scene Graph . build ( ) |&gt; rect ( { 100 , 200 } , fill : { :stream , &quot;camera_0&quot; } )","ref":"upgrading_to_v0-11.html#the-streaming-asset-pipeline"},{"type":"extras","title":"Upgrading to v0.11 - Texture API","doc":"The old Scenic.Utilities.Texture API has been improved and promoted to Scenic.Assets.Stream.Texture . The changes center around the fact that the NIF behind the put and clear functions breaks the immutable assumptions of the Erlang and Elixir languages. In other words, they operate directly on the backing memory of the texture instead of making a new copy and then changing it. This is for performance reasons. It also create several very hard to track down bugs. The new API fits better into the erlang world adding the mutable/1 and commit/1 function calls. When a texture is mutable, it is not usable by the Stream api. When it is commited, it is usable by Stream, but no longer editable. t = Texture . build ( :rgb , 10 , 20 ) |&gt; Texture . clear ( :blue ) |&gt; Texture . commit ( ) :ok = Stream . put ( &quot;example&quot; , t ) You can also specify new textures to be cleared with a specific color and/or committed as build options t = Texture . build ( :rgb , 10 , 20 , clear : blue , commit : true ) :ok = Stream . put ( &quot;example&quot; , t )","ref":"upgrading_to_v0-11.html#texture-api"},{"type":"extras","title":"Upgrading to v0.11 - Standard Driver","doc":"The new standard render driver for all Scenic apps is :scenic_driver_local . Both :scenic_driver_glfw and :scenic_drives_nerves_rpi are retired. This driver provides a single rendering code base for both hosted (Mac/PC/Linux) and Nerves environments. The seperate drivers were 95% the same anyway and it was getting difficult to keep fixes for them in sync.","ref":"upgrading_to_v0-11.html#standard-driver"},{"type":"extras","title":"Upgrading to v0.11 - Driver Model","doc":"Another big change to Scenic is the re-write of the driver model. If your work is all at the scene layer, then this shouldn't affect you. But if you have a custom driver that renders graphs, it will need to be re-written. The old model sent graphs directly to the drivers. They would then traverse these graphs, translating them into some render specific linear list of commands, which were then, in turn, passed to the actual renderer. It was complicated, repeated the same difficult code in every driver, and was difficult to maintain. The new model moves the traversal or &quot;compilation&quot; of the graphs into the ViewPort layer and standardizes the set of draw commands in the form of a linear script. This means the difficult part of all drivers has been done once in the ViewPort layer and drivers themselves have become much simpler. Drivers are still in charge of how often to render, how to deal with latency, and can intercept/customize the serialization of these scripts into binary form. See driver documentation for more details. (may not be complete yet...)","ref":"upgrading_to_v0-11.html#driver-model"},{"type":"extras","title":"Upgrading to v0.11 - Scripts","doc":"As part of the driver re-write, the concept of Draw Scripts has been introduced. When you use push_graph/2 to send a graph to the ViewPort, it is being compiled into a standard draw script and that is what is actually stored for distribution to the drivers. This script API is also exposed to scenes, so you can make your own scripts that go outside the confines of the primitives. In fact, that I almost cut the Path primitive as a custom script is almost always a better way to go, but it lives on as a way to insert a limited inline script. Scripts can be created, and referred to in a graph as an easy to way to use them. alias Scenic.Script def init ( scene , _param , _opts ) do script = Script . start ( ) |&gt; Script . fill_color ( :green ) |&gt; Script . draw_rect ( 100 , 200 , :fill ) |&gt; Script . finish ( ) scene = push_graph ( scene , graph ) { :ok , scene } end See the Scenic.Script module for the full API.","ref":"upgrading_to_v0-11.html#scripts"},{"type":"extras","title":"Upgrading to v0.11 - Scripts vs Scenes","doc":"An important point to call out is Scripts are top level objects at the ViewPort. This means that when a Scene creates a script and then refers to it in a graph, the graph and the script are tracked &amp; send to drivers separately. This is a way of separating concerns. A script that is changing rapidly doesn't cause the potentially large and complex graph that references it to update, and vice versa. In fact, Graphs are now just compiled into scripts. They are no longer stored directly on the ViewPort at all. It is scripts all the way down.","ref":"upgrading_to_v0-11.html#scripts-vs-scenes"},{"type":"extras","title":"Scenic","doc":"Scenic is an application framework written directly on the Elixir/Erlang/OTP stack. With it, you can build client-side applications that operate identically across all supported operating systems, including MacOS, Ubuntu, Nerves/Linux, and more. Scenic is primarily aimed at fixed screen connected devices (IoT), but can also be used to build portable applications.","ref":"welcome.html"},{"type":"extras","title":"Scenic - IMPORTANT - Upgrading to v0.11","doc":"If you have used versions before v0.11, please see the Upgrading to v0.11 Guide .","ref":"welcome.html#important-upgrading-to-v0-11"},{"type":"extras","title":"Scenic - How to get started?","doc":"If you are new to Scenic, then you should read the following guides. Install Dependencies General Overview Getting Started Getting Started with Nerves (IoT) Structure of a Scene Life-cycle of a Scene Graph Overview Primitives Standard Components Styles Transforms Contributing Code of Conduct WIP ViewPort Overview Driver Overview Nerves","ref":"welcome.html#how-to-get-started"},{"type":"extras","title":"Install Dependencies","doc":"The design of Scenic goes to great lengths to minimize its dependencies to just the minimum. Namely, it needs Erlang/Elixir and OpenGL. Rendering your application into a window on your local computer (MacOS, Ubuntu and others) is done by the scenic_driver_local driver. It uses the GLFW and GLEW libraries to connect to OpenGL. The instructions below assume you have already installed Elixir/Erlang. If you need to install Elixir/Erlang there are instructions on the elixir-lang website .","ref":"install_dependencies.html"},{"type":"extras","title":"Install Dependencies - On MacOS","doc":"The easiest way to install on MacOS is to use Homebrew. Just run the following in a terminal: brew update brew install glfw3 glew pkg-config Once these components have been installed, you should be able to build the scenic_driver_local driver.","ref":"install_dependencies.html#on-macos"},{"type":"extras","title":"Install Dependencies - On Windows","doc":"Some initial setup is required for windows. You'll need windows services for linux (WSL) and VcXsrv, Jeffrey Borchert's article details these steps.","ref":"install_dependencies.html#on-windows"},{"type":"extras","title":"Install Dependencies - On Ubuntu 16","doc":"The easiest way to install on Ubuntu is to use apt-get. Just run the following: sudo apt-get update sudo apt-get install pkgconf libglfw3 libglfw3-dev libglew1.13 libglew-dev Once these components have been installed, you should be able to build the scenic_driver_glfw driver.","ref":"install_dependencies.html#on-ubuntu-16"},{"type":"extras","title":"Install Dependencies - On Ubuntu 18","doc":"The easiest way to install on Ubuntu is to use apt-get. Just run the following: sudo apt-get update sudo apt-get install pkgconf libglfw3 libglfw3-dev libglew2.0 libglew-dev Once these components have been installed, you should be able to build the scenic_driver_glfw driver.","ref":"install_dependencies.html#on-ubuntu-18"},{"type":"extras","title":"Install Dependencies - On Fedora","doc":"The easiest way to install on Fedora is to use dnf. Just run the following: dnf install glfw glfw-devel pkgconf glew glew-devel Once these components have been installed, you should be able to build the scenic_driver_glfw driver.","ref":"install_dependencies.html#on-fedora"},{"type":"extras","title":"Install Dependencies - On Archlinux","doc":"The easiest way to install on Archlinux is to use pacman. Just run the following: sudo pacman -S glfw-x11 glew If you're using wayland, you'll probably need glfw-wayland instead of glfw-x11 and glew-wayland instead of glew","ref":"install_dependencies.html#on-archlinux"},{"type":"extras","title":"Install Dependencies - What to read next?","doc":"Next, you should read about General Overview .","ref":"install_dependencies.html#what-to-read-next"},{"type":"extras","title":"General Overview","doc":"Scenic is a client application framework written directly on the Elixir/Erlang/OTP stack. With it, you can build applications that operate identically across all supported operating systems, including MacOS, Ubuntu, Nerves/Linux, and more. Scenic is primarily aimed at fixed screen connected devices (IoT), but can also be used to build portable applications.","ref":"overview_general.html"},{"type":"extras","title":"General Overview - Goals","doc":"Available: Scenic takes full advantage of OTP supervision trees to create applications that are fault-tolerant, self-healing, and highly available under adverse conditions. Small and Fast: The only core dependencies are Erlang/OTP and OpenGL. Self Contained: &quot;Never trust a device if you don't know where it keeps its brain.&quot; The logic to run a device should be on the device and it should remain operational even if the service it talks to becomes unavailable. Maintainable: Each device knows how to run itself. This lets teams focus on new products and only updating the old ones as the business needs. Remotable: Scenic devices know how to run themselves, but can still be accessed remotely. Remote traffic attempts to be as small so it can be used over the Internet, cellular modems, Bluetooth, etc. Reusable: Collections of UI can be packaged up for reuse with, and across applications. I expect to see Hex packages of controls, graphs, and more available for Scenic applications. Flexible: Scenic uses matrices similar to game development to position everything. This makes reuse, scale, positioning and more very flexible and simple. Secure: Scenic is designed with an eye towards security. For now, the main effort is to keep it simple. No browser, Javascript, and other complexity presenting vulnerabilities. There will be much more to say about security later.","ref":"overview_general.html#goals"},{"type":"extras","title":"General Overview - Non-Goals","doc":"Browser: Scenic is not a web browser. It is aimed at a fixed screen devices and certain types of windowed apps. It knows nothing about HTML. 3D: Scenic is a 2D UI framework. It uses techniques from game development (such as transform matrices), but it does not support 3D drawing at this time. Immediate Mode: In graphics speak, Scenic is a retained mode system. If you need immediate mode, then Scenic isn't for you. If you don't know what retained and immediate modes are, then you are probably just fine. For reference: HTML is a retained mode model.","ref":"overview_general.html#non-goals"},{"type":"extras","title":"General Overview - Architecture","doc":"Scenic is built as a three-layer architectural cake. Scene Layer At the top is the Scene Layer , which encapsulates all application business logic. The developer will do most of their Scenic work in the Scene layer. ViewPort Layer In the middle is the ViewPort Layer , which acts as a bridge between the Scenes and the Drivers. The ViewPort controls the scene life-cycle (More on that in Scene Overview ), sends graphs down to the drivers, and routes user input up to the correct scene. Driver layer At the bottom is the Driver layer , which is where knowledge of the graphics hardware and/or remote configuration lives. Drivers draw everything on the screen and originate the raw user input. Developers can write their own drivers, but that will be rare if at all. Dealing with Sensors and other hardware is a different problem space.","ref":"overview_general.html#architecture"},{"type":"extras","title":"General Overview - Mental Model","doc":"Scenic is definitely not a browser and has nothing to do with HTML. However, its design attempts to draw analogies to web design so that a developer with experience building web pages will catch on very quickly. The following terms include HTML analogies as appropriate…","ref":"overview_general.html#mental-model"},{"type":"extras","title":"General Overview - Terms and Definitions","doc":"Scene Scenes are sort of like a web page. Each scene is a GenServer process that contains state and business logic to handle user input. As the device navigates to different screens, it is moving between scenes. Graph A Graph is a sort of like the DOM. It is a hierarchical set of data that describes things to draw on the screen. The Graph is immutable in the functional coding sense and is manipulated through transform functions. Primitive Each node in a Graph is a Primitive. There is relatively small, fixed set of primitives, but they can be combined to draw pretty much any UI you need. Component A component is a Scene, with added sugar so that it can be referenced/used by other Scenes. This allows you to build libraries of reusable components and isolates logic into sensible containers. Standard controls such as Button, RadioGroup, Slider and more are written as components. Style Styles are sort of analogous to CSS styles. Styles are optional parameters you can add to any primitive in a graph. They are inherited down the graph. Transform All positioning, rotation, scale and such is expressed by applying transform matrices to nodes in a Graph. Transforms are inherited down the graph. You will almost never interact directly with the matrices, as there are very easy helpers that manage them for you. ViewPort A ViewPort is a sort of like a tab in your browser. It manages the scene life-cycle, routes graphs to the drivers, and input back up to the scenes. If you want two windows in your app, you need to start two ViewPorts. Driver Drivers know nothing about scenes but are able to render Graphs to a specific device. That could be a graphics chip or the network… Drivers also collect raw user input and route it back up to the ViewPort. Input There is a fixed set of user input data (mouse, keyboard, touch, etc.) that drivers generate and hand up to the ViewPort. The ViewPort, in turn, sends the input as a message to the appropriate Scene. Scenes handle raw user input via the handle_input/3 callback. Event In response to user input (or timers or any other message), a component can generate an event that it sends up to its parent scene. Unlike user input, if the parent doesn't handle it, it is passed up again to that component's parent until it reaches the root scene. Scenes handle events that are bubbling up to the chain via the handle_event/3 callback. This is analogous to event bubbling on a web page.","ref":"overview_general.html#terms-and-definitions"},{"type":"extras","title":"General Overview - What to read next?","doc":"If you are new to Scenic, you should read and follow the exercise in Getting Started . If you want to dig deeper into the structure of a Scene, then read the Scene Overview .","ref":"overview_general.html#what-to-read-next"},{"type":"extras","title":"Getting Started","doc":"This guide will walk you through installing the new project generator, then building your first Scenic application.","ref":"getting_started.html"},{"type":"extras","title":"Getting Started - Install Dependencies","doc":"See Install Dependencies","ref":"getting_started.html#install-dependencies"},{"type":"extras","title":"Getting Started - Install scenic.new","doc":"The Scenic Archive is the home of the scenic.new mix task, which lays out a starter application for you. This is the easiest way to set up a new Scenic project. Install the Scenic Archive like this mix archive.install hex scenic_new","ref":"getting_started.html#install-scenic-new"},{"type":"extras","title":"Getting Started - Build the Basic App","doc":"First, navigate the command-line to the directory where you want to create your new Scenic app. Then run the following commands: (change my_app to the name of your app...) mix scenic.new my_app cd my_app mix do deps.get, scenic.run If you want to explore the more full-on example, then follow the instructions below.","ref":"getting_started.html#build-the-basic-app"},{"type":"extras","title":"Getting Started - Build the Example App","doc":"First, navigate the command-line to the directory where you want to create your new Scenic app. Then run the following commands: (change my_app to the name of your app...) mix scenic.new.example my_app cd my_app mix do deps.get, scenic.run","ref":"getting_started.html#build-the-example-app"},{"type":"extras","title":"Getting Started - Configure Scenic","doc":"In order to start Scenic, you should first build a configuration for one or more ViewPorts. These configuration maps will be passed in to the main Scenic supervisor. These configurations should live in your app's config.exs file. import Config # Configure the main viewport for the Scenic application config :my_app , :viewport , [ name : :main_viewport , size : { 700 , 600 } , default_scene : MyApp.Scene.Example , drivers : [ [ module : Scenic.Driver.Local , name : :local , window : [ resizeable : false , title : &quot;Example Application&quot; ] , ] ] ] Then use that config to start your supervisor with the Scenic supervisor. defmodule MyApp do # ... def start ( _type , _args ) do import Supervisor.Spec , warn : false # 1. Load the viewport configuration from config main_viewport_config = Application . get_env ( :my_app , :viewport ) # 2. Start the application with the viewport children = [ # ... supervisor ( Scenic , [ viewports : [ main_viewport_config ] ] ) , ] Supervisor . start_link ( children , strategy : :one_for_one ) end end In the ViewPort configuration you can do things like set a name for the ViewPort process, its size, the default scene and start one or more drivers. See the documentation for ViewPort Configuration to learn more about how to set the options on a viewport. Note that all the drivers are in separate Hex packages as you should choose the correct one for your application. For example, the Scenic.Driver.Glfw driver draws your scenes into a window under MacOS and Ubuntu. It should work on other OS's as well, such as other flavors of Unix or Windows, but I haven't worked on or tested those yet.","ref":"getting_started.html#configure-scenic"},{"type":"extras","title":"Getting Started - Running and Debugging","doc":"Once the app and its dependencies are set up, there are two main ways to run it. If you want to run your app under IEx so that you can debug it, simply run iex -S mix This works just like any other Elixir application. If you want to run your app outside of iex, you should start it like this: mix scenic.run","ref":"getting_started.html#running-and-debugging"},{"type":"extras","title":"Getting Started - The Starter App","doc":"The starter app created by the generator above shows the basics of building a Scenic application. It has four scenes, two components, and a simulated sensor. Splash: The Splash scene is configured to run when the app is started in the config/config.exs file. It runs a simple animation, then transitions to the Sensor scene. It also shows how to intercept basic user input to exit the scene early. Sensor: The Sensor scene depicts a simulated temperature sensor. The sensor is always running and updates its data through the Scenic.SensorPubSub server. Primitives: The Primitives scenes displays an overview of the basic primitive types and some of the styles that can be applied to them. Components: The Components scene shows the basic components that come with Scenic. The crash button will cause a match error that will crash the scene, showing how the supervision tree restarts the scene. It also shows how to receive events from components. Components Nav: The nav bar at the top of the main scenes shows how to navigate between scenes and how to construct a simple component and pass a parameter to it. Note that it references a clock, creating a nested component. The clock is positioned by dynamically querying the width of the ViewPort Notes: The notes section at the bottom of each scene is very simple and also shows passing in custom data from the parent. The simulated temperature sensor doesn't collect any actual data, but does show how you would set up a real sensor and publish data from it into the Scenic.SensorPubSub service.","ref":"getting_started.html#the-starter-app"},{"type":"extras","title":"Getting Started - What to read next?","doc":"Next, you should read about the structure of a scene . This will explain the parts of a scene, how to send and receive messages and how to push the graph to the ViewPort.","ref":"getting_started.html#what-to-read-next"},{"type":"extras","title":"Getting Started with Nerves","doc":"Nerves is a tool chain that builds your application into a minimal boot image that you can use to run on devices such as the Raspberry Pi, BeagleBone Black, and many more. Scenic has everything you need to run on in this environment. In fact, this is the type of system that Scenic was made for! When built with Nerves, the boot-image (this includes Linux, Erlang, Elixir, Scenic, several fonts, etc.) is on the order of 30Mb in size, which is a welcome relief. This guide assumes you have some familiarity with Nerves .","ref":"getting_started_nerves.html"},{"type":"extras","title":"Getting Started with Nerves - Install scenic.new","doc":"The Scenic Archive is the home of the scenic.new mix task, which lays out a starter application for you. This is the easiest way to set up a new Scenic project. Install the Scenic Archive like this mix archive.install hex scenic_new","ref":"getting_started_nerves.html#install-scenic-new"},{"type":"extras","title":"Getting Started with Nerves - Create the Basic Nerves App","doc":"First, navigate the command-line to the directory where you want to create your new Scenic app. Then run the following commands: (change my_app to the name of your app...) mix scenic.new.nerves my_app cd my_app At this point you have a choice. Do you want to build it locally to run on your dev machine (device specific things won't be there or need to be emulated), or do you want to build a boot image","ref":"getting_started_nerves.html#create-the-basic-nerves-app"},{"type":"extras","title":"Getting Started with Nerves - Build and Run on Your Dev Machine","doc":"The first time you build a nerves app, you need to set the MIX_TARGET , which tells it where you intend to run your app. Then you can install the dependencies. Do that on the command line like this: export MIX_TARGET=host mix deps.get Then you can run the app on your dev machine the same way you would a non-nerves app. mix scenic.run","ref":"getting_started_nerves.html#build-and-run-on-your-dev-machine"},{"type":"extras","title":"Getting Started with Nerves - Build and Run on a Raspberry Pi 3","doc":"The first time you build a nerves app, you need to set the MIX_TARGET , which tells it where you intend to run your app. Then you can install the dependencies. When targeting an embedded device, you will also need to create a release file. Do that on the command line like this: export MIX_TARGET=rpi3 mix deps.get mix compile mix nerves.release.init Then you can build the boot image and burn it to your micro-SD card. mix firmware.burn","ref":"getting_started_nerves.html#build-and-run-on-a-raspberry-pi-3"},{"type":"extras","title":"Getting Started with Nerves - Supported Devices","doc":"At the moment, the only supported devices are Raspberry Pis. In fact, the only one I've really tested is the Raspberry Pi 3, although it should work on the others. Support for the BeagleBone is coming, but isn't ready yet.","ref":"getting_started_nerves.html#supported-devices"},{"type":"extras","title":"Getting Started with Nerves - What to read next?","doc":"Next, you should read about the structure of a scene . This will explain the parts of a scene, how to send and receive messages and how to push the graph to the ViewPort.","ref":"getting_started_nerves.html#what-to-read-next"},{"type":"extras","title":"Structure of a Scene","doc":"A Scenic.Scene is a GenServer process which creates and manages a Graph that gets drawn to the screen. Scenes also respond to user input and other events. Scenes can reference each other, creating a logical hierarchy that lives above the Graphs themselves. This allows scenes to be reusable, small, and simple. A properly designed scene should do one job, and do it well. Then it can be reused along with other simple scenes to create a complex screen of UI. Scenes that are specifically meant to be reused are called components. Components have sugar apis that make them very easy to use inside of a parent scene. For example, if you create a dashboard, it may have buttons, text input, sliders, or other input controls in it. Each of those controls is a component scene that is dynamically created when the dashboard scene is started. This collection of scenes forms a graph, which can be quite deep (scenes using scenes using scenes). All these scenes communicate with each other by generating events and passing them as messages. This is explained more below . The life-cycle of scenes (when they start, stop, etc.) is explained in the life-cycle of a scene guide.","ref":"overview_scene.html"},{"type":"extras","title":"Structure of a Scene - The Graph","doc":"The most important state a Scene is responsible for is its Graph. The Graph defines what is to be drawn to the screen, any referenced components, and the overall draw order. When the Scene decides the graph is ready to be drawn to the screen, it pushes it to the ViewPort. In general, a graph is an immutable data structure that you manipulate through transform functions. In the example below Graph.build() creates an empty graph, which is piped into functions that add things to it. The text/3 function accepts a graph, adds some text to it, then applies a list of options to the text. The button/3 is similar to text/3 . It accepts a graph, adds a button and applies a list of options to. Text is a Primitive , which can be drawn directly to the screen. The text/3 helper function is imported from the Scenic.Primitives module. Button is a component whose helper function is imported from the Scenic.Components module. defmodule MyApp.Scene.Example do use Scenic.Scene alias Scenic.Graph import Scenic.Primitives import Scenic.Components @graph Graph . build ( ) |&gt; text ( &quot;Hello World&quot; , font_size : 22 , translate : { 20 , 80 } ) |&gt; button ( &quot;Do Something&quot; , translate : { 20 , 180 } ) def init ( scene , _param , _opts ) do scene = push_graph ( scene , @graph ) { :ok , scene } end ... end If you can, build your graphs at compile time instead of at run time . This both reduces load/power use on the device and surfaces any errors early instead of when the device is in use. In the example above, the graph is built at compile time by assigning it to the module attribute @graph . You can read more about module attributes in Elixir's module attribute documentation . In the above example, the graph is pushed to the ViewPort during the init/2 callback function. There is more detail on how to build and manipulate Graph data in the Graph Overview .","ref":"overview_scene.html#the-graph"},{"type":"extras","title":"Structure of a Scene - Initialization","doc":"The only required callback a Scene must implement is init/3 . This function is called when the scene is started and is where you should initialize your state. Pushing the graph here is optional, but recommended. If you wait too long to build and push your first graph, the user will see a blank space or screen until you are ready. Note that a Scene's state is always a %Scenic.Scene{} struct. Just like Socket in phoenix, it has an :assigns field that is used to store your state def init ( scene , _param , _opts ) do graph = @graph scene = scene |&gt; assign ( graph : graph , my_value : 123 ) |&gt; push_graph ( graph ) { :ok , scene } end The second argument, param , is any term that you pass to your scene when you reference it or otherwise configure it in the ViewPort. Look at an example configuration of a ViewPort from the config.exs file... import Config # Configure the main viewport for the Scenic application config :my_app , :viewport , [ name : :main_viewport , size : { 700 , 600 } , default_scene : { MyApp.Scene.Example , :scene_init_data } , drivers : [ [ module : Scenic.Driver.Local , name : :local , window : [ resizeable : false , title : &quot;Example Application&quot; ] , ] ] ] The line default_scene: {MyApp.Scene.Example, :scene_init_data} configures the ViewPort to always start the scene defined by the MyApp.Scene.Example module and to pass in :scene_init_data as the param argument of its init/3 function. That :scene_init_data term could be any data structure you want. It will be passed to the scene's init/3 function unchanged. The opts parameter is a Keyword list of contextual/optional data that is generated by the ViewPort and passed to your scene. The main options are: option description :id If this scene is a component, then the id that was assigned to its reference in the parent's graph is passed in as the :id option. Typically, controls that generate and send events to its parent scene use this id to identify themselves. If this is the root scene, the id will not be set.","ref":"overview_scene.html#initialization"},{"type":"extras","title":"Structure of a Scene - User Input","doc":"A Scene also responds to messages. The two types of messages Scenic will send to the scene are user input and events. Input is usually comes from the driver, such as mouse clicks and key presses, it can be handled with Scenic.Scene.handle_input/3 . Messages are generally sent from child components (such as a button) and can be handled with Scenic.Scene.handle_event/3 .","ref":"overview_scene.html#user-input"},{"type":"extras","title":"Structure of a Scene - Events","doc":"You are free to send your own messages to scenes just as you would with any other GenServer process. You can use the handle_info/2 , handle_cast/2 and handle_call/3 callbacks as you would normally.","ref":"overview_scene.html#events"},{"type":"extras","title":"Structure of a Scene - Components","doc":"Components are simply scenes with a little extra sugar added to make them easy to use from within another scene. To make a component, call the use Scenic.Component macro instead of the Scene version. You will then need to add info/0 and verify/1 callbacks. The verify/1 accepts the scene_args parameter that will be passed to the init/2 function and verifies that it is correctly formatted. If it is correct, return {:ok, data} . If it is not ok, return :invalid_data . In the event that verify/1 returns :invalid_data , then the info/1 callback is called to get a bitstring describing useful information to the developer. This will be included in the error that gets raised. defmodule MyApp.MyComponent do use Scenic.Component import Scenic.Primitives , only : [ { :text , 3 } , { :update_opts , 2 } ] def verify ( text ) when is_bitstring ( text ) , do : { :ok , text } def verify ( _ ) , do : :invalid_data def init ( scene , text , opts ) do # modify the already built graph graph = Graph . build ( ) |&gt; text ( &quot;&quot; , text_align : :center , translate : { 100 , 200 } , id : :text ) scene = scene |&gt; assign ( graph : graph , my_value : 123 ) |&gt; push_graph ( graph ) { :ok , scene } end ... end Other than verifying the incoming information, Components work the same as any other scene.","ref":"overview_scene.html#components"},{"type":"extras","title":"Structure of a Scene - Adding Components to a Parent Scene","doc":"You can add a component (like the one above) to a scene's graph via the add_to_graph/3 public function that is added to your component via the use Scenic.Component macro. defmodule MyApp.Scene.ExampleScene do @graph Graph . build ( ) |&gt; MyApp.MyComponent . add_to_graph ( :init_data , translate : { 10 , 20 } ) ... end The first time this graph is submitted to the ViewPort via push_graph/1 , that will trigger the life-cycle management of the MyApp.MyComponent scene process. If this is a component you intend to make available to other developers, then you should also create a helper function to make this more compact. Look at the source code for the Scenic.Components module for examples. This entire module is a collection of helper functions whose job is to provide sugary access to the basic components' add_to_graph/3 functions. With helper functions, the above graph would be re-written like this: @graph Graph . build ( ) |&gt; my_component ( :init_data , translate : { 10 , 20 } )","ref":"overview_scene.html#adding-components-to-a-parent-scene"},{"type":"extras","title":"Structure of a Scene - What to read next?","doc":"Next, you should read about the life-cycle of a scene . This will explain how scenes get started, when they stop, and how they relate to each other.","ref":"overview_scene.html#what-to-read-next"},{"type":"extras","title":"Life-cycle of a Scene","doc":"A very important part of Scenic is the Scene life-cycle management. Most scenes' life-cycles will be managed automatically by their ViewPort . The ViewPort determines when to start and stop these dynamic scenes. In effect, when you create a graph and add components like button , checkbox and more, you are doing more than just saying, &quot;Draw a button here&quot;. You are instructing the ViewPort how and when to start and stop the processes that drive those components.","ref":"scene_lifecycle.html"},{"type":"extras","title":"Life-cycle of a Scene - The Root Scene","doc":"This process starts when you set a root scene into the ViewPort. This is first done when you configure your ViewPort in config.exs config :my_app , :viewport , %{ name : :main_viewport , size : { 700 , 600 } , default_scene : { MyApp.Scene.MyFancyScene , :some_init_data } , ... } In the above configuration, when Scenic first starts up, it will start the configured ViewPort. This ViewPort will, in turn, start up the scene defined in the module MyApp.Scene.MyFancyScene and pass in :some_init_data as the first parameter to its init/2 function. Afterwards, you can dynamically change the root scene by calling Scenic.ViewPort.set_root/3 . Both ways of setting the root scene effectively do the same thing.","ref":"scene_lifecycle.html#the-root-scene"},{"type":"extras","title":"Life-cycle of a Scene - Dynamically Supervised Scenes","doc":"As MyApp.Scene.MyFancyScene initializes, it eventually calls its push_graph/1 function. When a scene calls push_graph/1 , the primitives in the graph are sent out for rendering and the components in the graph are started or stopped as needed. To say it another way, when you reference components like button , checkbox and the others, you are programming the supervision tree for your scene. Your scene has an internal DynamicSupervisor , which supervises these dynamic scenes that you asked for in your graph. Each of these can also have a dynamic supervisor and spin up more scenes in a nested tree. At some point, depending on your target processor, you will start to have performance issues if you nest too many components too deeply. The good news is that as you switch away to different root scenes, all the old components are automatically cleaned up for you.","ref":"scene_lifecycle.html#dynamically-supervised-scenes"},{"type":"extras","title":"Life-cycle of a Scene - What to read next?","doc":"If you are exploring Scenic, then you should read the Graph Overview next.","ref":"scene_lifecycle.html#what-to-read-next"},{"type":"extras","title":"Graph Overview","doc":"The most important state a Scene is responsible for is its Graph. The Graph defines what is to be drawn to the screen, any referenced components, and the overall draw order. When a Scene decides the graph is ready to be drawn to the screen, it pushes it to the ViewPort. Graphs are made out of a handful of primitives, each of which knows how to draw one thing. When multiple primitives are put together, almost any standard UI can be drawn. For example, the graph below shows the words &quot;Hello World&quot; around them. @graph Graph . build ( font : :roboto , font_size : 24 ) |&gt; text ( &quot;Hello World&quot; , text_align : :center , translate : { 300 , 300 } ) |&gt; circle ( 100 , stroke : { 2 , :green } , translate : { 300 , 300 } ) In the example above, the first line creates a new graph and assigns two font styles to its root. The next two lines form a pipeline that adds primitives to the root node of the new graph. Each of these primitives also assigns styles.","ref":"overview_graph.html"},{"type":"extras","title":"Graph Overview - Primitives","doc":"There is a fixed set of primitives that Scenic knows how to draw. These form the base set of things that you can do. While they seem simple, when combined you draw pretty much any 2D UI that you need. Read more about the primitives here. In general, each primitive renders one thing to the screen. The Group primitive is sort of like a &lt;div&gt; tag in html in that it creates a new node in the graph hierarchy that more primitives can be organized beneath. Each primitive can also be assigned styles and transforms, which affect how (or whether) they are drawn and where.","ref":"overview_graph.html#primitives"},{"type":"extras","title":"Graph Overview - Styles","doc":"In addition to the fixed set of primitives, there is also a fixed set of primitive styles. (Some components support more styles, but they really get boiled down to the primitive styles when it is time to render) Read more about the styles here. Styles are inherited down the graph hierarchy. This means that if you set a style on the root of a graph, or in a group, then any primitives below that node inherit those styles without needing to explicitly set them on every single primitive. For example, in the following graph, the font and font_size styles are set at the root. Both text primitives inherit those values, although the second one overrides the size with something bigger. @graph Graph . build ( font : :roboto , font_size : 24 ) |&gt; text ( &quot;Hello World&quot; , translate : { 300 , 300 } ) |&gt; text ( &quot;Bigger Hello&quot; , font_size : 40 , translate : { 400 , 300 } )","ref":"overview_graph.html#styles"},{"type":"extras","title":"Graph Overview - Transforms","doc":"The final type of primitive control is transforms. Unlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix transforms. This is common in video games and provides powerful control of your primitives. A matrix is an array of numbers that can be used to change the positions, rotations, scale and more of locations. Don't worry! You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers. You can read about the transform types here. Transforms are inherited down the graph hierarchy. This means that if you place a rotation transform at the root of a graph, then all the primitives will be rotated around a common point. If you want to zoom in, scroll, or rotate a UI, or just pieces of the UI, you can do that very easily by applying transforms. In the example below, the first text line is translated, and the second is scaled bigger, and the whole graph rotated 0.4 radians. @graph Graph . build ( font : :roboto , font_size : 24 , rotate : 0.4 ) |&gt; text ( &quot;Hello World&quot; , translate : { 300 , 300 } ) |&gt; text ( &quot;Bigger Hello&quot; , font_size : 40 , scale : 1.5 )","ref":"overview_graph.html#transforms"},{"type":"extras","title":"Graph Overview - Modifying a graph","doc":"Scenic was written specifically for Erlang/Elixir, which is a functional programming model with immutable data. As such, once you make a graph, it stays in memory unchanged - until you change it via Graph.modify/3 . Technically you never change it (that's the immutable part), instead Graph.modify returns a new graph with different data in it. Graph.modify/3 is the single Graph function that you will use the most. For example, lets go back to our graph with the two text items in it. @graph Graph . build ( font : :roboto , font_size : 24 , rotate : 0.4 ) |&gt; text ( &quot;Hello World&quot; , translate : { 300 , 300 } , id : :small_text ) |&gt; text ( &quot;Bigger Hello&quot; , font_size : 40 , scale : 1.5 , id : :big_text ) This time, we've assigned ids to both of the text primitives. This makes it easy to find and modify that primitive in the graph. graph = @graph |&gt; Graph . modify ( :small_text , &amp; text ( &amp;1 , &quot;Smaller Hello&quot; , font_size : 16 ) ) |&gt; Graph . modify ( :big_text , &amp; text ( &amp;1 , &quot;Bigger Hello&quot; , font_size : 60 ) ) Notice that the graph is modified multiple times in the pipeline.","ref":"overview_graph.html#modifying-a-graph"},{"type":"extras","title":"Graph Overview - What to read next?","doc":"If you are exploring Scenic, then you should read the Primitives Overview next.","ref":"overview_graph.html#what-to-read-next"},{"type":"extras","title":"ViewPort Overview","doc":"Give an overview of a viewport here Coming soon","ref":"overview_viewport.html"},{"type":"extras","title":"Driver Overview","doc":"Drivers live at the bottom of the scenic stack. Drivers know nothing about the scenes you are running. They receive compiled scripts and assets from the viewport and are responsible for rendering them into pretty pictures on the screen. Drivers also receive input from the user and send that into the ViewPort for processing.","ref":"overview_driver.html"},{"type":"extras","title":"Driver Overview - Scenic.Driver.Local","doc":"In Scenic v0.11 the main driver you use to render locally (meaning on a screen attached to the same computer your app is running on) is the :scenic_driver_local . In older versions of Scenic, you used a glfw specific driver to render on a Mac/PC/Linux machine and a separate driver to render on Nerves. These drivers were 95% the same and only really differed in how it initialized the graphics sub systems. This create a situation that was difficult to maintain and difficult to explain. These drivers have been combined into a new driver that covers both scenarios. So you can use :scenic_driver_local on Mac, PC, Linux, and Nerves.","ref":"overview_driver.html#scenic-driver-local"},{"type":"extras","title":"Driver Overview - Configuration of Scenic.Driver.Local","doc":"The configuration options for :scenic_driver_local are similar to, but not the same as, those for the previous drivers. This is because as a unified driver, we can't make certain assumptions. For example, the window title, or whether or not it is resizable has no meaning on an embedded device, but is still used on a PC. Another example is that the actions it should take when the driver closes is different. An embedded device should always do its best to stay running, whereas closing the window on a Mac should probably cause it to stop the app. You will need to make a few config tweaks. There are a few new options that probably make more sense on an embedded device but are very cool... You can now rotate the UI, scale it to fit a screen, center it, etc, just by setting config options. This is an example of a config (which is in turn part of a ViewPort config) that is oriented toward running on a Mac/PC/Linux machine. [ module : Scenic.Driver.Local , window : [ title : &quot;Local Window&quot; , resizeable : true ] , on_close : :stop_system ] This is an example of a embedded style config. [ module : Scenic.Driver.Local , position : [ scaled : true , centered : true , orientation : :normal ] ] , Please see the docs for :scenic_driver_local for the full set of options.","ref":"overview_driver.html#configuration-of-scenic-driver-local"},{"type":"extras","title":"Styles Overview","doc":"Styles are optional modifiers that you can put on any primitive. Each style does a specific thing and some only affect certain primitives. There is a fixed list of primitive styles which are understood by the drivers. Some Components may introduce their own optional styles, but the only ones sent down to the drivers for rendering are contained in the list below. In general, the primitive styles are each defined in their own module, but you apply them as options in a primitive's option list. For example, to use the style defined in the module Scenic.Primitive.Style.Font you would define an option on a text primitive like this: graph = Graph . build |&gt; text ( &quot;Styled Text&quot; , font : :roboto_mono ) |&gt; text ( &quot;Custom Text&quot; , font : &quot;fonts/my_font.ttf&quot; )","ref":"overview_styles.html"},{"type":"extras","title":"Styles Overview - Primitive Styles","doc":"Cap sets how to draw the end of a line. Fill fills in a primitive with a paint style . Font sets the font to use to draw text. FontSize sets the point size text. Hidden a flag that sets if a primitive is drawn at all. Input send cursor related input to your scene when the cursor is over the primitve. Join sets how to render the intersection of two lines. Works on the intersections of other primitives as well. LineHeight adjust the vertical distance between lines of text. Works similar to line height in css. MiterLimit sets whether or not to miter a joint if the intersection of two lines is very sharp. Scissor defines a rectangle that drawing will be clipped to. Stroke defines how to draw the edge of a primitive. Specifies both a width and a paint style . TextAlign sets the horizontal alignment of text relative to the starting point. Examples: :left, :center, or :right TextBase sets the vertical alignment of text relative to the starting point. Examples: :top, :middle, :alphabetic, or :bottom Theme a collection of default colors. Usually passed to components, telling them how to draw in your preferred color scheme.","ref":"overview_styles.html#primitive-styles"},{"type":"extras","title":"Styles Overview - Primitive Paint Styles","doc":"The Fill and Stroke styles accept a paint type. This describes what to fill or stroke the primitive with. There is a fixed set of paint types that the drivers know how to render. Color fills a primitive with a solid color. Image fills a primitive with an image that is loaded into Scenic.Cache . LinearGradient fills a primitive with a linear gradient. RadialGradient fills a primitive with a radial gradient. Stream fills a primitive with a streaming image. Specifying Paint When you use either the Fill and Stroke you specify the paint in a tuple like this. graph = Graph . build |&gt; circle ( 100 , fill : { :color , :green } , stroke : { 2 , { :color , :blue } } ) Each paint type has specific values it expects in order to draw. See the documentation for that paint type for details. Color Paint Specifying a solid color to paint is very common, so has a shortcut. If you simply set a valid color as the paint type, it is assumed that you mean Color . graph = Graph . build |&gt; circle ( 100 , fill : :green , stroke : { 2 , :blue } ) # simple color |&gt; rect ( { 100 , 200 } , fill : { :green , 128 } ) # color with alpha |&gt; rect ( { 100 , 100 } , fill : { 10 , 20 , 30 , 40 } ) # red, green, blue, alpha","ref":"overview_styles.html#primitive-paint-styles"},{"type":"extras","title":"Styles Overview - What to read next?","doc":"If you are exploring Scenic, then you should read the Transforms Overview next.","ref":"overview_styles.html#what-to-read-next"},{"type":"extras","title":"Transforms Overview","doc":"Unlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix transforms. This is common in video games and provides powerful control of your primitives. A matrix is an array of numbers that can be used to change the positions, rotations, scale and more of locations. Don't worry! You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers. Multiple transforms can be applied to any primitive. Transforms combine down the graph to create a very flexible way to manage your scene. There are a fixed set of transform helpers that create matrices for you. Matrix hand specify a matrix. Pin set a pin to rotate or scale around. Most primitives define a sensible default pin. Rotate rotate around the pin. Scale scale larger or smaller. Centered around the pin. Translate move/translate horizontally and vertically. Specifying Transforms You apply transforms to a primitive the same way you specify styles. graph = Graph . build |&gt; circle ( 100 , fill : { :color , :green } , translate : { 200 , 200 } ) |&gt; ellipse ( { 40 , 60 , fill : { :color , :red } , rotate : 0.4 , translate : { 100 , 100 } ) Don't worry about the order you apply transforms to a single object. Scenic will multiply them together in the correct way when it comes time to render them.","ref":"overview_transforms.html"},{"type":"extras","title":"Transforms Overview - What to read next?","doc":"If you are exploring Scenic, then you should read the ViewPort Overview next.","ref":"overview_transforms.html#what-to-read-next"},{"type":"extras","title":"Primitives Overview","doc":"Primitives are the simplest thing that Scenic know how to draw to the screen. Everything that you see in a Scenic application is drawn by combining multiple primitives together to make complex UIs. There is a fixed set of primitives. This simplifies the internals of Scenic, particularly when it comes to communicating to the drivers. New primitives may be added in the future, but those require serious thought and coordination. Arc draws an arc. This would be a line cut out of a part of the edge of a circle. If you want a shape that looks like a piece of pie, then you should use the Sector . Circle draws a circle. Component doesn't draw anything by itself. Instead starts a component (another scene) and tells it where to draw. Ellipse draws an ellipse. Group doesn't draw anything. Instead, it creates a node in the graph that you can insert more primitives into. Any styles or transforms you apply to the Group are inherited by all the primitives below it. Line draws a line. Path is sort of an escape valve for complex shapes not covered by the other primitives. You supply a list of instructions, such as :move_to, :line_to, :bezier_to, etc. to generate a complex shape. Quad draws polygon with four sides. Rectangle draws a rectangle. RoundedRectangle draws a rectangle with the corners rounded by a given radius. Script draws a pre-build script. Sector draws a shape that looks like a piece of pie. If you want to stroke just the curved edge, then combine it with an Arc . Sprites draws one or more sub-images from a single source image. Text draws a string of text. Triangle draws a triangle.","ref":"overview_primitives.html"},{"type":"extras","title":"Primitives Overview - Using Primitives","doc":"The easiest way to insert primitives into your graph is to import the functions in Scenic.Primitives into your scene module. This adds a helper function for each primitive that you can use in a pipeline to build a graph. defmodule MyApp.Scene.Example do use Scenic.Scene alias Scenic.Graph import Scenic.Primitives @graph Graph . build ( font : :roboto , font_size : 22 ) |&gt; text ( &quot;Hello World&quot; , text_align : :center , translate : { 300 , 350 } ) |&gt; circle ( 150 , fill : :green , translate : { 300 , 350 } ) ... end In the example above, the scene calls import Scenic.Primitives , which imports helpers for all the primitives. Since the graph only uses text and circle, you could save a tiny bit of memory by just importing what you need. import Scenic.Primitives , only : [ { :text , 3 } , { :circle , 3 } ] Once the helpers are imported, you call each call appends a primitive to the graph.","ref":"overview_primitives.html#using-primitives"},{"type":"extras","title":"Primitives Overview - Styles","doc":"In addition to the fixed set of primitives, there is also a fixed set of primitive styles. (Some components support more styles, but they really get boiled down to the primitive styles when it is time to render) Read more about the styles here. Styles are inherited down the graph hierarchy. This means that if you set a style on the root of a graph, or in a group, then any primitives below that node inherit those styles without needing to explicitly set them on every single primitive. For example, in the following graph, the font and font_size styles are set at the root. Both text primitives inherit those values, although the second one overrides the size with something bigger. @graph Graph . build ( font : :roboto , font_size : 24 ) |&gt; text ( &quot;Hello World&quot; , translate : { 300 , 300 } ) |&gt; text ( &quot;Bigger Hello&quot; , font_size : 40 , translate : { 400 , 300 } )","ref":"overview_primitives.html#styles"},{"type":"extras","title":"Primitives Overview - Transforms","doc":"The final type of primitive control is transforms. Unlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix based transforms. This is common in video games and provides powerful control of your primitives. A matrix is an array of numbers that can be used to change the positions, rotations, scale and more of locations. Don't worry! You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers. You can read about the transform types here. Transforms are inherited down the graph hierarchy. This means that if you place a rotation transform at the root of a graph, then all the primitives will be rotated around a common point. If you want to zoom in, scroll, or rotate a UI, or just pieces of the UI, you can do that very easily by applying transforms. In the example below, the first text line is translated, and the second is scaled bigger, and the whole graph rotated 0.4 radians. @graph Graph . build ( font : :roboto , font_size : 24 , rotate : 0.4 ) |&gt; text ( &quot;Hello World&quot; , translate : { 300 , 300 } ) |&gt; text ( &quot;Bigger Hello&quot; , font_size : 40 , scale : 1.5 )","ref":"overview_primitives.html#transforms"},{"type":"extras","title":"Primitives Overview - Modifying a Primitive","doc":"Scenic was written specifically for Erlang/Elixir, which is a functional programming model with immutable data. As such, once you make a graph, it stays in memory unchanged - until you change it via Graph.modify/3 . Technically you never change it (that's the immutable part), instead Graph.modify returns a new graph with different data in it. @graph Graph . build ( font : :roboto , font_size : 24 , rotate : 0.4 ) |&gt; text ( &quot;Hello World&quot; , translate : { 300 , 300 } , id : :small_text ) |&gt; text ( &quot;Bigger Hello&quot; , font_size : 40 , scale : 1.5 , id : :big_text ) In the above graph, we've assigned :id values to both primitives. This makes it easy to find and modify that primitive in the graph. Graph.modify/3 is very fast at finding primitives marked with an :id . If you marked multiple primitives withe id: :small_text , then they would all be modified by the call to Graph.modify/3 graph = @graph |&gt; Graph . modify ( :small_text , &amp; text ( &amp;1 , &quot;Smaller Hello&quot; , font_size : 16 ) ) |&gt; Graph . modify ( :big_text , &amp; text ( &amp;1 , &quot;Bigger Hello&quot; , font_size : 60 ) ) Notice that the graph is modified multiple times in the pipeline. The last parameter to Graph.modify/3 is a pointer to a function that receives a primitive and returns the new primitive that should be inserted in its place. The following is the same as one of the calls above, but in expanded form to make it easier to see what is going on graph = Graph . modify ( graph , :small_text , fn ( primitive ) -&gt; text ( primitive , &quot;Smaller Hello&quot; , font_size : 16 ) end )","ref":"overview_primitives.html#modifying-a-primitive"},{"type":"extras","title":"Primitives Overview - What to read next?","doc":"If you are exploring Scenic, then you should read the Styles Overview next.","ref":"overview_primitives.html#what-to-read-next"},{"type":"extras","title":"Assets Overview","doc":"The assets system has been completely overhauled as of Scenic v0.11. Any good-looking UI is a combination of vector drawing via primitives and/or scripts and assets. Assets are the fonts, images, or other types of art that are displayed to the user. These tend to be standard formats, such as a .jpg, .png, or .ttf files. We can split the world of assets into two categories. These are Static and Streaming assets. Static assets, as the name implies, are set up in advance and never change. They are cache-able, both in memory and via servers. Streaming assets, on the other hand, change over time. They are named, but not cache-able.","ref":"overview_assets.html"},{"type":"extras","title":"Assets Overview - Static Assets","doc":"The new static asset pipeline is designed to feel familiar to the Phoenix static asset system. With a bit of configuration, you end up with an &quot;assets&quot; directory in your project directory. The supported files in this directory are &quot;built&quot; during the compilation process and automatically end up as hashed files that can be loaded at run time. The Static Assets Library consists of several parts An asset module that you create in your project. This is where the actual library is stored and built. A source directory that contains the assets you want to use in your project. A config.exs item that links Scenic to you Assets module. Once those pieces are configured, then your assets are built when you compile your application. You can add more assets by simply dropping them into the assets directory. Note, they must be one of the supported types. Example directory structure my_cool_project assets fonts custom_font . ttf another_font . ttf images parrot . jpg Example Assets Module defmodule MyApplication.Assets do use Scenic.Assets.Static , otp_app : :my_application , alias : [ parrot : &quot;images/parrot.jpg&quot; ] end Example config config :scenic , :assets , module : MyApplication.Assets Example use in a Scene Graph . build ( ) |&gt; text ( &quot;Some Text&quot; , font : &quot;fonts/custom_font.ttf&quot; ) |&gt; rect ( { 100 , 200 } , fill : { :image , &quot;images/parrot.jpg&quot; } ) |&gt; rect ( { 100 , 200 } , fill : { :image , :parrot } ) # uses the alias set up in MyApplication.Assets Both of the rectangles in the above example render the same image. One uses a string that gives the local path in your assets folder. The other uses an alias that is configured to point to the same image in the Assets Module. Under the covers Several things happen under the covers when you build your project The use Scenic.Assets.Static part of your Assets module, activates some code that scans your assets directory - looking for assets of known types. It computes a cryptographic hash for asset, parses out metadata, and builds a library of metadata and hashes. That library is stored as a term in Assets module. The contents of the assets file is copied into a new file in your build directory. The name of that file is the bin-hex of the computed hash. If you want to see the contents of your asset library, you can get to it like this: MyApplication.Assets . library ( ) # or Scenic.Assets.Static . library ( ) When you add new assets to your assets directory, you need to kick off this process by touching your assets module. Add a return or a space or something. Eventually, we will have a file watcher that does this for you.","ref":"overview_assets.html#static-assets"},{"type":"extras","title":"Assets Overview - Streaming Assets","doc":"What used to be called the Scenic.Cache.Dynamic , is now Scenic.Assets.Stream and Scenic.Assets.Stream.Texture. This is for images that you generate on the fly (charts, bit rendered game screens, rotating colors, etc...) or frames that you capture live from a camera. The goal is to separate the source of these images from the consumers (the drivers) in a way that is latency/bandwidth friendly and is easy to use. The Scenic.Assets.Stream module is a process/api that manages an :ets table of streaming assets. This allows a camera to capture frames at whatever rate makes sense for it and to put them into the table when it sees fit. This data is then distributed to any listening drivers, who can do the right thing with it. Example camera source - ( from some camera source... tbd by developer... ) def handle_info ( { :camera_0 , texture } , state ) do :ok = Stream . put ( &quot;camera_0&quot; , texture ) end Example use in a Scene Graph . build ( ) |&gt; rect ( { 100 , 200 } , fill : { :stream , &quot;camera_0&quot; } )","ref":"overview_assets.html#streaming-assets"},{"type":"extras","title":"Contributor Code of Conduct","doc":"As contributors and maintainers of this project, and in the interest of fostering an open and welcoming community, we pledge to respect all people who contribute through reporting issues, posting feature requests, updating documentation, submitting pull requests or patches, and other activities. We are committed to making participation in this project a harassment-free experience for everyone, regardless of the level of experience, gender, gender identity and expression, sexual orientation, disability, personal appearance, body size, race, ethnicity, age, religion, or nationality. Examples of unacceptable behavior by participants include: The use of sexualized language or imagery Personal attacks Trolling or insulting/derogatory comments Public or private harassment Publishing other's private information, such as physical or electronic addresses, without explicit permission Other unethical or unprofessional conduct. Project maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct. By adopting this Code of Conduct, project maintainers commit themselves to fairly and consistently applying these principles to every aspect of managing this project. Project maintainers who do not follow or enforce the Code of Conduct may be permanently removed from the project team. This code of conduct applies both within project spaces and in public spaces when an individual is representing the project or its community. Instances of abusive, harassing or otherwise unacceptable behavior may be reported by opening an issue or contacting one or more of the project maintainers. This Code of Conduct is adapted from the Contributor Covenant , version 1.2.0, available at http://contributor-covenant.org/version/1/2/0/","ref":"code_of_conduct.html"},{"type":"extras","title":"Contributing to Scenic","doc":"Please take a moment to review this document in order to make the contribution process easy and effective for everyone involved! Also, make sure you read our Code of Conduct that outlines our commitment towards an open and welcoming environment.","ref":"contributing.html"},{"type":"extras","title":"Contributing to Scenic - Components","doc":"There are many components that could be written and shared with the community. Only a few really core ones should be in the Scenic package itself. If you have ideas for components, I would love the see the community supply optional packages of them for developers to use. Each component package should have the component models themselves, and a &quot;Components&quot; module that contains helper functions to make adding the new components very simple. See the code for Scenic.Components for example helper functions.","ref":"contributing.html#components"},{"type":"extras","title":"Contributing to Scenic - Using the issue tracker","doc":"Use the issues tracker for: Bug Reports Submitting Pull Requests Please do not use the issue tracker for personal support requests nor feature requests. Support requests should be sent to: Still working on this bit... For now, please play around with it. I would gladly accept help documenting it. Over the coming weeks, I'll set up discussion mailing lists and whatever. Simply haven't gotten there yet. We do our best to keep the issue tracker tidy and organized, making it useful for everyone. For example, we classify open issues per perceived difficulty, making it easier for developers to contribute to Scenic .","ref":"contributing.html#using-the-issue-tracker"},{"type":"extras","title":"Contributing to Scenic - Bug reports","doc":"A bug is either a demonstrable problem that is caused by the code in the repository or indicate missing, unclear, or misleading documentation. Good bug reports are extremely helpful - thank you! Guidelines for bug reports: Use the GitHub issue search &amp;mdash; check if the issue has already been reported. Check if the issue has been fixed &amp;mdash; try to reproduce it using the master branch in the repository. Isolate and report the problem &amp;mdash; ideally, create a reduced test case. Please try to be as detailed as possible in your report. Include information about your Operating System, as well as your Erlang, Elixir and Scenic versions. Please provide steps to reproduce the issue as well as the outcome you were expecting! All these details will help developers to fix any potential bugs. Example: Short and descriptive example bug report title A summary of the issue and the environment in which it occurs. If suitable, include the steps required to reproduce the bug. 1. This is the first step 2. This is the second step 3. Further steps, etc. `&lt;url&gt;` - a link to the reduced test case (e.g. a GitHub Gist) Any other information you want to share that is relevant to the issue being reported. This might include the lines of code that you have identified as causing the bug, and potential solutions (and your opinions on their merits).","ref":"contributing.html#bug-reports"},{"type":"extras","title":"Contributing to Scenic - Feature requests","doc":"Feature requests are welcome and should be currently be discussed as an issue in github. This will change to either a topic in Elixir forum or a mail-list soon. Before you make a request however, please take a moment to find out whether your idea fits with the scope and aims of the project. It's up to you to make a strong case to convince the community of the merits of this feature. Please provide as much detail and context as possible.","ref":"contributing.html#feature-requests"},{"type":"extras","title":"Contributing to Scenic - Contributing Documentation","doc":"Code documentation ( @doc , @moduledoc , @typedoc ) has a special convention: the first paragraph is considered to be a short summary. For functions, macros and callbacks say what it will do. For example write, something like: @doc &quot;&quot;&quot; Marks the given value as HTML safe. &quot;&quot;&quot; def safe ( { :safe , value } ) , do : { :safe , value } For modules, protocols and types say what it is. For example, write something like: defmodule MyModule.HTML do @moduledoc &quot;&quot;&quot; Conveniences for working HTML strings and templates. ... &quot;&quot;&quot; Keep in mind that the first paragraph might show up in a summary somewhere, long texts in the first paragraph create very ugly summaries. As a rule of thumb, anything longer than 80 characters is too long. Try to keep unnecessary details out of the first paragraph, it's only there to give a user a quick idea of what the documented &quot;thing&quot; does/is. The rest of the documentation string can contain the details, for example when a value and when nil is returned. If possible include examples, preferably in a form that works with doctests. This makes it easy to test the examples so that they don't go stale and examples are often a great help in explaining what a function does.","ref":"contributing.html#contributing-documentation"},{"type":"extras","title":"Contributing to Scenic - Pull requests","doc":"Good pull requests - patches, improvements, new features - are a fantastic help. They should remain focused in scope and avoid containing unrelated commits. IMPORTANT : By submitting a patch, you agree that your work will be licensed under the license used by the project. If you have any large pull request in mind (e.g. implementing features, refactoring code, etc.), please ask first otherwise you risk spending a lot of time working on something that the project's developers might not want to merge into the project. Please adhere to the coding conventions in the project (indentation, accurate comments, etc.) and don't forget to add your own tests and documentation. When working with git, we recommend the following process in order to craft an excellent pull request: Fork the project, clone your fork, and configure the remotes: # Clone your fork of the repo into the current directory git clone https://github.com/&lt;your-username&gt;/scenic # Navigate to the newly cloned directory cd scenic # Assign the original repo to a remote called &quot;upstream&quot; git remote add upstream https://github.com/ScenicFramework/scenic If you cloned a while ago, get the latest changes from upstream, and update your fork: git checkout master git pull upstream master git push Create a new topic branch (off of master ) to contain your feature, change, or fix. IMPORTANT : Making changes in master is discouraged. You should always keep your local master in sync with upstream master and make your changes in topic branches. git checkout -b &lt;topic-branch-name&gt; Commit your changes in logical chunks. Keep your commit messages organized, with a short description in the first line and more detailed information on the following lines. Feel free to use Git's interactive rebase feature to tidy up your commits before making them public. Make sure all the tests are still passing. mix test Push your topic branch up to your fork: git push origin &lt;topic-branch-name&gt; Open a Pull Request with a clear title and description. If you haven't updated your pull request for a while, you should consider rebasing on master and resolving any conflicts. IMPORTANT : Never ever merge upstream master into your branches. You should always git rebase on master to bring your changes up to date when necessary. git checkout master git pull upstream master git checkout &lt;your-topic-branch&gt; git rebase master Thank you for your contributions!","ref":"contributing.html#pull-requests"},{"type":"extras","title":"Contributing to Scenic - Guides","doc":"These Guides aim to be inclusive. We use &quot;we&quot; and &quot;our&quot; instead of &quot;you&quot; and &quot;your&quot; to foster this sense of inclusion. Ideally, there is something for everybody in each guide, from beginner to expert. This is hard, maybe impossible. When we need to compromise, we do so on behalf of beginning users because expert users have more tools at their disposal to help themselves. The general pattern we use for presenting information is to first introduce a small, discreet topic, then write a small amount of code to demonstrate the concept, then verifies that the code worked. In this way, we build from small, easily digestible concepts into more complex ones. The shorter this cycle is, as long as the information is still clear and complete, the better. For formatting the guides: We use the &quot;elixir&quot; code fence for all module code. We use the &quot;console&quot; code fence for iex and shell commands. We use backticks for filenames and directory paths. We use backticks for module names, function names, and variable names. This contribution guide is adapted from the Phoenix contribution guide .","ref":"contributing.html#guides"}]